;######################################################################
;#
;#    CommMem.pl  Ver1.0 Management or Member library  for WEB SHOP System
;#                (manage.cgi member.cgip Perl library)
;#
;#    Created on: 05/06/15 Modified --/--/--
;#    (C) Copyright 2005 PMCJ by Tomio Sato
;#    http://www.pmcj.com/   info@pmcj.com
;#
;######################################################################

sub DateCheckDisp
{ my ($day, $dc, $plu) = @_;
  $dc = 0 if !$day;
  my @date = $plu ? localtime(time + $day*24*60*60) : localtime(time - $day*24*60*60);
  my $yc; $date[4] += 1; 
  if( $dc % 2 )
  { $date[5] = $date[5] > 100 ? $date[5] + 1900 : $date[5] + 2000; $yc = '%04d'; } else
  { $date[5] = $date[5] - 100 if $date[5] > 100; $yc = '%02d'; }
  if( $dc =~ /^(1|2)$/ )
  { sprintf("$yc%02d%02d", $date[5], $date[4], $date[3]); }
  elsif( $dc =~ /^(3|4)$/ )
  { sprintf("$yc%02d%02d%02d%02d%02d", $date[5], $date[4], $date[3], $date[2], $date[1], $date[0]); }
  else
  { return 0; }
}

sub FileDateCheck
{ my ($file, $hou) = @_;
  my $lim = (stat($file))[9] > time() - $hou*24*60*60 ? 1 : 0;
  if( !$lim && $CGI->{'np'} ){ system("touch $file"); $lim = 1; } $lim;
}

sub PassFileDate
{ my $noP = shift;
  my ($uid, $plim) = $CGI_CODE == 10 
	? ($CGI->{'mid'}, $Pladd) : ($CGI->{'uid'}, $SS->{'MEMB_PASSC'});
  my $pfile = $SS->{'MEMB_DIR'} . &MembUidDir($uid) . '.' . 
		($CGI->{'mid'} eq $SS->{'ADMIN_ID'} ? 'MASADMIN' : $uid) . '_P';
  my $pmsg = $plim && !&FileDateCheck($pfile, $plim)
	? &ShopErrorPri(&MembError(0, $plim), 1 , 14) : undef; 
  my $spece = !$PTB ? '@@ ' : undef;
  my $preg = $spece . ' ύXꍇ [ ' . ($CGI_CODE == 10 ? 'Admin Ǘ' : 'pX[hύX') 
	   . ' ] sĉB .... y #NoRegist# z';
  $$pmsg .= !$PTB ? '<font CLASS=font7 size=1><br><br></font>' . "\n" . 
	'<font CLASS=font13 size=2>' . $preg . '</font>' : $BR . $preg  . $BR if $$pmsg; $pmsg;
}

sub MembUserLockDisp
{	my $id = shift;
	my ($ul_dir, $luser, @list) = ($SS->{'CACHE_DIR'} . 'admin/vmlock/', 0);
	my $uidcheck = $SS->{'MEMB_HEDID'} . '[\d]{6}';

	if( $id =~ /^$uidcheck$/ )
	{ my $ulockfile = $ul_dir . $id;
	  if( $CGI_CODE == 10 )
	  { if( $CGI->{'mlock'} )
	    { &FilePrint(\$ulockfile, undef, 0, 0) if !(-f $ulockfile); } 
	    elsif( $CGI->{'lockdel'} )
	    { unlink($ulockfile) if -f $ulockfile; } 
	  } $luser = 1 if -f $ulockfile; 
	  return $luser, $CGI_CODE == 10 ? \('<input type="checkbox" name="lockdel" value="'
		 . $id . "\"> bN($id)") : undef if $luser; return 0; } 
	elsif( $CGI_CODE == 10 )
	{ my $vc = $DMO =~ /^([A-Z]+)\/([\d]{3})$/ ? $1 . $2 : undef;
	  foreach my $lf (sort @{&FileListOpen(\$ul_dir)})
	  { if( $lf =~ /^$uidcheck$/ && (!$vc || $lf =~ /^$vc/) )
	    { if( $CGI->{'lockdel'} && ($CGI->{'lockdel'} eq $SS->{'MEMB_HEDID'} 
		|| $CGI->{'lockdel'} eq $lf) ){ unlink($ul_dir . $lf); next; }
	      push(@list, "$lf:$lf"); }
	  } 
	  if( $#list >= 0 )
	  { unshift(@list, "$SS->{'MEMB_HEDID'}:S") if $#list > 0;
	    unshift(@list, "0: I");
	    return $#list + 1, \(' ' . ${&ManageSelectFormDisp('lockdel', \@list, $SS->{'MEMB_HEDID'}, 0)} . 
				'<input type="submit" name="disp" value="0.">' . "\n");
	  } return 0;
	}
}

####################################################
############## tH[ bZ[W ֘A ############ 
#################################################### 

sub MembFormDisp
{	my ($action, $memb, $ftype, $from, $name) = @_;
	my ($form, $submit) = (undef, undef);
	my $sc = $from == 6 ? 6 : $from == 7 ? 7 : $from != 3 ? 3 : 5;
	if( $name eq 'mode' )
	{ my $utn = $CGI_CODE == 5 && $SS->{'OS'} == 1 && $CGI->{'mode'} eq 'mfor_3' && $from == 3 ? 1 : 0;
	  ($form, $submit) = &PostFormDisp($action, $sc, 0, 1, 0, $utn); } else
	{ $submit = (&PostFormDisp($action, $sc, 0, 1))[1]; }
	$ftype =~ s/(.+[\d]+)$/$1 . 'k'/eoi if $from != 3;
	$ftype =~ s/([A-Z])$/&FormAlphaCheck($1, $CGI->{'fback'}, 0)/eoi;
	$$form .= "<input type=\"hidden\" name=\"$name\" value=\"$ftype\">\n";
	$$memb = $$form . $$memb . $$submit;
}

sub MembPassRegi
{	my ($lc, $lt, $pos) = @_;
	local($Memadd) = 2;
	my $pass = &LoginFormDisp($lc, $lt, $pos); $pass;
}

sub MembLoginMsg
{	my ($mptc, $msg, $c) = (shift, undef, 0);
	my $lname = $CGI_CODE == 10 ? 'ǗOC' : 'p';
	@LTime = split(/\,/, $CGI->{'LTIME'}) if !$mptc;
	if($#LTime >= 1)
	{ $msg  = "<b>$IMG->{'Maru'} $lname</b> ߋ3Login" . $BR . "\n"
	  							if $CGI->{'disp'} !~ /^3\./;
	  $msg  =  $BR . $msg .$BR if $CGI_CODE == 10;
	  $msg  =~ s/ /$BR/o if $PTB;
	  foreach (@LTime)
	  { $c++;
	    next if !$mptc && $c == 1;
	    if( !$mptc )
	    { $msg .= "@" . "$IMG->{'hist'} ". (split(/\^/, $_))[0] . "<br$clc>\n" if (split(/\^/, $_))[0]; } else
	    { my @ldata = split(/\^/, $_);
	      $msg .= $IMG->{'hist'} . " <b>" . $ldata[0] . "</b>" . $BR . "\n";
	      $msg .= "<b>HOSTF</b>" . ($ldata[1] ? $ldata[1] : 'Unknow') . "\n";
	      $msg .= "<b>ADDRF</b>" . ($ldata[2] ? $ldata[2] : 'Unknow') . $BR . "\n";
	      $msg .= "<b>UserAgentF</b>" . ($ldata[3] ? $ldata[3] : 'Unknow') . $BR . $BR . "\n";  }
	  }
	} $msg =~ s/(\()/$BR\n#space#$1/g if $PTB;
	$msg .= $BR;
	$msg .= ${&MembInforMsg()} if $CGI_CODE != 10; \$msg;
}

sub MembOtoiFormDisp
{	my $data = shift;

	if($Nop < 2 && $CGI->{'send'} && $$Error)
	{ $Nop = 1 if $$data =~ /<ol>/; $Nop = 2 if $$data =~ /<\/ol>/; next if $Nop; }
	if( /#FORM_ACTION\#/ )
	{ $$data = $$Error . ($PTB ? $BR : undef) . $$data if $$Error;
	  $$data =~ s/\#FORM_ACTION\#/<br$clc>$TC->{'li6'}$$form/; } 
	$$data =~ s/\#INPUT\_E\#/$TC->{'ine'}/;
	$$data =~ s/\#UNAME\#/$Name/; $$data =~ s/\#EMAIL\#/$Mail/;
	$$data =~ s/\#FORM\_OTOI\#/$CGI->{'otoi'}/; $$data =~ s/\#FORM\_BOTAN\#/$$Submit/;
	if($CGI->{'subje'} && $$data =~ /(<option[^"]+value="([^"]+)")(.*)/)
	{ $$data = $1 . ' selected="selected"' . $3 if $2 eq $CGI->{'subje'}; }
	elsif($CGI->{'copy'} && $$data =~ /(.*)(\"checkbox\" name=\"copy\" value=\"1\")(.*)/)
	{ $$data = $1 . $2 . ' checked="checked"' . $3; }
	if( $PTB || $CGI->{'vtype'} == 2 )
	{ $$data =~ s/<(\/)?blockquote>//; 
	  $$data =~ s/(.+type="text".+size=)"[\d]+"(.+)/$1"12"$2/;
	  $$data =~ s/cols="[\d]+"/cols="12"/; 
	  $$data =~ s/rows="[\d]+"/rows="2"/; 
	  $$data =~ s/F/<br$TC->{'clc'}>/g; 
	}
}

sub MembTempleFileDisp
{	my $data = shift;
	if( $$data =~ /\#SUB_TITLE\#(.*)/ )
	{ $SUBNAME = $1; $SUBNAME =~ s/(\r)?\n//g;
	  $SUBNAME = !$PTB ? 's ' . $SUBNAME . ' t' : 
		$CGI->{'pname'} . $BR . $BR . "\n" . $SUBNAME; return 1; 
	} $TC->{'li6'} = '================' if $CGI->{'vtype'} == 2;
	$$data =~ s/\#line_6\#/$TC->{'li6'}/;
	$$data =~ s/\#Moji\_([A-Z0-9]+)\#/$IMG->{$1}/ig;
	$$data =~ s/\#(li[\d]+|clc)\#/$TC->{$1}/g;
	return 0;
}

####################################################
################# I[_[֘A ################# 
#################################################### 

sub MembOrderTimeDisp
{	my ($ptc, $otime) = (shift, undef);
	if( $ptc == 2 )
	{ $otime = $SS->{'MEMB_LIMIT'} } else
	{ $otime = $SS->{'POINT_LIMIT'} > $SS->{'ORDER_LIMIT'}
		 ? $SS->{'POINT_LIMIT'} : $SS->{'ORDER_LIMIT'} }
	&DateCheckDisp($otime, 4, 0), &DateCheckDisp($SS->{'POINT_LIMIT'}, 4, 0);
}

sub MembUserPutData
{	my ($uid, $check) = @_;
	my @cad	= (&MembOrderFileCheck($uid))[1 .. 2];
	my ($dat, $dat2) = (undef, undef);
	if( !$check )
	{ my $opt = (&MembOrderRead($uid, 1, undef))[4];
	  my $men = $1 if $cad[1] =~ /\_([\d]+)$/;
	  if( $SS->{'EPSI_SET'} )
	  { $dat = -f $cad[1] ? '(' . $men . 'L)' : 
		   -f $cad[0] ? '' : ''; $dat = 'J[hF' . $dat; }
	  if( $SS->{'POINT_SET'} ){ $dat .= ' |CgF' . $opt . 'pt'; }
	  $dat = '<font CLASS=font13> [ ' . $dat . ' ]</font>' if $dat; } else
	{ my $checked = $SForm->{'form_checked'};
	  $dat = \$checked if -f $cad[0];  $dat2 = \$checked if -f $cad[1]; $dat, $dat2; }
}

sub MembOrderNoGet
{	my ($ofile, $ong, $serc, %OD, @ODA) = (shift, shift, 0, undef);

	if(!open(OFILE,"<$ofile"))
	{ #$ERROR = 'NotOrderFile'; 
	  return \%OD, \@ODA; }
	while (<OFILE>)
	{ s/(\r)?\n//;
	  if(/^($Lmatc)?([\w\-\^\.]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/)
	  { my $key = $2; my $val = $6 || $7 || $8;
	    if( $ong == 1 && $key eq 'order_number' || $ong != 1 )
	    { if( $ong == 2 )
	      { $OD{$key} = $val if $key =~ /^(order_number|shop_date)$/;
	        push(@ODA, "$key=$val"); } else
	      { $OD{$key} = $val; last if $ong == 1; } }
	  }
	} close(OFILE);	\%OD, \@ODA;
}

sub MembOrderRead
{	my ($uid, $ptc, $clean) = @_;
	my ($c, $rec, $opt, %refile, %order) = (0, 0, 0, undef, undef);
	my $oDir = (&MembOrderFileCheck($uid))[0];

	unless( -d $oDir )
	{ #$ERROR = "NotOrderDir $uid"; 
	  return \%order, $c, \%refile, $rec, $opt; }
	foreach (@{&FileListOpen(\$oDir)})
	{ if( /^([\d]{12}[\d]{6})\_([\d]+)(\.([\d]+))?(\-[\d]+\_)?(\-\-)?$/ )
	  { my ($ono, $setc, $pot, $pend, $file) = ($1, $2, $4, $5, $_);
	    if( $CGI_CODE == 10 && $clean && $_ =~ /\-\-$/ )
	    { if( $clean eq 'R' )
	      { unlink($oDir . $_); &ManageSalesDisp($oDir, $_) if $SForm->{'SYS_salstat'}; next; } 
	      elsif( $clean eq 'U' )
	      { my $re = $_; $re =~ s/(.*)\-\-$/$1/o;
	        unlink($oDir . (split(/\,/, $OFCheck{$ono}))[0]);
	        rename($oDir . $_, $oDir . $re); $file = $re; 
	      } } 
	    elsif( !$clean )
	    { my $OD = Sys::FileOpen(\($oDir . $file), 5, 0);
	      if( $ptc == 2 ) 
	      { if( $Olim && $Olim < $OD->{'shop_date'} ){ $pot = 1;last; } }
	      elsif( $Olim && $Olim > $OD->{'shop_date'} ){ unlink($oDir . $_); next; }
	      elsif( $Plim &&  $Plim > $OD->{'shop_date'} )
	      { $pot = 0; $file = $ono . '_' . $setc; rename($oDir . $_, $oDir . $file); }
	    }
	    if( !$ptc || $ptc == 8 )
	    { if( $file =~ /\-\-$/ ){ $rec++; $refile{$ono} = 1 if !$clean; next; }
	      next if $clean eq 'U' && $_ !~ /\-\-$/ && $RFCheck{$ono} 
				|| $ptc == 8 && $setc !~ /^(10|18)$/;
	      my $oNo = (&MembOrderNoGet($oDir . $file))[0];
	      $order{$ono} = $file . ',' . $oNo->{'order_number'};
	    } $opt += $pot if $ptc != 2 && $setc !~ /^(1|3|4|6|7|18)$/ && $file !~ /(\-\-|\_)$/; $c++; 
	  }
	} \%order, $c, \%refile, $rec, $opt;
}

sub UserOrderView
{	my ($url, $manag, $Line) = @_; $DMO = $CGI->{'uid'} if $CGI_CODE != 10;
	my ($order, $c, $refile, $rec, $upt) = &MembOrderRead($DMO, 0, undef);
	my ($olist, $link, $odata)     = (undef, undef, undef); 
	my $disp = $CGI->{'disp'};
	my $idc  = $manag ? 'mid' : 'uid';
	my $ah   = ($CGI_CODE == 10 ? ${&ManageCommHidden($$url, 0, 0)} :
						${&CommHidden($$url, 0, 0)}) . '&mode=';
	if( !$disp || $disp =~ /^[\d]/ )
	{ if( $CGI_CODE == 10 && $disp =~ /\.4$/ )
	  { ($Error, $odata, $Endmsg) = &ManageOrderDispCheck($order, $refile);
	    if( !$$Error )
	    { $olist .= $$Endmsg . $BR . $BR . "\n" if $$Endmsg;
	      return &UserOrderView($url, 1, $Line) if $CGI->{'odis'} = /^N\./;
	      ($order, $c, $refile, $rec, $upt) = @{$odata}; } else
	    { $olist .= $$Error . $BR . $BR . "\n"; } } 
	  elsif( $CGI_CODE != 10 )
	  { ($Uview, $Kview, $D) = ($SS->{'ORDER_LIST'} || 10, $SS->{'ORDER_MOBLIST'} || 5, $CGI->{'p'} || 1); }
	  my ($start, $end, $lc) = &PageViewCheck(!$PTB ? $Uview : $Kview, $D);
	  $link = $ah; #$link =~ s/^<[A-Z0-9\x20\=]+href\=(")?(.*)/$2/io;
	  my $count = ${&MembCountView($start, $end, $c)};
	  $olist .= ' F ' . $count . "$BR\n";
	  return undef, \$olist, $rec if $count eq 'S0';
	  $olist .= 'y L|Cg ' . ${Sys::PriceCheck(\$upt)} . "pt z$BR\n" if $SS->{'POINT_SET'};
	  $olist .= ' ( ڍׂ [  ] NbNĉB )' . "$BR\n";
	  $olist .= (!$PTB ? $Line : $TC->{'li5'}) . "\n";
	  my @ofile = sort { $b cmp $a } keys(%{$order});

	  for ($start .. $end)
	  { my ($data, $oNom) = split(/\,/, $order->{$ofile[$_]});
	    if($data =~ /^([^\_]+)\_([\d]+)(\.([\d]+))?/)
	    { my $onom = $1;
	      my $setc = $2; my $pot = $4;
	      my $OD = Sys::FileOpen(\((&MembOrderFileCheck($DMO))[0] . $data), 5, 0);
	      my $date = $1 . 'N' . $2 . '' . $3 . '' if $OD->{'shop_date'}=~ /([\d]{2})([\d]{2})([\d]{2})/; 
	      my $sett = $setc =~ /^(1|3|4|6|7)$/ ? '[' : $setc == 10 ? '' : $setc == 18 ? 'I' : '[';
	      my $ldis = ($CGI_CODE == 10 ? $CGI->{'mode'} : 'lin_order') . 
			'&disp=ofor_1_' . $ofile[$_] . ($PTB ? '&P=' . $D : undef);
	      $olist .= &PageJavaLink(\($link . $ldis), '', 'Order', '580', '400', 'yes');
	      $olist .= "<input type=\"radio\" name=\"opNo\" value=\"$ofile[$_]\.$pot\">\n" if $CGI_CODE == 10;
	      $olist .= "<b>$date</b>$BR\n";
	      $olist .= "ԍF" . ($oNom ? $oNom : $onom) . "\n";
	      $olist .= $BR if $PTB;
	      $olist .= " ( $sett )\n";
	      $olist .= $BR if $PTB; 
	      if( $SS->{'POINT_SET'} )
	      { $olist .= '|CgF'; $pot = 0 if !$pot;
	        if( $setc =~ /^(1|3|4|6|7)$/ )
		{ $olist .= '0pt'; 
		  $olist .= ' [' . ${Sys::PriceCheck(\$pot)} . "pt" if $CGI_CODE == 10; } else
		{ my $pript = ${Sys::PriceCheck(\$pot)} . 'pt';
		  if( $data =~ /\-([\d]+)\_$/ )
		  { $pript = '<s>' . $pript . '</s> (' . ($CGI_CODE == 10 ? ' ' . $1 : undef) . ' )'; }
		  $olist .= $pript; }
	      }
	      $olist .= "$BR\n" . (!$PTB ? $Line : $TC->{'li5'}) . "\n"; }
	  } my ($page, $pa) = ($CGI_CODE == 10 ? $P . '.' . $L : 0, !$PTB ? 'p' : 'div');
	  $ah .= $CGI->{'mode'};
	  $olist .= ${&ManagePageLink($page, 0, 0, &PageLink($ah . 
				($CGI_CODE == 10 ? '&disp=4.' : undef), $lc, $c - 1, $end, 0))};
	  if( $CGI_CODE != 10 )
	  { $olist .= "<$pa align=right>" . ${&ListPage($ah, $c, $Uview, $Kview, $D, 0, 0)} . "</$pa>\n";
	    $olist .= $BR if $PTB; } } else
	{ #local($oretc) = undef;
	  my ($ofrom, $oNo) = ($1, $2) if $CGI->{'disp'} =~ /for\_([\d]+)\_([\d]+)/i;
	  my $ofile = (split(/\,/, $order->{$oNo}))[0];
	  my $orderfile = (&MembOrderFileCheck($DMO))[0] . $ofile;
	  my ($pot, $OD, $ODA) = (undef, &MembOrderNoGet($orderfile, $CGI->{'odis'} =~ /^(edit|eadd)$/ ? 2 : 0));
	  if($ofile =~ /[\d]+\_([\d]+)(\.([\d]+))?/)
	  { $pmCo = $1; $pot = $3;
	    $SUBNAME = ($PTB ? $CGI->{'pname'} . $BR . $BR . "\n" : undef)  . 
			's ' . $1 . 'N' . $2 . '' . $3 . '' . ' t'
				if $OD->{'shop_date'} =~ /([\d]{2})([\d]{2})([\d]{2})/; 
	  } return \$ERROR if $ERROR;

	  if( !$PTB ){ $olist .= $SUBNAME . $BR . "\n "; }
	  $olist .= "ԍF" . $OD->{'order_number'} . $BR . "\n";
	  if( $CGI_CODE == 10 && $CGI->{'disp'} =~ /^ofor\_1\_[\d]+/ )
	  { $olist = 
	    '<table CLASS=font14><tr><td>' . $olist . '</td>' . "\n" . 
	    '<td valign=bottom>#SUBMIT#</td></tr></table>' . "\n"; 
	    if( $CGI->{'odis'} eq 'edit' )
	    { $olist .= ${(&MembOrderRegForm(1, undef, $ODA))[2]}; } 
	    elsif( $CGI->{'odis'} =~ /^(eadd|U\.|R\.)/ )
	    { ($OD, $rec, $form, $aerr) = &MembOrderRegForm($CGI->{'odis'} eq 'eadd' ? 2 : 
			$CGI->{'odis'} =~ /U\./ ? 3 : 4, \$orderfile, $ODA, $order, $refile);
	      if( $OD->{'ERROR'} )
	      { $olist = $OD->{'ERROR'} . '<br>' . $olist; 
	        if( $aerr ){ $CGI->{'odis'} = 'edit'; $olist .= "$TC->{'li5'}<br>\n" . $$form; } }
	    } my $submit = '<input type="submit" value="' . 
			($CGI->{'odis'} ne 'edit' ? 'ҏW' : 'ύX') . '">' . "\n" if !$rec;
	    $olist =~ s/\#SUBMIT\#/$submit/o;
	    return undef, \$olist, $rec if $CGI->{'odis'} eq 'edit'; 
	  } $olist .= $TC->{'li5'} . "\n";
	  $OD->{'st_code'} = sprintf("%02d", $OD->{'st_code'}) if $OD->{'st_code'} =~ /^\d$/;
	  my ($stc, $con) = ($ES->{($OD->{'st_code'} =~ /^[\d]+$/ ? 'OP_' : 'ST_CODE_') . $OD->{'st_code'}}, 
					$ES->{'CONVI_' . $OD->{'conveni_code'}});

	  $stc =~ s/[\d]+\:(.*)/$1/; $stc =~ s/(.+)(A|B) \((.*)/$1\ ($2\)/; $con =~ s/[\d]+\:(.*)/$1/;
	  $olist .= "[x@]:$stc\n"; $olist .= " ( $con )\n" if $con; $olist .= "<br$clc>\n";
	  if( !$OD->{'conveni_code'} )
	  { my $settdate = $pmCo =~ /^(1|3|4|6|7)$/ ? '[' : $pmCo == 10 ? 'ۋ' : 
		$OD->{'last_update'} ? sprintf("%s\/%s\/%s", split(/-/, $OD->{'last_update'})) : '[';
	    $olist .= '[ϓ]:' . $settdate . "$BR\n"; } else 
	  { if( $OD->{'paid'} && $pmCo != 3 )
	    { $olist .= sprintf("[ϓ]:%s\/%s\/%s$BR\n", 
				split(/-/, $OD->{'conveni_date'})) if $OD->{'conveni_date'}; } else 
	    { $olist .= "[ϓ]:[$BR\n";
	      $olist .= "[tԍ]:$OD->{'receipt_no'}<br$clc>\n" if $OD->{'receipt_no'};
	      $olist .= sprintf("[x]:%s\/%s\/%s$BR\n", 
			split(/-/, $OD->{'conveni_limit'})) if $OD->{'conveni_limit'};
	      $olist .= "[戵\\URL]:<a href=\"$OD->{'haraikomi_url'}\" target=\"_blank\">"
			.  "$OD->{'haraikomi_url'}</a><br$clc>\n" if $OD->{'haraikomi_url'};
	    }
	  } $olist .= "[i]:$OD->{'item_name'}$BR\n";
	  $olist .= "[xz]:" . ${Sys::PriceCheck(\$OD->{'item_price'})} . "~$BR\n";
	  if($PTB){ $olist =~ s/\]\:/\]$BR/g; } else { $olist =~ s/\]\:/\] /g; }
	  if( $pmCo == 18 || $pot )
	  { $olist  .= "$TC->{'li5'}\n";
	    $olist .= ' <font color="#FF0000"><b> ۋI</b></font>' . $BR . "\n" if $pmCo == 18;
	    if( $SS->{'POINT_SET'} && $pot )
	    { $olist .= ' |CgF';
	      if( $pmCo =~ /^(1|3|4|6|7)$/ )
	      { $olist .= '0pt' . ' ( [ ' . ${Sys::PriceCheck(\$pot)} . 'pt )'; } else
	      { $pript = ${Sys::PriceCheck(\$pot)} . 'pt';
		if( $orderfile =~ /\-([\d]+)\_$/ ){ $pript = '<s>' . $pript . '</s> ()'; }
		$olist .= $pript }
	       $olist .= $BR . "\n";
	    }
	  } $olist  .= "$TC->{'li5'}\n";
	  my @ofile = sort { $b cmp $a } keys(%{$order}); 
	  $olist  .= ${&MembFilePageDips(\$ah, $CGI->{'mode'} . 
					'&disp=ofor_1_', \@ofile, $oNo, 0)} . $BR . "\n";
	} undef, \$olist, $rec;
}

####################################################
################  y[W֘A   #################
#################################################### 

sub MembCountView
{	my ($count, $start, $end, $c) = (undef, @_); $c = 0 if $c eq '';
	$count .= "S" . $c . ""; my $enc = $c < $end + 1 ? $c : $end + 1;
	$count .= "(" . ($start + 1) . "-" . $enc . ") " if $c; \$count;
}

sub ManagePageLink
{	my ($pu, $s, $cen, $next, $back) = @_;
	my ($plink, $url) = (undef, undef);
	$$next =~ s/(&p=)([\d]+)/$1$pu\.$2/ if ($pu || $s) && $$next;
	$$back =~ s/(&p=)([\d]+)/$1$pu\.$2/ if ($pu || $s) && $$back;
	$plink = "<center>\n" if $cen && ($$next || $$back);
	$plink .= $$back  if $$back;
	$plink .= ' | '   if $$next && $$back;
	$plink .= $$next  if $$next;
	$plink .= "</center>\n" if $cen && ($$next || $$back); \$plink;
}

sub MembFilePageDips
{	my ($ah, $disp, $fdata, $cfile, $cen) = @_;
	my ($page, $c) = (undef, 0);
	foreach (@{$fdata})
	{ if( $cfile eq $_ )
	  { $next = $fdata->[$c+1] if $fdata->[$c+1];
	    $back = $fdata->[$c-1] if $c && $fdata->[$c-1]; } $c++; }
	$page  .= "&lt;-" . $$ah . $disp .  $back . "\">߂</a>\n" if $back;
	$page  .= " - " if $next && $back;
	$page  .= $$ah . $disp .  $next . "\"></a>-&gt;\n" if $next; 
	$page  = '<center>' . $page . '</center>' if $cen && ($next || $back); \$page;
}

####################################################
################  G[֘A   #################
#################################################### 

sub MembError
{	my ($eNo, $eMsg) = @_;
	my @error_msg = undef;
	$error_msg[0]  = "pX[ho^$eMsgȏo߂Ă܂B<br>@@@" . 
			 "pX[h̕ύX߂܂B";
	\$error_msg[$eNo];
}

1;

