;######################################################################
;#
;#    Imglib.pl  Item Image Check library Ver1.0 for WEB SHOP System
;#
;#    Created on: 05/06/15 Modified --/--/--
;#    (C) Copyright 2005 PMCJ by Tomio Sato
;#    http://www.pmcj.com/   info@pmcj.com
;#
;######################################################################

sub ImgMagLib
{	my $imgmaglib = $SS->{'LIB_DIR'} . 'ImgMaglib.pl';
	if( -f $imgmaglib ){ require $imgmaglib; } else { SysStartError($imgmaglib); }
}

sub ItemImagDisp
{	my ($imgcode, $view) = @_;
	local($newKaku)  = $OS == 2 ? 'png' : 'jpg';
	local($newCheck) = $PTB ? 'm' : $view == 1 ? 'l' : 's';
	my ($img, $def)  = &ItemImgCheck($SS->{'ITE_ROOT'} . $imgcode);
	if( !$img )
	{ $img = &ImgAltPut(\$IMG->{'NoImg'}, '', 0); } else 
	{ my ($ws, $hs) = 
		$view == 1 && $SS->{'LIST_PIC'} ? ($SS->{'LIST_PIC'}, int($SS->{'LIST_PIC'} * 0.75)) :
		$view != 1 && $SS->{'PIUP_PIC'} ? ($SS->{'PIUP_PIC'}, int($SS->{'PIUP_PIC'} * 0.75)) : 80, 60 if $def;
	  my ($w, $h) = $def ? (" width=\"$ws\"", " height=\"$hs\"") : (undef, undef);
	  my $imgurl = $SS->{'ITE_IMG'};
	  $imgurl =~ s/^https\:\/\//http:\/\//o if $CGI_CODE == 10;
	  $img =~ s/^$SS->{'ITE_ROOT'}(.*)/$imgurl$1/o;
	  $img = "<img src=\"$img\"$w$h>";  
	} return $img;
}

sub ItemImgCheck
{	my $img = shift;
	my ($defImg, $ok) = (undef, 0);
	my $img2 = $img . '_' . $newCheck . '.' . $newKaku;

	if( !(-f $img2) )
	{ foreach ('jpg', 'gif', 'png')
	  { $defImg = $img . "\." . $_; if(-f $defImg){ $ok = 1; last; } }
	  if( $ok )
	  { if( $SS->{'IMAGE_MAGICK'} == 2 )
	    { &ImageMagick(0, $defImg, $img2); return ($img2, 0); } else 
	    { return ($defImg, 1); } } else
	  { return (0, 0); } } else 
	{ return ($img2, 0); } 
}

1;

