package Sys;
;#**************************************************************************
;#
;#    Sys.pl Commonness Seting Ver1.0 for WEB SHOP System
;#
;#    Created on: 05/06/01 Modified --/--/--
;#    (C) Copyright 2005 PMCJ by Tomio Sato
;#    http://www.pmcj.com/   info@pmcj.com
;#
;#**************************************************************************

;############################################
;# SYSTEM ROOT SET CONFt@C
$ROOTCONF = '/home/xxxx/wsdata/etc/conf/root.conf';
;############################################

sub SsData{ $SS; }
sub SysSeting
{ ($CGI_CODE, $DIS_CODE, @Rchen) = @_;

  $MANAG_HEDID = 'MAS'; 
  $Dmatc = '\'([^\']*)\'|\"([^\"]*)\"|([\x21-\x22\x24-\xFF]*)';
  $Lmatc = '[\x20\t]+';
  $Mmatc = '[\w\.\-\+\/]+\@[\w\-]+\.[\w\.\-]+';
  $SS = &RootRead($ROOTCONF); &AccessCheck();
  $SS->{'VERSION'} = '2.02';
  $SS->{'ErrFile'} = $SS->{'LOG_DIR'} . 'ErrorLog';

  my ($lib, $ld) = (undef, \$SS->{'LIB_DIR'});

;# Open2 W[
  use IPC::Open2;
;# {R[h}`ϊCu[
  SysStartError($lib) if !(-f ($lib = $$ld . 'JMClib.pl')); require $lib;
  srand (time|$$);

;# WEB SHOP SYSTEM ʃTu[` 
  SysStartError($lib) if !(-f ($lib = $$ld . 'CommDisp.pl')); require $lib;

;# WEB SHOP SYSTEM ֘ATu[` 
  if( $CGI_CODE == 1 || $CGI_CODE == 10 )
  { SysStartError($lib) if !(-f ($lib = $$ld . 'Imglib.pl')); require $lib;
    if( $CGI_CODE == 10 )
    { SysStartError($lib) if !(-f ($lib = $$ld . 'Managlib.pl')); require $lib;
      &ManageSysData(); } }
  if( $CGI_CODE == 1 || $DIS_CODE == 33)
  { SysStartError($lib) if !(-f ($lib = $$ld . 'Syslib.pl')); require $lib; } 
  if( $CGI_CODE >= 4 )
  { if( $CGI_CODE == 4 )
    { SysStartError($lib) if !(-f ($lib = $$ld . 'Epsip.pl')); require $lib; 
      SysStartError($lib) if !(-f ($lib = $$ld . 'Epslib.pl')); require $lib; } 
    elsif( $CGI_CODE >= 5 )
    { SysStartError($lib) if !(-f ($lib = $$ld . 'CommMem.pl')); require $lib; }
    if( $CGI_CODE < 10 )
    { SysStartError($lib) if !(-f ($lib = $$ld . 'Memblib.pl')); require $lib; }
  }
}

sub RootRead
{	my ($file, $auto, $root, $droot, $shop, %SS) = (shift, 0, undef, undef, undef, undef);

	if(!open(RFILE, "<$file"))
	{ &SysStartError("root.conf"); } else 
	{ while (<RFILE>)
	  { if(/^($Lmatc)?([A-Z\_]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/)
	    { my $key = $2; my $val = $6 || $7 || $8; 
	      if( $key ne '' )
	      { if( $key eq 'SSL_ENV_CHECK' && $val )
		{ $SSL = $val =~ /^\d/ && $ENV{'SERVER_PORT'} eq $val ? $val : $ENV{$val}; }
		elsif( $key eq 'SHOPDIR_NAME' ){ $shop = $val;  }
		elsif( $key eq 'LB_AUTO' && $val )
	        { $auto = 1; $root = $ENV{'SCRIPT_FILENAME'}; $root =~ s/(.*\/$shop\/)(.*)/$1/; }
		elsif( ($key eq 'DATA_ROOT' || $SSL && $key eq 'DATA_ROOT_SSL') && $val )
		{ $droot = $val; }
		elsif( $key =~ /\_DIR$/ && $val !~ /^(\/|[A-Z]\:)/ )
		{ $val .= '/' if $key =~ /\_DIR$/ && $val !~ /\/$/;
	          $val = $droot && $key !~ /^(IMG|PC|PTB)\_/ ? ($droot . $val) : $auto ? ($root . $val) : 
		    $SSL && $SS{'ROOT_SSL'} ? ($SS{'ROOT_SSL'} . $val) : ($SS{'ROOT'} . $val); }
	        $SS{$key} = $val; } } } close(RFILE); 
	  &SysStartError("Not lib dir") unless -d $SS{'LIB_DIR'}; 
	}
	$SS{'SYSENGINE'} = $SS{'BIN_DIR'}  . $SS{'SYS_ENGINE'};
	$SS{'KEYENGINE'} = $SS{'BIN_DIR'} . $SS{'KEY_ENGINE'}; # if $CGI_CODE == 10;
	$SS{'SYSCONF'}   = $SS{'CONF_DIR'} . $SS{'SYS_CONF'};
	\%SS;
}

sub EnginePastCheck
{	my $lib = undef;
	if( -f ($lib = $SS->{'LIB_DIR'} . 'pchecklib.pl') )
	{ require $lib; Prk::EngineProcessCheck($SS); }
}

sub ModuleCheck
{	my $check = shift;

	return 1 if $SS->{'IMAGE_MAGICK'} == 2;

	my $modulefile = $SS->{'LOCK_DIR'} . 'moduleOn';
	my $ok = undef;
	if( -f $modulefile && ( $check == 1 
		|| $check == 2 && (stat($modulefile))[9] > time() - 60*60*24) )
	{ my $image = &FileOpen(\$modulefile, 1, 0);
	  $ok = 1 if $$image =~ /ImageMagick/; return $ok; }
	if( $check == 2 )
	{ foreach my $dir (@INC)
	  { foreach (@{&FileListOpen(\$dir)})
	    { my $file = $dir . '/' . $_ . '/Magick.pm';
	      if(-f $file){ $ok = 'ImageMagick'; last; } } }
	  &FilePrint(\$modulefile, \$ok, 0) if $ok; return $ok; }
}

sub ImgUrlCheck
{	my @imgpri = @_;
	my $check = $imgpri[0] ne 'href' ? 1 : $imgpri[0] eq 'href' && $imgpri[2] ? 2 : 0;
	if( $check )
	{ if( $imgpri[1] =~ /^.\// ){ $imgpri[1] =~ s/^.\//$htmroot/o; }
	  elsif( $imgpri[1] !~ /^http/ && $imgpri[1] =~ /^([\w]+)/ ){ $imgpri[1] = $htmroot . $1; } 
	  $imgpri[0] = $imgpri[2] . $imgpri[0] if $check == 2;
	} $url = $imgpri[0] . '="' . $imgpri[1] . '"'; $url;
}

sub AccessCheck
{	my ($HTTP, $DOMAIN, $CGIFILE); 

	if( $ENV{'HTTP_HOST'} !~ /^$SS->{'DOMAIN'}(\:[\d]+)?/ || $ENV{'REQUEST_URI'} =~ /.cgi\// )
	{ if( $SSL )
	  { $HTTP = 'https'; $DOMAIN = $SS->{'SSL_DOMAIN'} ? $SS->{'SSL_DOMAIN'} : $SS->{'DOMAIN'}; } else
	  { $HTTP = 'http';  $DOMAIN = $SS->{'DOMAIN'}; }

	  $CGIF = $DIS_CODE ==  1 ? $SS->{'SHOP_CGI'} : $DIS_CODE ==  2 ? $SS->{'CAGO_CGI'} :
	 	  $DIS_CODE ==  3 ? $SS->{'ORDE_CGI'} : $DIS_CODE == 10 ? $SS->{'MEMB_CGI'} :
		  $DIS_CODE == 11 ? $SS->{'SETT_CGI'} : undef;
	  local($URL) = $HTTP . "://". $DOMAIN . $CGIF; &HttpEquiv(0, $URL);
	} $SS->{'IMG_URL'} = $SS->{'IMG_URL_SSL'} if $SSL && $SS->{'IMG_URL_SSL'}; return 0;
}

sub DmainSslCheng
{	my ($urlDate, $cgi) = @_;
	my @cgiType = ('', 'SHOP', 'CAGO', 'ORDER', 'MEMB', 'EPSI');
	my $cgiKey = $cgiType[$cgi] . '_CGI'; 
	my $cmatc = $SS->{$cgiKey}; $cmatc = JMClib::MatchHex($cmatc); 
	my $dmatc = $SS->{'DOMAIN'}; $dmatc = JMClib::MatchHex($dmatc);
	$$urlDate =~ s/(http)(:\/\/)($dmatc)($cmatc)/
	  $1 . 's' . $2 . ($SS->{'SSL_DOMAIN'} ? $SS->{'SSL_DOMAIN'} : $3)
	     . ($SS->{'SSL_DOMAIN'} && $SS->{'SSL_' . $cgiKey} ? $SS->{'SSL_' . $cgiKey} : $4)/e;
}

sub ManageShopFilePrint
{	my ($root, $file) = @_;
	my ($buf, $c) = (undef, 0);
	my $rtemp = ($root eq 'iView' ? $SS->{'IMG_DIR'} . 'item/' : 
			$root ? $root : $SS->{'CACHE_DIR'} . 'admin/itemtmp/') . $file; 
				$file =~ s/\.tmp$//o; $file =~ s/(.*)\/([^\/]+)$/$2/;
	my $imgkaku = 'jpg|jpe|jpeg|gif|png|tar.gz'; 
	my $gsize = -s $rtemp;
	my $content = JMClib::Content($file =~ /\.(js|css)$/ ? "txt" : $file); 
	local($htmroot) = '../html/';
	print $content . "\n";
	print "Content-disposition: inline; filename=\"$file\"\n\n";

	if( !open(IF,"<$rtemp") )
	{ print "Content-Type: text/plain\n\n404 Not Found\n$rtemp\n$file"; } else
	{ binmode(IF) if $file =~ /$imgkaku$/;
	  while (<IF>)
	  { if( $file =~ /\.($imgkaku)$/ )
	    { binmode(STDOUT); } else
	    { if( !$c && /^<table/ )
	      { print "<head><title>Open View</title>\n" . ${&HeadSet()} . "</head>\n"; }
	      elsif( $file =~ /\.(js|css)$/ ){ print "<pre>\n"; }
	      s/(rel=(")?stylesheet(")? )?(href|background|src)\=(")?([^\"\x20]+)(")?/&ImgUrlCheck($4, $6, $1)/ge;
	      s/#IMG_([A-Z0-9\/]+)#/&ItemImagDisp($1, $Itemout)/ie; $c++; }
	    print $_;
	  } close(IF);
	}
exit;

}

sub HttpEquiv
{	my ($lc, $url) = @_;
	my ($time, $lname) = (0, !$PTB ? 'here' : 
				$url =~ /mode\=cglook\_/ ? '' : 'ENTER');
	my $msg  = ($PTB ? 'LANZXĉB<br><br>' : 
			($url =~ /mode\=cglook\_/ ? 'ɃANZXłB' : 
				$lc ? 'ANZXłB' : 'ANZX܂B')  . 
					' Leading......') . " <a href=\"$url\">$lname</a>";

	print "Content-type: text/html; charset=Shift_JIS\n\n";
	print '<html><head>' . "\n";
	if( !$PTB ){
	print <<"CANCELL";
<META NAME="ROBOTS" CONTENT="NOINDEX">  
<META HTTP-EQUIV="Content-Type" content="text/html; charset=Shift_JIS">
<META HTTP-EQUIV="Refresh" CONTENT="$time;URL=$url">
CANCELL
	}
	print <<"CANCELL";
<title>Shoping System</title>
</head>
<body bgolor="#FFFFFF">
CANCELL
	if( !$PTB )
	{ print '<p align=center><BR><BR><BR>';
	  print "<font style=\"font-size:14px;font-family:'lr oSVbN', 'Osaka'\">";
	  print $msg . '</p></font>'; } else
	{ print '<BR>' . $msg; }
	print '</body></html>' . "\n";

exit;

}

sub LocationPrint
{	my ($lc, $location) = @_;
	if( $lc )
	{ print "Content-Type: text/html\n";
	  print "Location: $location\n\n"; } else
	{ &HttpEquiv(1, $location); }
exit;

}

sub SysStartError
{	my $file = shift;
	print "Content-Type: text/plain\n\n";
	print "WEB SHOP System setting error ( $file )\n\n"; 
exit;

}


1;
