;######################################################################
;#
;#    Syslib.pl  System library Ver1.01 for WEB SHOP System
;#
;#    Created on: 05/06/15 Modified 05/07/10
;#   (C) Copyright 2005 PMCJ by Tomio Sato
;#    http://www.pmcj.com/   info@pmcj.com
;#
;######################################################################

sub ItemList
{ foreach ($LISTTOP, $LISTEND)
  { if( /\#SHOP_SEARCH([^#]+)?\#/ )
    { s/\#SHOP\_SEARCH(\_SSL)?(.([^#]+))?\#/${&SearcPrint($1, $3)}/e; }
  } \$ITEMLIST, \$LISTTOP, \$LISTEND, 
	($CGI->{'p'} || 1), split(/\,/, $CGI->{'ITEM_COUNT'});
}

sub FormData
{ $FORM =~ s/(<br>(\n)?)+$//o if $PTB; \$FORM;
}

;######################################################################
;# JeS[֘A
;######################################################################

sub CategoryCheck
{	my ($cc, $top, $catepri, $titname, $Error) = (0, 1, undef, undef, undef);
	local($folder, $line) = ($IMG->{'Folder'}, $IMG->{'Fline'});
	local($Folder1, $Folder2) = (undef, undef);
	$Folder1 = $Folder2 = $folder;
	if( !$PTB )
	{ $Folder1 =~ s/(<.*)(\.[a-z]+".*)/$1 . '1' . $2/e;
	  $Folder2 =~ s/(<.*)(\.[a-z]+".*)/$1 . '2' . $2/e;
	}
	$CGI->{'cate'} =~ s/^\_//;
	$CGI->{'cate'} = 'top' if $CGI->{'ITEM_COUNT'} =~ /^check([\d])?$/i;
	if($CGI->{'cate'} =~ /^(rank\.(.*)|picup([\d])?)$/)
	{ my $catekey = $1 if $CGI->{'cate'} =~ /([^\.]+)(\.)?/;
	  $catepri = \$CD->{$catekey}; $titname = $CD->{$catekey};
	  $$catepri = '<b>' . $$catepri . '</b>' if !$PTB; 
	  &CateTopPri($catepri); $cc = 3; 
	}
	my $categ = $cc != 3 && ($CGI->{'cate'} || $CGI->{'sercate'});
	return $cc, $catepri, \$URL->{'SHOP_URL'}, \$titname if !$categ && !$CGI->{'skey'};

	my $categDir = $categ; $categDir =~ s/\_/\//g;
	undef $categDir if $categDir =~ /^top$/i;
	my $cateRoot = $SS->{'ITEM_DIR'} . $categDir;
	my $itemfile = $cateRoot . '/' . $SS->{'ITEM_FILEKAKU'} if $categDir;

	#//// 1:CateTop 2:CateSubList 3:CateItemView 10:ItemView  /////#
	$cc = !$CGI->{'skey'} && !$categDir && -d $cateRoot ? 1 : 
	  $CGI->{'ITEM_COUNT'} eq 'CATE_DIR' ?  2 : 
	  $CGI->{'ITEM_COUNT'} =~ /^EXPAL\,/ ? 10 : -d $cateRoot ? 3 : 0;
	$titname = (split(/\,/, $CGI->{'ITEM_COUNT'}))[1] if $cc == 10;

	$SS->{'HeadFile'} = $cc > 2 ? $SS->{'HeadFile'} : $SS->{'HeadFile2'};
	undef $SS->{'HeadFile2'};
	if( $ERROR ) 
	{ if( $ENO != 20 )
	  { &Print(&ShopErrorPri(\$ERROR, 0, 14)); } else 
	  { $Error = ${&ShopErrorPri(\$ERROR, 1, 14)} . $BR . $BR;
	    $cc = 1; $CGI->{'cate'} = 'top'; }
	}
	if( $categ && $cc )
	{ if( $cc != 1 )
	  { while (my ($key, $val) = each %{$CD})
	    { if( $key eq $categ )
	      { $titname = $CD->{$key} if !$titname;
		$catepri = CategoryPrintData($cc, \$categ); $top = 0; last; } }
	  } $$catepri = ($Error ? $Error : undef) . ${CategoryPrintData($top, undef)} if $top;
	}
	if( $CGI->{'skey'} )
	{ my $search = undef; $CGI->{'skey'} =~ s/\x81\x40/\x20/g;
	  foreach (split(/ /, $CGI->{'skey'})){ $search .= $_ . ' ' if length($_) > 1; } 
	  if( $cc == 3 && $search )
	  { $$catepri .= $categ ? $BR : $BR . &CateTopPri(undef, 0);
	    $$catepri .= 'y ' . $search . ' z ̌'; }
	} undef $CGI->{'cate'} if $CGI->{'cate'} =~ /^top$/i;
	$cc, $catepri, \$URL->{'SHOP_URL'}, \$titname;
}

sub CategoryPrintData
{	my ($cc, $categ) = @_;
	my ($catecode, $catepri) = (undef, undef);
	my $file = $SS->{'LOCK_DIR'} . 'categoOn';
	local($CCO) = &FileOpen(\$file, 2, 0);

	if( $cc == 1 || $cc == 2 )
	{ $CATE_TYPE = 1;
	  local($Allcount) = 0;
	  my $ccheck = '_';
	  local($hier) = 0;
	  local(@catec) = split(/\_/, $$categ);
	  my $colsapn = $cc == 1 ? 2 : $#catec + 3;
	  if( !$PTB )
	  { $catepri  = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" CLASS=font13>\n";
	    $catepri .= "<tr><td nowrap colspan=\"" . ($colsapn + 1) 
				. "\">[ ACe:". $CCO->{'ALL_COUNT'} . " ]</td></tr>\n";
	    foreach (sort { $a cmp $b } keys(%{$CD}))
	    { local(@subca) = split(/\_/, $_); local($hiec) = $#subca;
	      next if &HierarchyCheck($_, $categ);
	      $colc = $colsapn - ($hiec + 1);
	      my ($fp, $al, $bo) = $cc == 1 || $$categ ne $_ ? ($Folder1, 1, 0) : ($Folder2, 0, 1);
	      my $cp = $bo ? '<b>' . $CD->{$_} . '</b>' : 
			     $URL->{'SHOP_URL'} . $ccheck . $_ . '">' . $CD->{$_} . '</a>';
	      my ($count, $linep) = &TiemCount(\$_, $line, $categ);
	         $cp .= ' (' . $count . ')';
	      $catepri .= "<tr>";
	      for($i = 0; $i <= $hiec; $i++)
	      { $hiMark = ($hier <= $hiec || $hier > $hiec) && $i >= $hiec ? $linep : '@';
		$catepri .= "<td width=\"26\" align=\"right\">$hiMark</td>"; }
	      $catepri .= "<td width=\"26\">$fp</td><td colspan=\"$colc\" nowrap>$cp</td></tr>\n"; 
	      $hier = $hiec;
	    } $catepri .= "</table>\n"; }
	  else
	  { my ($hed, $hc, $co) = (undef, 0, 0);
	    my ($start, $end, $p) = PageViewCheck($SS->{'MOBAIL_CATEVIEW'}, $CGI->{'p'});
	    foreach (sort { $a cmp $b } keys(%{$CD}))
	    { local(@subca) = split(/\_/, $_); local($hiec) = $#subca;
	      next if &HierarchyCheck($_, $categ);
	      my ($fp, $al, $bo) = $cc == 1 || $$categ ne $_ ? ($Folder1, 1, 0) : ($Folder2, 0, 1);
	      my $cp = $$categ ne $_ ? $URL->{'SHOP_URL'} . $ccheck . $_ . '">' . $CD->{$_} . '</a>' : $CD->{$_};
	      if( $cc != 1 && !$hc)
	      { $hed .= $cp . '-&gt;'; $hc = 1 if $$categ eq $_; next; }
	      my ($count, $linep) = &TiemCount(\$_, $line, $categ);
	      $cp .= ' (' . $count . ')';
	      if( $co >= $start &&  $co <= $end )
	      { $catepri .= "<font color=\"$SS->{'MOBAIL_COLOR'}\"></font>" . $cp . $BR . "\n"; } 
	      $hier = $hiec; $co++;
	    }
	    $catepri .= $BR . "\n"; 
	    $hed =~ s/\-\&gt\;$//o; 
	    $hed = !$hed ? "ё:". $CCO->{'ALL_COUNT'} : &CateTopPri(undef, 2) . '-&gt;' . $hed;
	    $catepri = "<font color=\"$SS->{'MOBAIL_COLOR'}\">"
		       . $IMG->{'Shik'} . "[" . $hed . "]</font>$BR\n" . $catepri;
	    my $cp = $CGI->{'cate'}; $cp = '_' . $cp if $cp ne 'top';
	    my ($next, $back) = Sys::PageLink(($URL->{'SHOP_URL'} . $cp), $p, $co - 1, $end, 1);
	    if( $$next || $$back )
	    { $catepri .= '<center><font color="' . $SS->{'MOBAIL_COLOR'}. '">' . $TC->{'li9'} . '</font>';
	      $catepri .= $$back if $$back; $catepri .= '|' if $$next && $$back;
	      $catepri .= $$next if $$next;  $catepri .= '</center>' . $BR . "\n";

	    } $catepri .= '- - - - -' . $BR . &CateTopPri(undef, 3) . $BR; } } else
	{ my $c = 0;
	  foreach (split(/\_/, $$categ))
	  { if( $c ){ $catecode .= '_'; $catepri .= !$PTB ? ' -&gt; ' : '-&gt;'; } 
	    $catecode .= $_; 
	    my $cateval = $CD->{$catecode}; 
	    if($catecode eq $$categ)
	    { $cateval = '<b>' . $cateval . '</b>'; } else
	    { $cateval = $URL->{'SHOP_URL'} . ($SS->{'CATE_VIEW'} ? '_' : undef) . $catecode . '">' . $cateval . '</a>' }
	    $catepri .= $cateval; $c++; } $catepri =~ s/\-\&gt$//;
	    &CateTopPri(\$catepri);
	} \$catepri;
}

sub CateTopPri
{	my ($catepri, $camob) = @_;
	if( !$PTB )
	{ my $catetop = '<a class=lb href="' . $URL->{'SHOP_CTOP'} . '">' . 'JeSgbv</a> -&gt; ';
	  $$catepri = '<table border="0" cellpadding="0" cellspacing="0" CLASS=font13><tr><td>' 
		. $Folder1 . '</td><td>' . $catetop . $$catepri; } else 
	{ my $catetop = ($camob != 2 ? $IMG->{'Back2'} : undef) . '<a href="' . $URL->{'SHOP_CTOP'} . '">' . 'úį</a>';
	  return $catetop if $camob > 1; 
	  if( !$camob )
	  { $LISTEND .= $TC->{'li2'} . $catetop . $BR; 
	    $$catepri = $catetop . $BR . '-&gt;' . $$catepri; } else
	  { $$catepri = $TC->{'li2'} . $catetop . $BR; }
	} $$catepri .= '</td></tr></table>' if !$PTB; $$catepri;
}

sub TiemCount
{	my ($k, $line, $categ) = @_;
	my ($c, $count, $l) = (0, 0, 0);
	while (my ($key, $val) = each %{$CD})
	{ if($key =~ /^$$k\_/){ $count += $CCO->{$key}; $c++; } }
	$l = $c && $$categ =~ /^$$k/ ? 2 : $c ? 1 : 0; 
	$count = $CCO->{$$k} if !$c && $CCO->{$$k}; 
	$line=~ s/(<.*)(\.[a-z]+".*)/$1 . $l . $2/e if $l; $count, $line;
}

sub HierarchyCheck
{	my ($del, $i, $cadat, $categ) = (0, 0, @_);
	return 1 if $cadat =~ /^(picup|rank)/;
	if( $$categ && $PTB )
	{ my $vc = $$categ; $vc =~ s/^([A-Z0-9]+)\_.*/$1/;
	  $del = 1 if $cadat ne $vc && $cadat !~ /^$vc\_/ || 
				$cadat ne $$categ && $#catec == $hiec; }
	$cadat =~ s/\_/\//g;
	return 1 unless -d $SS->{'ITEM_DIR'} . $cadat;
	foreach (@subca){ last if $catec[$i] !~ /$_/; $i++; }
	$del = 1 if $i < $hiec || $del && $i <= $hiec;
	$hier = $hiec if $del; return $del;
}

;######################################################################
;# Vbvy[Wvg֘A
;######################################################################

sub PicUpRand
{	my ($key, $iCode) = @_;
	my ($file, @pupdat, @puprand) = undef;
	my $pCo = $key; $pCo =~ s/^PICUP([\d+])/$1/;
	my $pupdir = $SS->{'PIUP_DIR'} . 'picup' . $pCo . '/';

	if( !$iCode )
	{ if( !$PUC{$key} )
	  { foreach (@{&FileListOpen(\$pupdir)})
	    {  push(@pupdat, $_) if !$CGI->{'cate'} && $_ =~ /.dat$/
				  || $CGI->{'cate'} && $_ =~ /^$CGI->{'cate'}/; 
	    } while (@pupdat){ push(@puprand, splice(@pupdat, rand @pupdat, 1)); }
	    $PUP{$key} =  \@puprand;
	  } $c = !$PUC{$key} ? 0 : $PUC{$key};
	  $file = ${$PUP{$key}}[$c]; $PUC{$key} = $c + 1; } else
	{ $file = $iCode . '.dat'; }
	my $pupfile = $pupdir . $file;
	unless( -f $pupfile )
	{ $file = '<br><img src="' . $SS->{'SHO_IMG'} . 'snotpicup.gif">' if !$c; 
	  return $file; }
	my $puphtml = &FileOpen(\$pupfile, 1, 1);
	   $$puphtml =~ s/(src=(")?http)\:/$1s\:/g 
				if $CGI_CODE == 1 && $SSL && $SS->{'IMG_URL_SSL'};
	   $$puphtml =~ s/#IMG_([A-Z0-9\/]+)#/&ItemImagDisp($1, 1)/ie
				if $$puphtml =~ /#IMG_([A-Z0-9\/]+)#/;
	   $$puphtml =~ s/\#Detail\_URL\#/$URL->{'CATE_URL'}/o
				if $$puphtml =~ /\#Detail\_URL\#/; $$puphtml;
}

sub StatRankCheck
{	my ($sdate, $param) = (undef, shift);
	if( $CGI->{'cate'} =~ /^rank\.(.*)/ ){ $sdate = $1; } else { return 0; }
	my $stalib = $SS->{'LIB_DIR'} . 'Statlib.pl';
	my @modec = split(/\_/, $sdate); # syear_smon mode=rank.2005_04.12_5
	$DMO = 2; $CGI->{'sort'} = 4; $CGI->{'stype'} = 1;
	if( $modec[1] =~ /\./ )
	{ my ($mon, $monc) = ($1, $2) if $modec[1] =~ /([\d]+)\.([\d]+)/; 
	  if( $modec[0] <= 12 )
	  { $mon = $TIME[4] - $modec[0]; $modec[0] = $TIME[5]; 
	    if( $mon <= 0 ){ $mon = 12 + $mon; $modec[0] -= 1; } 
	  }
	  my ($eyear, $emon, $eday) = ($modec[0], 0, 0);
	  $monc = 12 if $monc > 12;
	  $emon = $mon - $monc + 1; 
	  if( $emon <= 0 ){ $eyear -= 1; $emon = 12 + $emon; } 
	  $CGI->{'syear'} = 'free';
	  ($CGI->{'dys'}, $CGI->{'dms'}) = ($modec[0], sprintf("%02d", $mon));
	  ($CGI->{'dye'}, $CGI->{'dme'}) = ($eyear, sprintf("%02d", $emon)); } else
	{ ($CGI->{'syear'}, $CGI->{'smon'}) = ($modec[0], sprintf("%02d", $modec[1]));
	} $CGI->{'listc'} = $modec[2] || 5;
	SysStartError($stalib) unless -f $stalib;
	require $stalib;
	foreach (@{Stat::ManageSalView()}){ push(@{$param}, $_); }
}

sub StatDModeCheck
{  $DMO;
}


;######################################################################
;# tH[
;######################################################################

sub SearcPrint
{	my ($ssl, $name) = @_;
	return '' if $CGI->{'mode'} =~ /^cglook/ || $SS->{'DIS_TYPE'} == 3 || $CGI->{'page'};
	$CGI->{'cate'} =~ s/(.*)\_[^\_]+$/$1/o if $SS->{'DIS_TYPE'} == 2;
	my $search = &CommHidden($URL->{'SHOP_TOP'}, '', 1, '', '');
	my $cate = $CGI->{'cate'} || $CGI->{'sercate'};
	my $size = !$PTB ? 25 : 6;
	my $checkbox = ' checked="checked"' if $CGI->{'sercate'};
	my $skey;
	&DmainSslCheng($search, 1) if $ssl;
	if( $CGI->{'skey'} )
	{ $CGI->{'skey'} =~ s/\x81\x40/\x20/g;
	  foreach (split(/ /, $CGI->{'skey'})){ $skey .= $_ . ' ' if length($_) > 1; } }

	if( $PTB )
	{ $$search .= $BR . $BR if $ENO == 22; $$search .= $IMG->{'Search'}; } else
	{ $$search = '<table border="0" cellpadding="0" cellspacing="0" ><tr><td>' . $$search . '@'; }
	$$search .= '<input type="text" name="skey" value="' . $skey . '" size="' . $size . '">';
	if( $cate )
	{ if( -f $SS->{'ITEM_DIR'} . $cate . $SS->{'ITEM_FILEKAKU'})
	  { $cate =~ s/(.*)\_([^\_]+)$/$1/o; }
	  my $scinp = '<input type="checkbox" name="sercate" value="' . $cate . '"' . $checkbox . '>';
	  $$search .= !$PTB ? $scinp . '<td><img src="' . $SS->{'SHO_IMG'} . 'sseacate.gif" border="0" width="50" height="18" alt="JeS"></td>'
			     : $scinp . 'Ó' . $BR . ' '; 
	} $$search .= '</td><td>' if !$PTB;
	$$search .= &ImgAltPut(!$PTB ? \$IMG->{'Search'} : '', $name ? $name : 'i', 1);
	$$search .= !$PTB ? '</td></form></tr></table>' : '</form>' . $BR; $search;
}

;######################################################################
;# o[`FbN
;######################################################################

sub MembCheckForm
{	my ($Rmemcheck, $cMsg, $order) = @_;
	my $TITLE   = $SS->{'SHOP_NAME'} . ' [ vtH[ ] ';
	my $SUBNAME = 'v̫';
	my @subset  = ($TITLE, $SUBNAME);
	if( !$Rmemcheck && $ERROR )
	{ $$order = $ERROR; $$order .= $BR . $BR if $PTB; } else
	{ $ERROR = $$cMsg if $Rmemcheck == 5;
	  $$order = $ERROR . "\n" . $$order if $Rmemcheck && $ERROR;
	  $$order .=  &PageParag(5) if !$PTB; 
	} Sys::Print($order, \@subset, '', '', 0);
}

sub MembCheckView
{	my ($ssl, $mod1, $mod2, $msg) = (shift, undef, undef, undef);
	my $memmode = $CGI->{'mode'} =~ /^Rmemcheck([\d]+)/ ? $1 : 1;
	my $targ = $SS->{'ORDER_TRAGET'} ne $SS->{'CART_TRAGET'} ? $SS->{'ORDER_TRAGET'} : undef;
	my ($checked, $check1, $check2) = (' checked="checked"', undef, undef);
	my $msg1  = $memmode == 1 ? 
		    'v̍ہA̕[]Ƀ`FbNiŉB' :
		    $memmode == 2 ?
		    'ŵxɂ́AOC͉o^KvłB' : 
		    $memmode =~ /^(5|6)$/ ?
		    'ς~܂̂ŁA𑱂ꍇ͍ăOCĉB' : 
		    'OCĉB';
	my $msg2  = 'v͉o^KvłB߂()́̕Ao^葱ʂɈڂ܂B';
	my $msg3  = $memmode == 1 ? 
		    ( $CGI->{'Epstuki'} ? '(߂Ă̕[o^]ɂĂi݉B)' :
		    '(߂Ă̕ŉo^ꍇ[o^]Ƀ`FbNĉB)') :
		    $memmode == 2 ?
		    '(x@ύXꍇ́A[o^]̃`FbNOĂi݉B)' :
		    '(߂Ắ̕A[߂]Ƀ`FbNiݒA[AhXmFB)' if $memmode !~ /^(5|6)$/;
	my $accou = $memmode <  2 ? 
		    &ImgAltPut(\$IMG->{'Accou'}, 'v', 1) : &ImgAltPut(\$IMG->{'Fnext'}, '֐i', 1);

	$DIS_CODE = 3 if $CGI_CODE == 4;
	if( $LOGIN || $ENO == 35 ){ $check2 = $checked; } else { $check1 = $checked; }
	if( $SS->{'MEMB_TYPE'} && $SS->{'MEMB_TYPE'} != 3 && !$CGI->{'memb_login'} ) # $memmode =~ /^(5|6)$/ ? '5C' : 
	{ my $mod = $SS->{'MEMB_TYPE'} == 1 ? 'ofor_' . ($memmode !~ /^(2|5|6)$/ ? 1 : '4E') : 'amemb';
	  $mod1 .= '<input type="hidden" name="memmode" value="' . $memmode . '">' . "\n";
	  $mod1 .= "<input type=\"radio\" name=\"mode\" value=\"$mod\"$check1>߂ \n";
	  $mod1 .= "<input type=\"radio\" name=\"mode\" value=\"umemb\"$check2>$BR";
	  $mod1 .= '@<input type="checkbox" name="login" value="3"' .
	  ( $memmode >= 2 || $CGI->{'Epstuki'} ? $checked : undef) . 
		'>o^' . (!$PTB ? $BR : undef) if $SS->{'MEMB_TYPE'} == 1;
	  $msg   = $SS->{'MEMB_TYPE'} == 2 ? $msg2 : $SS->{'MEMB_TYPE'} == 1 ? $msg1 : undef;
	  $msg  .= $BR . $msg3 if $SS->{'MEMB_TYPE'} == 1; $msg .= $BR . $BR . "\n"; } else
	{ $msg   = 'L{^AtH[ւi݉B' . $BR . "\n";
	  $mod2 = "<input type=\"hidden\" name=\"mode\" value=\"ofor_1\">\n"; 
	  $mod2 .= '<input type="hidden" name="memmode" value="10">' if $SS->{'MEMB_TYPE'}; }
	my $form   = &CommHidden($SS->{'ORDE_URL'}, $targ,  1, '', '');
	   &DmainSslCheng($form, 3) if $ssl;
	   $$form .= $mod2 . "\n";
	my $cart  = $$form; my $catepri = undef;
	   $cart .= $msg;
	   $cart .= !$PTB ? 
		"<table width=\"400\" CLASS=font14><tr>\n" . 
		"<td width=\"200\"> </td><td width=\"200\">$mod1</td></tr>" . 
		"<td width=\"200\" align=\"center\" valign=\"bottom\">" . &ShopLink() . "</td>\n" . 
		"<td width=\"200\" align=\"center\">$accou</td></tr></table>\n</form>" 
		: $mod1 . '<center>' . $TC->{'li0'} . $accou . '</center></form>' . 
					$BR . "\n" . &CateTopPri(undef, 1); \$cart;
}

;######################################################################
;# N`FbN
;######################################################################

sub LinkGet
{	my $url = shift;
	$url = '<a href="' . $url if $url !~ /<a/;
	$url =~ s/^<a href/<a class=lb href/o if !$PTB; $url =~ s/\?$//o; $url;
}

sub ShopLink
{	my $name = '𑱂';
	my $slink = (!$PTB ? '<p>@</p>' : $BR . $BR) . "\n" if $ERROR && $CGI->{'mode'} !~ /^Rmemcheck/;
	$slink .= !$PTB && 
	    ($DIS_CODE == 2 && $SS->{'CAGO_TRAGET'} && $SS->{'CAGO_TRAGET'} !~ /^_top$/i
	      || $DIS_CODE == 3 && $SS->{'ORDER_TRAGET'} && $SS->{'ORDER_TRAGET'} !~ /^_top$/i)
		 ? '<a href="javascript:window.close();' : &LinkGet($URL->{'SHOP_TOP'}); 
	if( $ENO > 70 && $ENO < 77 && $PTB )
	{ $slink =~ s/\&cart\=[\d]+//o;
	  $slink .= ($slink !~ /\?/ ? '?' : $slink !~ /\?$/ ? '&' : undef) . $$;
	} $slink .= '">' . ($IMG->{'Conti'} ? &ImgAltPut(\$IMG->{'Conti'}, $name, 0) : $name) . '</a>';
}

1;

