#!/usr/bin/perl
#**************************************************************************
#
#    order.cgi WEB SHOP SYSTEM Cart CGI Ver1.01
#
#     ( WEB SHOP tH[p CGI )
#
#    Created on: 05/06/15 Modified 05/10/22
#   (C) Copyright 2005 by Tomey(Tomio Sato)
#    http://www.pmcj.com/   info@pmcj.com
#    http://www.web-purpose.com/PMC/   info@web-purpose.com
#
#**************************************************************************

require './local/lib/Sys.pl';

#**************************************************************************
Sys::SysSeting(1, 3); #####################################################
#**************************************************************************
  
  local($CGI, $SS, $ED, $PTB, $TC) = (Sys::GetParam())[0, 1, 4, 5, 7];
  local($Etp, $Error, $Br, $Cour) = (Sys::Error(), "<br$TC->{'clc'}>", 1);

  if( $ED->{'epshtml'} ){ Sys::Print(undef, undef, 5, '', 0); exit; }
  if( !$$Error && ($CGI->{'mode'} =~ /^efor\_/ || 
	$CGI->{'mode'} =~ /^order\_/ && $CGI->{'st_code'} =~ /[\d]+\-[\d]+\-[\d]+/) )
  { $Cour = 2;
    my $epslib = $SS->{'LIB_DIR'} . 'Epslib.pl';
    if( -f $epslib )
    { require $epslib; Eps::EpsDataInGet(); } else
    { $Cour = 1; $Error = (Sys::ShopSysError(70 , "Not Epslib.pl"))[0]; }
  }
  if( $CGI->{'mode'} =~ /^(o|e)for\_/ )
  { $Cour != 2 ? &OrderView(Sys::FormData()) : Eps::EpsOrderView(Sys::FormData()); }
  elsif( $CGI->{'mode'} =~ /^order\_/ )
  { Sys::OrderEndPrint($Cour == 2 ? 1 : 0); }
  elsif( $CGI->{'mode'} !~ /^ofor\_/ ) 
  { local($Rmemcheck) = $CGI->{'mode'} =~ /^Rmemcheck([\d]+)/ ? $1 : 0;
    if( !$CGI->{'mode'} || $Rmemcheck )
    { Sys::MembCheckForm($Rmemcheck, undef, Sys::MembCheckView()); }
    elsif( $CGI->{'mode'} =~ /memb$/ )
    { my $lc = $CGI->{'mode'} eq 'umemb' ? 1 : 4;
      &MembWindForm(Sys::LoginFormDisp($lc, 0)); }
    else{ &OrderNone(); } }
  else
  { &OrderNone(); }

exit;

#**************************************************************************

sub OrderNone
{
	print "Content-Type: text/plain\n\n";
	print "Order CGI for WEB SHOP System \n\n";

}

sub MembWindForm
{	my $order = shift;
	my $TITLE   = $SS->{'SHOP_NAME'} . ' [ vtH[ ] ';
	my $SUBNAME = 'v̫';
	my @subset  = ($TITLE, $SUBNAME);
	my ($msa, $msb) = $CGI->{'memmode'} < 2 ? ('vO', '[tH[]') : (undef, '');
	my $msg1 = 'IDPASS͂' . $msb . '֐iŉB';
	my $msg2 = '' . $msa . 'pX[h' . $msb . '֐iŉB';
	my $msg  = $$order =~ /\#MSG1\#/ ? $msg1 : $msg2;
	$$order  =~ s/\#MSG[\d]\#/\#MSG\#/;
	if( $$Error )
	{ if( $Etp == 1 ){ $order = $Error; } else{ $msg .= $Br . $Br . $$Error; } } 
	elsif( $PTB )
	{ $msg .= $Br . $Br; }
	if( $Etp != 1 )
	{ $$order  =~ s/\#MSG\#(<br( \/)?><br( \/)?>)/$msg . "\n" . (!$PTB ? $1 : undef)/eo;
	  $$order .= &Sys::PageParag(5) if !$PTB;
	} Sys::Print($order, \@subset, '', '', 0);
}

sub OrderView
{	my $order   = shift;
	my $mode    = \$CGI->{'mode'};
	my ($send, $sene) = ($CGI->{'osend'}, $CGI->{'osene'});
	my ($ofrom, $ofrc)   = ($1, $2) if $$mode =~ /\_(([\d]+)([a-z])?)$/i;
	my $subname = $ofrom =~ /^1/ ? ":ҏ" : $ofrom =~ /^2n$/i ? ":͂mF" :
		      $ofrom =~ /^2/ ? ":͂" : $ofrom =~ /^3/ ? ":͂̂@"  :
		      $ofrom =~ /^4/ ? ":x@El" : $ofrom =~ /^5/ ? ":͏̊mF"  : 
		      $ofrom =~ /^7/ ? ":̕ύX"   : undef;
	my $newmode = $$mode; 
	   $newmode .= Sys::FormAlphaCheck("k", $CGI->{'fback'}, 0) if $$mode !~ /([a-z])$/i;
	my $TITLE   = $SS->{'SHOP_NAME'} . " [ v$subname ] ";
	my $SUBNAME = 'v̫';
	my @subset  = ($TITLE, $SUBNAME);
	my $action  = \$SS->{'ORDE_URL'};
	my $amemb   = $CGI->{'amemb'};
	my ($sendc, $sendp, $osMsg, $coMsg) = (0, 0, undef, undef);
	if( $SS->{'OSEND_TYPE'} && $ofrom =~ /^2/)
	{ $sendc = $sene >= $SS->{'OSEND_TYPE'} ? 2 : 1;
	  $osMsg = $sendc == 1 ? 
	  "Xɂ͂ǉꍇ́AL[͐ǉ]NbNĉB" . $Br . 
	  "@ (͂搔$SS->{'OSEND_TYPE'}܂łwo܂B)" . $Br : 
	  "͂$SS->{'OSEND_TYPE'}ɒB܂̂łȏ̂w͏o܂B". $Br if $ofrom =~ /^2n$/i;
	  $coMsg = "" . $sene . "̂͂񂪓Ă܂B" if $sene > 0 && $ofrom !~ /^2E$/i;
	  $coMsg = !$PTB ? 
	  '<font CLASS=font13 size="2">'. $coMsg . '</font>' : $coMsg . $Br if $coMsg;
	}
	if( $$Error && (!$PTB || $Etp !~ /^(50|51)$/) )
	{ if( $ofrom eq '0E' )
	  { my ($pri, $html) = (0, undef);
	    $$order =~ s/\#OSEND\_(MCO|MSG)\#//g;
	    foreach ( split(/\n/, $$order) )
	    { $html .= $_ . "\n" if $pri; $pri = 1 if /<\!\-\- FORM4 \-\->/; }
	    $$order = $$Error . $Br. $html; } else
	  { $$order = $$Error; } } else
	{ my $subc  = $CGI->{'Eorder'} != 1 && $CGI->{'ordsend'} ? 8 : 
			$ofrom == 4 || $ofrom =~ /^1E$/i ? 3 : $ofrom =~ /^2N$/ ? 2 : 1;
			# $ofrom == 4 || $ofrom =~ /^(1e|1E|2N)$/ ? 2 : 1;
	  $sendc = 0 if $ofrom !~ /^2n$/i || $subc == 8;
	  $sene += 1 if $ofrom =~ /^2(e|n)?$/i; 
	  $send = $sene if !$CGI->{'Ferror'} && $ofrom =~ /^2$/;
	  $send = 1 if !$send;

	  my ($form, $submit, $bnam) = Sys::PostFormDisp($action, $subc, $sendc, int($ofrom), $sene);
	  $$order =~ s/\#BO\#/$bnam/o;
	  if( $CGI->{'ordsend'} ) 
	  { undef $form; } else
	  { $newmode =~ s/([a-z])$/Sys::FormAlphaCheck($1, $CGI->{'fback'}, 0)/ieo;
	    $$form .= "<input type=\"hidden\" name=\"mode\" value=\"$newmode\">\n"; 
	    $$form .= "<input type=\"hidden\" name=\"osend\" value=\"$send\">\n" 
					if $ofrom =~ /^(2|3)/ && $ofrom !~ /^2n$/i; }
	  if( $ofrom =~ /^7/ )
	  { my @Cart = (Sys::ItemList())[0 .. 2];
	    ${$Cart[2]} =~ s/\#ORDER\_SSL\#//o; #${$Cart[2]} =~ s/(<br>)+\n?$/\n/g;
	    $$order = ${$Cart[1]} . ${$Cart[0]} . ${$Cart[2]}; } else
	  { $ofrc = (!$SS->{'EPSI_SET'} || $subc == 8 && $CGI->{'Eorder'} != 3 ? 0 : 1) . $ofrc; $ofrc .= 'k' if $newmode =~ /\_2N$/i;
	    my $ofimg .=  '<img src="' . $SS->{'SHO_IMG'} . 'order_' . $ofrc . 
		'.gif" border="0" width="600" height="33" alt="">' . (!$$form ? $Br : undef) . "\n" if !$PTB;
	    $$order = $$Error . $Br. $$order if $$Error && $PTB && $Etp =~ /^(50|51)$/;
	    $$order =~ s/\#OSEND\_MCO\#/$coMsg/g;
	    $$order =~ s/\#OSEND\_MSG\#/$osMsg/g;
	    $$order =~ s/^(<input[^>]+>\n)?<br>/$1/o; 
	    $$order = $ofimg . $Br . $$form . $$order; 
	  } $$order .= $$submit; $$order .= $Br if $PTB;
	} Sys::Print($order, \@subset, '', '', 0);
}


