;#**************************************************************************
;#
;#    CommDisp.pl Commonness disp Subroutine Ver1.03 for WEB SHOP System
;#    Created on: 05/06/15 Modified 05/12/21
;#    (C) Copyright PMCJ Tomio Sato. http://www.pmcj.com/
;#
;#**************************************************************************

;######################################################################
;# O
;######################################################################

sub GetParam
{	#///// SysDat Seting1 /////
	&CommDataSet();
	&EpsAccessCheck() if $CGI_CODE == 4;
	#/////
	$CGI = &JmclForm('sjis', 'form2', &JmclOptionSet);
	#///// SysDat Seting2 /////
	&CodeDataSet();
	($ES, $CD, $ED, $IMG) = &SysEngine(&PutDataDisp());
	#/////
	&DataReturn();
}

sub JmclOptionSet
{	my $opt1 = substr($HMIME[2], 0, 1) . $SS->{'KANA_ZENKAKU'} . $SS->{'TERM_IZON'} . 'dd';
	my $opt2 = 'f600kpic1txthtm'; $SForm->{'SYS_APPLIMIT'} = 600 if $SForm->{'SYS_APPLIMIT'} > 600;
	   $opt2 .= 'l' . ($SForm->{'SYS_APPLIMIT'} ? $SForm->{'SYS_APPLIMIT'} : 600) .  'k"';
	$opt1, $opt2;
}

sub CommDataSet
{	$LANG  = $PTB ? 'SJIS' : $SS->{'LANG'};
	$OS    = $SS->{'OS'} = (JMClib::ClientCheck())[0];		
	$USER  = JMClib::UserEnv();
	$ADDR  = $USER->{'addr'}; $HOST = $USER->{'host'}; 
	$PTB   = $OS =~ /^\d/ ? $OS : 0;
	@HMIME = JMClib::Conthtml($LANG);
	$HMIME[0] = "Content-Type: text/html; charset=Shift_JIS\n\n" if !$HMIME[0];
	$HMIME[1] = "<meta http-equiv=Content-Typecontent=text/html\; charset=Shift_JIS>" if !$HMIME[1];
	@TIME  = JMClib::TimeGet($SS->{'TIME_ADJUST'});
	$TC    = &TerminalCheck();
	$BR = "<br$TC->{'clc'}>";
	$SKeyCheck = $CGI_CODE == 10 ? 'searkey' : 'skey';
	$SS->{'CGI_CODE'} = $CGI_CODE; $SS->{'DIS_TYPE'} = $DIS_CODE;
	$SS->{'cook'} = $TC->{'cook'}; $SS->{'kid'}  = $TC->{'kid'};
	$SS->{'ine'}  = $TC->{'ine'};  $SS->{'ins'}  = $TC->{'ins'};
}

sub CodeDataSet
{
	if( $CGI->{'itempImg'} || $CGI->{'itemdImg'} )
	{ &ManageShopFilePrint($CGI->{'itemdImg'} ? 'iView' : undef, 
				$CGI->{'itempImg'} || $CGI->{'itemdImg'}); }
	elsif( $CGI_CODE =~ /^(1|5)$/ && $CGI->{'check'} ){ &EnginePastCheck(); }
	elsif( $CGI_CODE ==  5 ){ &MembDataCheck(); }
	elsif( $CGI_CODE == 10 ){ &ManageDataCheck(); }
	elsif( $DIS_CODE == 31 ){ $CGI->{'mode'} = 'efor_6'; }
	elsif( $DIS_CODE == 33 ){ $CGI->{'mode'} = 'canc_8'; }
}

sub TimeDisp
{	my $adj = shift;
	$adj = $SS->{'TIME_ADJUST'} if !$adj;
	my @TIME = JMClib::TimeGet($adj); \@TIME;
}

sub DataReturn
{ $CGI, $SS, $CD, $ES, $ED, $PTB, $IMG, $TC, $I, $USER, \$FORM;
}

sub ManageSysData
{ my $sysfile = $SS->{'CONF_DIR'} . $SS->{'MAN_CONF'};
  $SForm = &FileOpen(\$sysfile, 2, 0);
  $SForm->{'form_mark'} = $SForm->{'Formar_IMG'}
	? '<img src="' . $SS->{'IMG_URL'} . $SForm->{'Formar_IMG'} . '">'
	: "<font color=\"$SForm->{'form_color3'}\"></font>"; #$SForm;
  while (my ($key, $val) = each %{$SForm})
  { if( $key =~ /^(mf|mg|lno|do)/ && $key =~ /\_IMG(\d)?$/ )
    { $SForm->{$key}   = '<img src="' . $SS->{'IMG_URL'} . $SForm->{$key} . '">'; }
  }
  $SForm->{'SYS_salstat'} = 10 if $SForm->{'SYS_salstat'} && $SForm->{'SYS_salstat'} > 10;
  $SS->{'X_LTIMEOUT'} = $SForm->{'SYS_LTIMEOUT'};
  $SS->{'SEARCH_LIMIT'} = $SForm->{'SEARCH_LIMIT'};
  $Uauto = $SForm->{'SYS_Uauto'}; $Pladd = $SForm->{'SYS_Pladd'};
  $Dview = $SForm->{'SYS_Dview'}; $Uview = $SForm->{'SYS_Uview'};
  $CGI->{'Ifilesv'} = $SForm->{'SYS_Fview'};
  $Imagc = 'jpg|jpe|jpeg|gif|png'; 
  $Htmlc = 'html|htm|dat|js|css';
}

sub ManageSysGet
{ $SForm, $Htmlc, $Imagc;
}

;######################################################################
;# HTML֘A
;######################################################################

sub Print
{	my ($bodydat, $subset, $headpri, $errjmc, $err) = @_;
	my ($Headdat, $Footdat) = (undef, undef);
	local($pritype) = $$headpri =~ /<\!-- ([\d]+) -->/ ? $1 : $headpri;
	local($Opt) = undef;
	&SubSet($subset); &MobileDataDisp($bodydat) if $PTB;
	$bodydat = &ShopErrorPri(\$ERROR , 1, 14) if !$ED->{'epshtml'} && !$$bodydat && $ERROR;
	&RootChange($bodydat) if $Rchen[0] && $DIS_CODE == 33;
	&HFfileTemplateChange() if $CGI->{'mkey'} =~ /(1|2).vTest/;
	if( !$err && !$pritype )
	{ &SysErrorDataDisp(1) if (!(-f $SS->{'FootFile'}) || !(-f $SS->{'HeadFile'}));
	  $Headdat = &HeadPrint( $bodydat );
	  $Footdat = &FootPrint(); 
	}
	if(!$$Headdat || !$$Footdat || $err || $pritype )
	{ if( !$err && !$pritype )
	  { $SS->{'HeadFile'} = 'HeadFile' if !$SS->{'HeadFile'};
	    $SS->{'FootFile'} = 'FootFile' if !$SS->{'FootFile'};
	    ($bodydat, $subset, undef, undef, undef) = &ShopSysError(51, 
	      ("Can't Open" . !$$Headdat ? $SS->{'HeadFile'} : $SS->{'FootFile'})); }
	  ($Headdat, $Footdat)  = (&Header($bodydat, $headpri) , &Footer()); 
	}
	if( $pritype != 5 )
	{ my $printdat = $$Headdat . $$Footdat;
	  $printdat = &JmclConv($printdat, $HMIME[2], 'sjis', $Opt)
		if !$errjmc && $HMIME[2] ne 'sjis' || $PTB;
	  print &ContentDisp() . $printdat; } else
	{ print $EPSIHTML; } 
exit;

}

sub ContentDisp
{
	if( $CGI_CODE == 5  && !$SS->{'MEMB_HTMCACHE'} 
	||  $CGI_CODE == 10 && !$SForm->{'SYS_HTMCACHE'} )
	{ $HMIME[0] =~ s/\n$//;
	  $HMIME[0] .= "Expires: Mon, 26 Jul 1997 05:00:00 GMT\n";
	  #$HMIME[0] .= "Pragma: no-cache\n";
	  $HMIME[0] .= "Cache-Control: no-cache\n\n";
	} $HMIME[0];
}

sub HFfileTemplateChange
{	my $temfile = $SS->{'CACHE_DIR'} . 'admin/';
	my ($temphead, $tempfoot) = ($SS->{'HeadFile'}, $SS->{'FootFile'});
	$temphead =~ s/^$SS->{'TEMPL_DIR'}([^\.]+)\.dat/$temfile$1\.tmp/o;
	$tempfoot =~ s/^$SS->{'TEMPL_DIR'}([^\.]+)\.dat/$temfile$1\.tmp/o;
	$SS->{'HeadFile'} = $temphead if -f $temphead;
	$SS->{'FootFile'} = $tempfoot if -f $tempfoot;
}

sub HeadSet
{	my $head = $HMIME[1];

	$head .= "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"" . $CGI->{'retime'} . "\;URL=" .
	  ${&ManageCommHidden($SS->{'MANAG_URL'}, 0, 1)} . '&mode=LD&lov='
		 . $CGI->{'lov'} . '&log=' . $CGI->{'log'} .'&retime=' . $CGI->{'retime'} 
			. '&' . sprintf("%02d%02d%02d", $TIME[2], $TIME[1], $TIME[0]) . "\">\n" 
				if $CGI_CODE == 10 && $CGI->{'mode'} eq 'LD' && $CGI->{'retime'};
	$head .= "<link rel=\"stylesheet\" href=\"$SS->{'CSS'}\" type=\"text/css\">\n"
	 . "<script language=\"JavaScript1.2\" src=\"$SS->{'JS'}\"></script>"; \$head;
}

sub SubWinClose
{	my ($url, $width) = @_;
	my $close = 
	'<table width="' . $width . '"><tr>' . 
	'<td align="right"><a href="javascript:window.close();"><img src="' . $$url . 
	'wclose.gif" width="60" height="20" border=0></a></td></tr></table>'. "\n"; \$close;
}

sub SubSet
{	my $subset = shift;
	$TITLE    = $subset->[0] if !$TITLE;
	$SUBNAME  = $subset->[1] if !$SUBNAME;
	$LISTVIEW = $subset->[2] if !$LISTVIEW;
}

sub BodySet
{	$SS->{'BG_COLOR'} = "#FFFFFF" if !$SS->{'BG_COLOR'};
	$SS->{'B_TEXT'}   = "#000000" if !$SS->{'B_TEXT'};
	$SS->{'BG_IMG'} = $SS->{'IMG_URL'} . 'mback0f.gif' if $CGI_CODE == 10;
	my $body = "<body ";
	$body .= " background=\"$SS->{'BG_IMG'}\"" if !$PTB && $SS->{'BG_IMG'};
	$body .= " bgcolor=\"$SS->{'BG_COLOR'}\" text=\"$SS->{'TEXT'}\""
	      . " link=\"$SS->{'LINK'}\" alink=\"$SS->{'ALINK'}\" vlink=\"$SS->{'VLINK'}\"";
	$body .= ' LEFTMARGIN=0 TOPMARGIN=0 marginwidth=0 marginheight=0' if !$PTB;
	$body .= ' onLoad="return focus()"' if $CGI_CODE == 10 && $CGI->{'mode'} eq 'LD';
	$body .= ">\n";
}

sub Header
{	my ($head, $bodydat, $headpri) = ("<html>\n", @_);
	$head .= "<head>\n";
	$head .= "<title>$TITLE</title>\n";
	$head .= ${&HeadSet()} . "\n" if !$PTB;
	$head .= "</head>\n";
	$head .= "$COPYR\n";
	$head .= &BodySet();
	$head .= "<p align=center><center>\n" if !$PTB;
	if( $pritype == 1 )
	{ $head .= $$headpri; }
	elsif( !$pritype || $pritype == 10 )
	{ $head .= "<br><br>\n" if !$PTB;
	  $head .= "<b>Web Shop System Error</b>"; 
	  $head .= "<br><br>\n" if !$PTB; 
	} $head .= $$bodydat; \$head;
}

sub Footer
{	my $foot;
	$foot .= "</center></p>\n" if !$PTB;
	$foot .= "</body></html>\n"; \$foot;
}

sub HeadPrint
{	my ($head, $bodydat) = (undef, shift);

	unless(open(HEADHTM, "<$SS->{'HeadFile'}")){ return \$head; }
	while (<HEADHTM>)
	{ s/(\r)?\n$//g; &CommChange();
	  s/(<body)/$COPYR$1/i; 
	  if( /#PICUP[\d]+(\_[\w]+\.[\d]+)?\#/ )
	  { s/\#(PICUP[\d]+)(\_([\w]+\.[\d]+))?\#/&PicUpRand($1, $3)/e;  } 
	  if( /\#MSGFILE\_[\w]+\#/ )
	  { s/\#MSGFILE\_([\w]+)\#/${&FileOpen(\($SS->{'INFO_DIR'} . $1 . '.dat'), 1 ,1)}/e; } 
	  if( /\#[\w]+\#/ )
	  { s/\#TITLE\#/$TITLE/o 		    if /\#TITLE\#/;
	    s/\#BODY_PRINT\#/$$bodydat/o 	    if /\#BODY_PRINT\#/;
	    if( !$PTB )
	    { s/\#HEAD\#/${&HeadSet()}/e 	    if /\#HEAD\#/; 
	      s/\#MEMB\_MENU\#/${&MembTopDisp()}/e  if /\#MEMB\_MENU\#/; } else
	    { s/\#PAGE_NAME\#/$IMG->{'Sub1'} $SUBNAME/ if /\#PAGE_NAME\#/; }
	  } $head .= $_ . "\n";
	} close(HEADHTM); \$head;
}

sub FootPrint
{	my $foot = undef;
	unless(open(FOOTHTM, "<$SS->{'FootFile'}")){ return \$foot; }
	while (<FOOTHTM>)
	{ s/(\r)?\n$//g; &CommChange(); $foot .= $_ . "\n"; } close(FOOTHTM); \$foot;
}

sub OrderEndPrint
{	my ($order, $eps) = (\$FORM, shift);
	my $subname = '';
	my $TITLE   = $SS->{'SHOP_NAME'} . " [ v:$subname ] ";
	my $SUBNAME = 'v̫';
	my @subset  = ($TITLE, $SUBNAME);
	if( $ERROR )
	{ $$order = $ERROR; } else
	{ my $error = Sys::OrderMailNotiDisp();
	  $$order =~ s/\#order\_number\#/$CGI->{'order_number'}/o;
	  $$order .= ${(Sys::ShopSysError(110))[0]} if $error;
	  $$order .= ${Eps::EpsConvMsg()} if $eps && $ED->{'payment_code'} == 3; 
	} &Print($order, \@subset, '', '', 0);
}

sub RootChange
{	my $buf = shift;
	$$buf =~ s/((\:openWin\(|href\=||src\=|background\=)[\"\'])$Rchen[0]/$1$Rchen[1]/ig;
}

sub LinkPrintDisp
{	my($url, $key, $page, $ssl) = (undef, @_);
	if( $page )
	{ $url = $URL->{'SHOP_TOP'};
	  &DmainSslCheng(\$url, 1) if $ssl;
	  $page = '&' . $page if $url !~ /\?$/; $url = $url . $page; } else
	{ my $add = 0;
	  if( $key =~ /ADDURL/ && !$LOGIN ){ $add = 1; $key =~ s/ADDURL/URL/o; } 
	  if( $key =~ /CONTACT/ ){ $add = -1; $key =~ s/CONTACTURL/URL/o; } 
	  $url = $URL->{$key};
	  if( $ssl )
	  { my $cgi = $key =~ /\_CAGO/ ? 2 : $key =~ /\_ORDER/ ? 3 : 
		      $key =~ /MEMB/ ? 4 : 1; &DmainSslCheng(\$url, $cgi); 
	  } if( $add > 0 ){ &MembAddLink(\$url) } elsif( $add < 0 ){ &ContactLink(\$url, 1); };
	  $url =~ s/\?$//;
	} $url;
}

sub CommChange
{	s/\#(LOGIN|LOGOUT)\_([A-Z]+)(\_SSL)?\#/${&MembForm($1, $2, $3)}/e if /\#(LOGIN|LOGOUT)\_[A-Z]+(\_SSL)?\#/;
	if( /(\#SHOP\_[\w]+(\_SSL)?|URL(\_SSL)?\#)/ )
	{ s/\#SHOP\_SEARCH(\_SSL)?(.([^#]+))?\#/${&SearcPrint($1, $3)}/e if $CGI_CODE == 1 && $_ =~ /\#SHOP_SEARCH([^#]+)?\#/;
	  s/\#SHOP\_(page\=[a-z0-9]+)(\_SSL)?\#/&LinkPrintDisp(undef, $1, $2)/eg if/\#SHOP\_(page\=[a-z0-9]+)(\_SSL)?\#/;
	  s/\#([A-Z]+\_[A-Z]+)(\_SSL)?\#/&LinkPrintDisp($1, undef, $2)/eg if /\#([A-Z]+\_[A-Z]+)(\_SSL)?\#/;
	} &RootChange(\$_) if $Rchen[0];
	s/\#Moji\_([A-Z0-9]+)\#/$IMG->{$1}/ig if /\#Moji\_[A-Z0-9]+\#/i; 
	if( $PTB )
	{ s/\#clc\#/$TC->{'clc'}/g 	        if /\#clc\#/;
	  s/\#(li[\d]+)\#/$TC->{$1}/g	        if /\#li[\d]\#/;
	}
}

sub PageNone
{	my $TITLE   = $SS->{'SHOP_NAME'};
	my $SUBNAME = $SS->{'SHOP_NAME'};
	my @subset  = ($TITLE, $SUBNAME);
	my $page = undef;
	Sys::Print(\$page, \@subset, '', '', 0);
}

;######################################################################
;# tH[֘A
;######################################################################

sub CommHidden
{	my ($hid, $action, $target, $mhc, $utc, $fnc) = (undef, @_);
	my $targ = ' target="' . $target . '"' if !$PTB && $target && $target ne 'login';
	my $formname = ' NAME="Formkey"' if $fnc;
	my $utn = ' utn' if $TC->{'utn'} && $utc;
	if( $mhc )
	{ $hid  = "<form method=\"POST\" action=\"$action\"$utn$formname$targ>\n";
	  $hid .= "<input type=\"hidden\" name=\"mkey\"" . 
				" value=\"$CGI->{'mkey'}\">\n"  if $CGI->{'mkey'};
	  if( $target ne 'login' )
	  { $hid .= "<input type=\"hidden\" name=\"uid\"" . 
				" value=\"$CGI->{'uid'}\">\n"   if $CGI->{'uid'};
	    $hid .= "<input type=\"hidden\" name=\"lcode\"" . 
				" value=\"$CGI->{'lcode'}\">\n" if $CGI->{'lcode'}; 
	  } $hid .= "<input type=\"hidden\" name=\"cart\"" . 
				" value=\"$CGI->{'cart'}\">\n"  if $CGI->{'cart'}; } else
	{ $hid  = "<a$targ href=\"$action?";
	  $hid .= "mkey=" . $CGI->{'mkey'} . "&" if $CGI->{'mkey'};
	  $hid .= "mid="  . $CGI->{'mid'}  . "&" if $CGI_CODE == 10 && $CGI->{'mid'};
	  if( $target ne 'login' )
	  { $hid .= "uid="   . $CGI->{'uid'}   . "&" if $CGI->{'uid'};
	    $hid .= "lcode=" . $CGI->{'lcode'} . "&" if $CGI->{'lcode'} && $CGI->{'lcode'} !~ /^madd\./; 
	  } $hid .= "cart="  . $CGI->{'cart'}  . "&" if $CGI->{'cart'}; $hid =~ s/\&$//; 
	} \$hid;
}

sub SearchFormDisp
{	my ($from, $mhc) = @_;
	my @count = &ManageUserCount() if $CGI_CODE == 10;
	my $s = $count[0] . ',' . $count[1] . ',' . $count[2] if $count[0]; 
	if( !$mhc )
	{ my $keyurl = JmclConv($CGI->{$SKeyCheck}, 'url', 'sjis', '', '', '') if $CGI->{$SKeyCheck}; 
	  $$from .= '&s=' . $s if $s;
	  $$from .= '&' . $SKeyCheck . '=' . $keyurl->[0] if $keyurl->[0];
	  $$from .= '&uskey=' . $CGI->{'uskey'} if $CGI->{'uskey'};
	  $$from .= '&sercate=' . $CGI->{'sercate'} if $CGI->{'sercate'};  } else
	{ $$from .= "<input type=\"hidden\" name=\"s\" value=\"$s\">\n" if $s;
	  $$from .= "<input type=\"hidden\" name=\"$SKeyCheck\" value=\"$CGI->{$SKeyCheck}\">\n"
									if $CGI->{$key};
	  $$from .= "<input type=\"hidden\" name=\"uskey\" value=\"$CGI->{'uskey'}\">\n" 
									if $CGI->{'uskey'};
	  $$from .= "<input type=\"hidden\" name=\"sercate\" value=\"$CGI->{'sercate'}\">\n"
									if $CGI->{'sercate'}; }
}

sub ImgAltPut
{	my ($img, $alt, $chang) = @_;
	if( !$chang )
	{ if( $$img =~ /^<img/ )
	  { $$img =~ s/^(<img(.*))(>)$/$1 border=\"0\" alt=\"$alt\"$3/; } 
	  elsif( !$$img )
	  { $$img = $alt; } } else
	{ $alt = $PTB && $$img && $$img !~ /^<img/ ? $$img : $alt;
	  if( $chang != 2 )
	  { if( $$img =~ /^<img/ )
	    { $$img =~ s/^<img(.*)>$/<input type=\"image\"$1 border=\"0\" alt=\"$alt\">/; } 
	    elsif( $$img !~ /^<input type=/ )
	    { $$img = '<input type="submit" value="' . $alt . '">'; } } else
	  { $$img = '<input type="reset" value="' . $alt . '">'; }
	} $$img;
}

sub MembAddLink
{	my $url = shift;
	$$url .= '&' if $$url !~ /\?$/; $$url .= 'mode=amemb';
	$$url .= '">'. &ImgAltPut(\$IMG->{'Logmadd'}, 'o^', 0) . '</a>' . $BR;
}

sub MembForm
{	my ($logc, $type, $ssl) = @_;

	return undef if !$SS->{'MEMB_TYPE'}; 
	return \("SHOP͉@\\ɂȂĂ܂B<br><br>") if !$SS->{'MEMB_SET'};

	local($Memadd) = 0;
	local($LSsl)    = 1 if $ssl;
	if( $type eq 'ERROR' )
	{ my $error = undef;
	  if( $CGI->{'mode'} eq 'login' && $ERROR)
	  { $error = (&Error())[1]; $$error = $BR . $BR . $$error if !$PTB; } return $error; }
	elsif( $logc eq 'LOGOUT' )
	{ return undef if !$LOGIN; return &LoginFormDisp(0, 1, $type); } 
	elsif( $logc eq 'LOGIN' )
	{ my $form = undef;
	  if( $type eq 'ADD' )
	  { return \$form if $CGI->{'mode'} ne 'amemb' && $ERROR;
	    $Memadd = 1; return &LoginFormDisp(5, 0, 0); } else 
	  { return \$form if $CGI->{'mode'} eq 'amemb' && $ERROR 
				|| $SS->{'CGI_CODE'} == 5 && $CGI->{'mode'} =~ /^a/;
	    if( !$LOGIN )
	    {  if( $type eq 'PAGE' )
	      { my ($url, $cgi) = $SS->{'MEMB_TYPE'} == 3 ? 
				($SS->{'SHOP_URL'} . '?', 1) : ($URL->{'MEMB_URL'}, 4);
						&DmainSslCheng(\$url, $cgi) if $ssl;
		$form = \$url;
	        $$form = '<a href="' . $$form if $$form !~ /<a href/;
	        $$form .= ($$form =~ /\?$/ ? '' : '&') . 'mode=login';
	        my $name = &ImgAltPut(\$IMG->{'Login'}, 'OC', 0);
	        $$form .= "\">" . $name . "</a>\n"; }
	      elsif($type =~ /^DISP/ )
	      { my $ft = $type =~ /A$/ ? 1 : $type =~ /B$/ ? 2 : 0;
	        return undef if $ft == 2; 
	        $form = &LoginFormDisp(1, 1, $ft);
	        my $name = &ImgAltPut(\$IMG->{'Logform'}, 'OC', 0) . $BR . "\n"
									    if $ft && !$PTB;
	        $$form = $name . $$form; } return $form; } else
	    { return undef if $CGI->{'mlist_no'};
	      if( $type eq 'PAGE' || $CGI_CODE =~ /^(5|4)$/ && $type !~ /^DISP(A|B)$/ || $CGI->{'mode'} eq 'umemb')
	      { my $ft = $type =~ /A$/ ? 1 : $type =~ /B$/ ? 2 : 0;
		return &LoginFormDisp($CGI->{'mode'} eq 'umemb' ? 1 : 0, 1, $ft); }
	      elsif( $type =~ /^DISP/ )
	      { return &MembMenuList(); }
	    }
	  }
	}
}

sub LoginFormDisp
{	my ($lc, $lt, $pos) = @_;
	my $add = 1 if $lc >= 4 && $lc <= 6;
	my $mname = $CGI_CODE != 10 ? 'mode' : 'disp';
	my $logio = undef;
	my ($style, $size) = 
		!$PTB ? (" style=\"font-size:13px\;height:17px\;width:100px\;\"", 16, undef) : 
									("$TC->{'ine'}><br", 12);
	my ($action, $cgi) = 
	   !$Memadd && !$lt ? ($SS->{'ORDE_URL'}, 3) : 
	   !$Memadd &&  $lc && $SS->{'CGI_CODE'} != 5 && $SS->{'MEMB_TYPE'} == 3 
			    ? ($SS->{'SHOP_URL'}, 1) : ($SS->{'MEMB_URL'}, 4);
	my $form = &CommHidden($action, ($lc ? 'login' : ''), 
			($lc ? $lc : 0), (!$Memadd && $lc && $OS == 1 ? 1 : 0), '') if $lc != 6;
							&DmainSslCheng($form, $cgi) if $LSsl;
	if( !$lc )
	{ return undef if $DIS_CODE =~ /^(2|3)$/ || $DIS_CODE == 33 && $CGI->{'order_number'};
	  my $mpg = $PTB && !$pos ? 1 : 0;
	  $$form .= ($$form =~ /\?$/ ? '' : '&') . 'mode=' . ($mpg ? 'lin_0' : 'logout');
	  my $name = $mpg ? &ImgAltPut(\$IMG->{'Mmtitle'}, 'y[W', 0)
							 : &ImgAltPut(\$IMG->{'Logout'}, 'OAEg', 0);
	  $logio = $$form . "\">" . $name . "</a>\n";
	  if( $PTB )
	  { $logio = $IMG->{'LogOUT'} . " " . $logio if !$mpg; 
	    $logio = $pos eq 'TOP' ? $logio . $BR . $TC->{'li9'} : 
		     $pos eq 'FOOT' ? $TC->{'li9'} . $logio . $BR : $logio; } } else 
	{ my ($mod, $hei) = $Memadd ? 
		($lc != 6 ? (afor_1, 34) : $CGI_CODE == 5 ? (mfor_10, 34) : (pfor_1, 34)) : 
		      $lt ? (umemb, 17)  : $CGI->{'memmode'} =~ /^(5|6)$/ ? (ofor_5E, 34) :
					   $CGI->{'memmode'} == 2 ? (ofor_5C, 34) :
					   $CGI->{'memmode'} == 3 ? (ofor_1E, 34) : (ofor_1, 34);
	  my $vali = $CGI->{'uid'} ? " value=\"$CGI->{'uid'}\"" : undef;
	  my $valp = $ERROR && (!$add && $CGI->{'login'} == 1
			 || $add && $CGI->{'login'} > 1) ? " value=\"$CGI->{'upass'}\"" : undef;
	  my $idfo = "<input type=\"text\" size=\"$size\" name=\"uid\"$vali$style>\n";
	  my $pafo = "<input type=\"password\" size=\"$size\" name=\"upass\"$valp$style>\n";
	  my $pcfo = "<input type=\"password\" size=\"$size\" name=\"cpass\"$style>\n";
	  my ($inpu1, $inpu2) = !$add ? (\$idfo, \$pafo) : (\$pafo, \$pcfo);
	  my ($name1, $name2) = (undef, undef);
	  if( !$PTB )
	  { ($name1, $name2) = !$add
	      ? (&ImgAltPut(\$IMG->{'LogID'}, 'ID', 0), 
		$pos ? &ImgAltPut(\$IMG->{'LogKEY'}, 'PASS', 0) : &ImgAltPut(\$IMG->{'LogPASS'}, 'PASS', 0))
	      : ($IMG->{'Form'} . "<nobr> <b>o^o`rr</b>(6-12) F </nobr>", " PASSmF F "); } else
	  { ($name1, $name2) = !$add
	      ? ($IMG->{'LogID'} . ' ID', $IMG->{'LogPASS'} . ' PASS')
	      : ($IMG->{'LogPASS'} . " o^PASS(6-12)", $IMG->{'LogPASS'} . " PASSmF"); }
	  $$form .= "<input type=\"hidden\" name=\"$mname\" value=\"$mod\">\n";
	  if( $lc != 6 )
	  { if( !$CGI->{'lcode'} )
	    { my $ldate = $CGI->{'ldate'} || $TIME[11];
	      $$form .= "<input type=\"hidden\" name=\"ldate\" value=\"$ldate\">\n"; } else
	    { $$form .= "<input type=\"hidden\" name=\"lcode\" value=\"$CGI->{'lcode'}\">\n"; }
	    $$form .= "<input type=\"hidden\" name=\"login\" value=\"$lc\">\n";
	    $$form .= "<input type=\"hidden\" name=\"memmode\" value=\"$CGI->{'memmode'}\">\n" if $CGI->{'memmode'};
	  }
	  $$form .= "<input type=\"hidden\" name=\"mkey\" value=\"$mkey\">\n" if $mkey;
	  $logio = undef;
	  if( $lc != 6 && $Memadd )
	  { my($tit, $nam, $msg) = (undef, undef, (!$PTB ? 'L' : ''));
	    if( !$PTB || $PTB && $SS->{'CGI_CODE'} != 5 )
	    { $tit  = &ImgAltPut(\$IMG->{'Maddtit'}, ' o^ ', 0);
	      $tit  = '<a href="' . $SS->{'MEMB_URL'} . '?mode=amemb">' . $tit . '</a>' if $PTB;
	      $tit  = (!$PTB ? '<p>@</p>' . "\n" : $BR . $BR . "\n" . '') . $tit . $BR;
	      $nam  = &ImgAltPut(\$IMG->{'Fpass'}, 'pX[h', 0) . $BR . "\n";
	      $nam  = $IMG->{'Shik'} . ' ' . $nam if $PTB;
	      $logio = $tit . "\n";
	      if( !$ERROR )
	      { $logio .= 'Vbv̂pɂ́Ao^KvłB' . $BR if $SS->{'MEMB_TYPE'} == 3;
	        $logio .=  'o^́A' . $msg . '育o^B'; }
	      if( $PTB ){ $logio .= $BR . $BR . "\n"; return \$logio; }
	      $logio .=  $BR . $nam;
	    }
	    if( !$ERROR )
	    { $logio .= '͂߂ɁApX[h[o^tH[]֐iŉB';
	      $logio .= $BR . $BR . "\n" if $PTB; } else
	    { $logio .= $ERROR; $logio .= $BR . $BR . "\n" if $PTB; }
	    $logio .= $BR . "\n" if !$PTB;
	    $botan = &ImgAltPut(\$IMG->{'Logfadd'}, 'o^tH[', 1); }
	  elsif( !$lt )
	  { $logio = !$add ? "#MSG1#$BR$BR\n" : "#MSG2#$BR$BR\n";
	    $botan = $CGI->{'memmode'} >= 2 ? &ImgAltPut(\$IMG->{'Fnext'}, '֐i', 1) : 
		     $lc != 6 ? &ImgAltPut(\$IMG->{'Order'}, 'tH[', 1) : 
				&ImgAltPut(\$IMG->{'Fregi'}, 'ύX', 1) }
	  if( !$PTB )
	  { my $size = $lt ? ($pos ? 30 : 46) : 150;
	    my $cols = $lt && $pos ? '<td align="right"></td><td>@' : '<td>'; $hei = 17 if $lt && !$pos;
	    $logio .= "<table border=0 cellspacing=0 cellpadding=0 height=$hei CLASS=font14>\n"
		   .  "<tr>$$form<td width=\"$size\" align=\"right\" valign=\"bottom\" nowrap>". $name1
		   .  "</td>\n<td width=\"100\">" . $$inpu1;
	    $logio .= $lt ? ($pos ? "</tr>\n<tr>" : "</td><td width=\"4\"><img src=\"" . $SS->{'IMG_URL'} . "table_dam.gif\" width=\"3\" height=\"1\"></td>\n" )
			  : "</td><td width=\"150\" rowspan=\"2\" align=\"right\" valign=\"bottom\">" . $botan . "</td></tr>\n<tr>";
	    $logio .= "<td width=\"$size\" align=\"right\" valign=\"bottom\" nowrap>" . $name2 . "</td>\n";
	    $logio .= "<td width=\"100\">" . $$inpu2 . "</td>\n";
	    if( $lt )
	    { $logio .= $pos ? "</tr>\n<tr>" : "<td width=\"4\"><img src=\"" . $SS->{'IMG_URL'} . "table_dam.gif\" width=\"3\" height=\"1\"></td>\n";
	      $logio .= $cols . &ImgAltPut(\$IMG->{'LogIN'}, 'LOGIN', 1) . "</td>\n"; }
	    $logio .= "</tr></form></table>\n"; } else
	  { $logio .= $$form;
	    $logio .= $name1 . $BR . $$inpu1;
	    $logio .= $name2 . $BR . $$inpu2;
	    $logio .= $TC->{'li9'};
	    my $vala = $IMG->{'Order'} ? $IMG->{'Order'} : 'tH[';
	    $logio .= $lt ? "@<input type=\"submit\" value=\"LOGIN\"> $IMG->{'LogIN'}$BR\n"
			  : "#space#" . $botan . $BR . "\n";
	    $logio .= "</form>" . $BR;
	  }
	} \$logio;
}

sub PostFormDisp 
{	my ($action, $sc, $se, $mc, $senc, $utn) = @_;
	my ($subm, $sreg, @nam) = (undef, undef, undef);
	my @img = $se == 1 && $sc == 1 ? (&FBoCheck('Fosen', 0), &FBoCheck('Fnext', 0)) :
		  $se == 1 && $sc == 2 ? (&FBoCheck('Fosen', 0), &FBoCheck('Fkaku', 0)) :
		  $sc == 1 ? ($mc =~ /^(5|7)$/ ? undef : &FBoCheck('Freset', 0), 
			       $mc == 7 ? &FBoCheck('Fkaku', 0) : &FBoCheck('Fnext', 0)) :
		  $sc == 2 || $sc == 3 ? (&FBoCheck('Freset', 0), &FBoCheck('Fkaku', 0)) : 
		  $sc == 5 ? (&FBoCheck('Fmedi', 0), 
			     $CGI_CODE == 5 && $senc == 1 ? &FBoCheck('Fnext', 0) : 
			     $CGI_CODE == 5 && $senc == 2 ? &FBoCheck('Fregi', 0) : 
			     $CGI_CODE == 5 && $senc == 8 ? &FBoCheck('Epcan', 0)  : &FBoCheck('Fadd', 0)) :
		  $sc == 6 ? (undef, &FBoCheck('Fregi', 0))  :
		  $sc == 7 ? (undef, &FBoCheck('Fadd', 0))   :
		  $sc == 8 ? (undef, &FBoCheck('Forder', 0)) : 
		  $sc == 9 ? (undef, $senc == 7 ? &FBoCheck('Emcan', 0)  : 
				     $senc == 8 ? &FBoCheck('Epcan', 0)  : 
						  &FBoCheck('Ewith', 0)) : (undef, undef);

	my $form = &CommHidden($$action, '',  1, $utn, 1) 
		if $CGI_CODE != 10 && $sc != 8 && ($CGI->{'mode'} !~ /^lin_3\./ 
						|| $CGI->{'mode'} =~ /^lin_3\.1([A-Z])?\.8/i);
	if( $se )
	{ my $osfo  = &CommHidden($$action, '',  0, '', 0);
	     $$osfo .= '&' if $$osfo !~ /\?$/; $$osfo .= 'mode=ofor_' . $mc;
	  @nam =  (&FBoCheck('Fosen', 1), $sc == 2 ? &FBoCheck('Fkaku', 1) : &FBoCheck('Fnext', 1));
	  $sreg = $$osfo . &FormAlphaCheck("a", $CGI->{'fback'}, 1) . '&osend=' . $senc . '">'
			 . &ImgAltPut($img[0], $nam[0], 0) . '</a>' if $se == 1;
	  $subm = $$osfo . &FormAlphaCheck("c", $CGI->{'fback'}, 1) . '">'
			 . &ImgAltPut($img[1], $nam[1], 0) . '</a>'; } else
	{ @nam =  $sc == 1 ? ($mc =~ /^(5|7)$/ ? undef : &FBoCheck('Freset', 1), 
			       $mc == 7 ? &FBoCheck('Fkaku', 1) : &FBoCheck('Fnext', 1)) :
		  $sc == 2 || $sc == 3 ? (&FBoCheck('Freset', 1), &FBoCheck('Fkaku', 1)) :
		  $sc == 5 ? (&FBoCheck('Fmedi', 1), 
			$CGI_CODE == 5 && $senc == 1 ? &FBoCheck('Fnext', 1) :
			$CGI_CODE == 5 && $senc == 2 ? &FBoCheck('Fregi', 1) : &FBoCheck('Fadd', 1)) :
		  $sc == 6 ? (undef, &FBoCheck('Fregi', 1)) :
		  $sc == 7 ? (undef, &FBoCheck('Fadd', 1))  : 
		  $sc == 8 ? (undef, &FBoCheck('Forder', 1))  : 
		  $sc == 9 ? (undef, $senc == 7 ? &FBoCheck('Emcan', 1)  : 
		 		     $senc == 8 ? &FBoCheck('Epcan', 1)  : 
						  &FBoCheck('Ewith', 1)) : (undef, undef);
	  if( $mc != 7 )
	  { $subm = &ImgAltPut($img[1], $nam[1], 1); } else
	  { my $osfo  = &CommHidden($$action, '',  0, '', 0);
	       $$osfo .= '&' if $$osfo !~ /\?$/; $$osfo .= 'mode=ofor_7C';
	    $subm = $$osfo . '">' . &ImgAltPut($img[1], $nam[1], 0)  . '</a>'; }
	  if( $sc == 5 )
	  { my $msfo  = &CommHidden($$action, '',  0, '', 0);
	    my ($mfor, $flco) = 
		$CGI->{'mode'} =~ /^a/ ? ('mode=afor_', '&lcode=' . $CGI->{'lcode'}) :
		$CGI_CODE == 5 && $CGI->{'mode'} =~ /^lin_3\./ ? ('mode=lin_3.', '.' . $CGI->{'process_code'}) :
		$CGI_CODE == 10 ? ('mode=' . $CGI->{'mode'} . '&disp=mfor_', undef) : ('mode=mfor_', undef);
	    $$msfo .= '&' if $$msfo !~ /\?$/; $$msfo .= $mfor . $mc; 
	    $sreg = $$msfo . 'E' . $flco . $CGI->{'RegiData'} . '">' . &ImgAltPut($img[0], $nam[0], 0) . "</a>"; } else
	  { $sreg = !$PTB && $sc % 2 
	     ? '<a href="javascript:document.' . ($mc == 7 ? 'forms[0]' : 'Formkey') . '.reset();">'
	      . &ImgAltPut($img[0], $nam[0], 0) . "</a>" : $nam[0] ? &ImgAltPut($img[0], $nam[0], $PTB ? 2 : 1) : undef; 
	  }
	} my $submit .= !$PTB ? $BR : $TC->{'li3'};
	if( !$PTB )
	{ my $size = 150; my $align = $CGI_CODE == 5 ? 'center' : 'right';
	  $submit .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tr>\n";
	  $sreg = undef if !$nam[0] && !$img[0];
	  $submit .= "<td width=\"$size\" align=\"center\">" . $sreg . "</td>\n"
		  .= "<td width=\"$size\" align=\"$align\">" . $subm . "</td>\n"
	  	  .  "</tr>\n</table>\n"; } else
	{ $submit .= '<center>' . $sreg . ($sreg && $se == 1 ? '/' : ' ') . $subm . '</center>'; }
	$submit .= "</form>" if $mc != 7; $form, \$submit, $nam[1];
}

;######################################################################
;# y[W֘A
;######################################################################

sub PageLink
{	my ($url, $p, $co, $end, $cent) = @_;
	&SearchFormDisp(\$url, 0) if $CGI->{$SKeyCheck} || $CGI->{'uskey'};
	my $next  = $url . '&p=' . ($p + 1)  . '">' . '</a>' if $co > $end;
	my $back  = $url . '&p=' . ($p - 1)  . '">' . '߂</a>' if $p > 1;
	if( !$PTB && ($next || $back) )
	{ $next .= $IMG->{'Next2'} if $next; $back = $IMG->{'Back2'} . $back  if $back;
	  if( $cent )
	  { my $ppri = '<center>' if $cent == 1;
	    $ppri .= $back if $back; $ppri .= ' | ' if $back && $next; $ppri .= $next if $next;
	    $ppri .= '</center>' if $cent == 1;
	    $ppri .= $BR . "\n"; \$ppri; } else
	  { \$next, \$back; } } else
	{ \$next, \$back; }
}

sub PageJavaLink
{	my ($url, $name, $targ, $wid, $hei, $scro) = @_;
	my ($at, $au) = ($1, $4) if $$url =~ /(<a(.*)href=(")?)?(.*)/;
	my $link = $at || '<a href="';
	$link .= (!$PTB ? "javascript:openWin('" .  $au . "','" . $targ . "','" . 
		$wid . "','" . $hei . "','" . $scro . "');" : $au) . '">' . $name . '</a>';
}

sub PageViewCheck
{	my ($view, $p) = @_; $p = 1 if !$p;
	my $start = ($p - 1) * $view;
	my $end   = $start + $view - 1; $start, $end, $p;
}

sub PageParag
{	my ($p, $c) = (undef, shift);
	for(my $i = 0; $i < $c; $i++){ $p .= "<p>@</p>\n"; } $p;
}

sub ListPage
{	my ($url, $count, $pv, $kv, $p, $pp, $no) = @_;
	my $i = 0;
	my @num =('O','P','Q','R','S','T','U','V','W','X','PO');
	my ($view, $co) = !$PTB ? ($pv, 10) : ($kv, 5);
	my $pcount = $count / $view;
	   $pcount = $count % $view ? int($pcount + 1) : $pcount;
	my ($lplink, $c, $o) = (undef, 0, 0);
	return "" if !$count;
	&SearchFormDisp(\$url, 0) if $CGI->{$SKeyCheck} || $CGI->{'uskey'};
	$lplink .= !$PTB ? 'PAGE [ ' : 'PAGE[';
	for ($i = 1; $i <= $pcount; $i++)
	{ $c++; 
	  if( $pcount > $co && $p > 1 && $i == 2 )
	  { $i = $pcount - $p > $co - 3 ? ($p > 2 ? $p - 1 : $p) : $pcount - ($co - 2); }
	  my $numb = undef;
	  if( $i < 10 ){ $numb = $num[$i]; } 
	  else { foreach my $n (split(//, $i)){ $numb .= $num[$n]; } }
	  if( !$no && $p == $i )
	  { $lplink .=  (!$PTB ? '<b>' . $numb . '</b>' 
			       : '<font color="#CC0000">' . $numb . '</font>'); } else
	  { $lplink .= $url . '&p='; $lplink .= $pp . '.' if $pp; 
	    $numb = '<b><font color="#FF0000">' . $numb . '</font></b>'
								 if !$PTB && $no && $p == $i;
	    $lplink .= $i  . '">' . $numb . '</a>'; } 
	  last if $c >= $co; 
	} $lplink .= !$PTB ? ' ]' : ']'; \$lplink;
}

sub MobileBackLink
{	my ($url, $page, $url2, $page2) = @_;
	my @link =($URL{'CATE_URL'}, $URL->{'MEMB_URL'});
	my @mode = ( [], [ 'lin_0', 'ƭ' ], [ 'lin_1', 'x' ], 
		     [ 'lin_3', 'ޑ' ], [], [ 'lin_01', 'm点' ]);
	my $back = $TC->{'li2'} . '&lt;-' . $link[$url] . '&mode=' . 
			$mode[$page]->[0] . '">' . $mode[$page]->[1] . '</a>';
	if( $url2 )
	{ $back .= '/' . $link[$url2] . '&mode=' . 
		$mode[$page2]->[0] . ($CGI->{'P'} ? '&p=' . $CGI->{'P'} : undef) . '">' . 
			$mode[$page2]->[1] . '</a>';
	} $back .=  $BR . "\n"; \$back;
}

;######################################################################
;# MEMBERy[W֘A
;######################################################################

sub MembUidDir
{	my $uid = shift;
	$uid =~ s/^\///o;
	$uid =~ s/^([A-Z]{3})([\d]{3})([\d]{3})(\_)?$/$1\/$2\/$3$4\//; $uid;
}

sub MembOrderFileCheck
{	my $udir = shift; 
	$udir = &MembUidDir($udir);
	my $oderDir = $SS->{'MEMB_DIR'} . $udir . 'order/';
	my $cardadd = $oderDir . "Card";
	my $carddel = $oderDir . "DelCard\_" . $TIME[4];
	$oderDir, $cardadd, $carddel;
}

sub MembOrderMonthlyCheck
{	my ($sc, $udir) = (0, shift); 
	$udir = &MembUidDir($udir);
	my $userDir = $SS->{'MEMB_DIR'} . $udir . 'order/';
	foreach (sort @{Sys::FileListOpen(\$userDir)})
	{ if( /^[^\_]+\_(10|18)(\.[\d]+)?/ )
	  { my $stc = $1; $sc = $stc == 10 ? 1 : 2 if $sc != 1; last if $sc == 1; } 
	} $sc;
}

sub MembMenuName
{	my $info = shift;
	my @Menu = (!$PTB ? \$SS->{'MEMB_MENU0'} : $info ? \$SS->{'MEMB_MENUM'} : \$IMG->{'Mmtitle'}, 
		\$SS->{'MEMB_MENU1'}, \$SS->{'MEMB_MENU2'}, 
		\$SS->{'MEMB_MENU3'}, \$SS->{'MEMB_MENU4'}, '', \('ƭ')); \@Menu;
}

sub MembMenuList
{	my $menu = &MembMenuName(1);
	my $mem  = (!$PTB ? &ImgAltPut(\$IMG->{'Mmtitle'}, '@y[W', 0) 
			: $IMG->{'Shik'} . ' ' . ${$menu->[6]}) . $BR . "\n";
	my $murl = \$URL->{'MEMB_URL'};
	my $mimg = $SS->{'MEMB_MEIMG'} ? 1 : 0;
	my $time = (split(/\,/, $CGI->{'LTIME'}))[0];
	   $time =~ s/[^\/]+\/([^\(]+)\([\w]+\)(.*)/$1 . ' ' . $2/e;

	$URL->{'MEMB_URL'} =~ s/^<a href/<a class=lb href/o if !$PTB;
	$mem .= '@y ' . $URL->{'MEMB_URL'} . '&mode=lin_01">' . ${$menu->[0]} . '</a> z<br>' . "\n";

	$mem .= '@ LoginTime' . $BR . '@' . $time . $BR . "\n";
	$mem .= '@ ' . $URL->{'MEMB_URL'} . '&mode=lin_1">' . ${$menu->[1]} . '</a><br>' . "\n";
	$mem .= '@' . ($SS->{'EPSI_SET'} && ${$menu->[3]} ? ' ' : '') . 
			    $URL->{'MEMB_URL'} . '&mode=lin_2">' . ${$menu->[2]} . '</a><br>' . "\n";
	if( $SS->{'EPSI_SET'} && ${$menu->[3]} )
	{ $mem .= '@ ' . $URL->{'MEMB_URL'} . '&mode=lin_3.1.8">' . 
					${$menu->[4]} . '</a><br>' . "\n" if $CD->{'MontItem'};
	  $mem .= '@ ' . $URL->{'MEMB_URL'} . '&mode=lin_3">' . 
					${$menu->[3]} . '</a><br>' . "\n";
	}
	if( $CGI_CODE =~ /^(5|4)$/ )
	{ $mem .= '@<b></b> ' . $URL->{'MEMB_URL'} . '&mode=mfor_9">pX[hύX</a><br><br>' . "\n"; 
	  $mem .= &ContactLink(\$URL->{'MEMB_URL'}, 0); } \$mem;
}

sub ContactLink
{	my ($link, $url, $ref) = (undef, @_);
	my $mode = ($$url !~ /\?/ ? '?' : $$url !~ /\?$/ ? '&' : undef) . 'mode=lin_otoi';
	$mode .= 's' if $ref;
	$link =  ($PTB ? $IMG->{'Mail'} : '@') . &PageJavaLink(\($$url . $mode), 
	&ImgAltPut(\$IMG->{'Motoi'}, '⍇', 0), 'otoi', '580', '400', 'yes');
	$$url = $link if $ref;
	$link;
}

;######################################################################
;# [֘A
;######################################################################

sub TerminalCheck
{	local($viwlmit, %TC) = (16, undef);
	my $sky = ("K03|D03|PE03|SH04|SH04B|SH05|N03");
	my $VCookie = $SS->{'X_VODA_COOKIE'};

	$TC{'size'} = 12;
	if( $OS =~ /^(3|5|6|7)$/ 
	  || $OS eq '2c' && (!$VCookie || $OS !~ /$VCookie/) 
	  || ($OS eq "2" && ((split(/\//,$USER->{'agent'}))[1] < 3
	  || (split(/\//,$USER->{'agent'}))[1] == 3 
	  && (split(/\//,$USER->{'agent'}))[2] =~ /^J\-($sky)(S|)/)))
	  { my $ono =  $OS; $ono =~ s/[a-z]$//;
	    &Print(&ShopSysError($ono =~ /^(2|3|7)$/ ? $ono + 10 : 10));
	} elsif($OS =~ /^(1|3b|4)$/)
	{ $OS =~ s/b$//; $PTB =~ s/b$//;
	  $TC{'ine'}  = ' istyle="3"'; $TC{'ins'} = ' istyle="4"';
	  if($OS == 1)
	  { $TC{'utn'} = ' utn'; $TC{'kid'} = $USER->{'agent'};
	    if($TC{'kid'} =~ /(\;|\/)(ser[A-Za-z0-9]+).*/){ $TC{'kid'} = $2; } 
	    else { undef $TC{'kid'}; } } else 
	  { $TC{'cook'} = 1;
	    $TC{'clc'} = ' /' if $OS == 3; $viwlmit = 20 if $OS == 4; }
	  $viwlmit = $1 if $OS == 1 && (split(/\//,$USER->{'agent'}))[5] =~ /W([\d]+)H([\d]+)/;
	  $viwlmit = $1 if $OS == 3 && $ENV{'HTTP_X_UP_DEVCAP_SCREENCHARS'} =~ /([\d]+)\,([\d]+)/;
	} elsif($OS =~ /^2/)
	{ my $midc = $OS eq "2b" ? 4 : 3;
	  if( $OS eq "2" || !$VCookie || $OS !~ /$VCookie/ )
	  { $TC{'kid'} = (split(/\//,(split(/ /,$USER->{'agent'}))[0]))[$midc]; } else
	  { $TC{'cook'} = 1; } $OS = 2;
	  $TC{'ine'} = ' MODE="alphabet"'; $TC{'ins'} = ' MODE="numeric"'; } else
	{ ($TC{'cook'}, $TC{'size'}, $viwlmit) = (1, 24, 64); }
	&LineCheck(); \%TC;
}

sub LineCheck
{	my ($lineO, $lineT);
	for($li = 0; $li < $viwlmit; $li++){ $lineO .= '-'; $lineT .= '='; }
	$TC{'li0'} = "----------<br$TC{'clc'}>\n";
	$TC{'li1'} = "==========<br$TC{'clc'}>\n";
	$TC{'li2'} = " - - - - -<br$TC{'clc'}>\n";
	$TC{'li3'}  = "<center>$lineO</center>\n";
	$TC{'li4'}  = "<center>$lineT</center>\n";
	$TC{'li5'}  = "$lineO<br$TC{'clc'}>\n";
	$TC{'li6'}  = "$lineT<br$TC{'clc'}>\n";
	$TC{'ml1'}  = $lineO;
	$TC{'ml2'}  = $lineT;
	undef $lineO;
	$viwlmit = int ($viwlmit / 2 );
	for($li = 0; $li < $viwlmit; $li++){ $lineO .= '';  }
	$TC{'li7'}  = "<center>$lineO</center>\n";
	$TC{'li8'}  = "$lineO<br$TC{'clc'}>\n";
	$TC{'li9'} = "<br$TC{'clc'}>\n";
	$TC{'hr1'}  = "<hr size=\"1\"$TC{'clc'}>\n";
	$TC{'hr2'}  = "<hr size=\"2\"$TC{'clc'}>\n";
}

sub MobileDataDisp
{	my $bodydat = shift;
	my ($cuta, $cutb, $cutc) = ('\(|\[|||||', '\*|\)|\]', '\x81\x40|<(\/)?b>');
	$Opt = 'h';
	$URL->{'HOME_URL'} = $IMG->{'Home'} . 
				"<a href=\"" . $URL->{'HOME_URL'} . "\">Home</a>";
	$$bodydat = $BR . $$bodydat if $$bodydat !~ /^<form/ && $$bodydat !~ /^<br/;
	$$bodydat =~ s/<\/option>//g if $OS == 1;
	$$bodydat =~ s/($cuta) /$1/g; $$bodydat =~ s/ ($cutb)/$1/g; 
	$$bodydat =~ s/($cutc)//g; 
	$$bodydat =~ s/(<br>([\n]+)?)*(<br>([\n]+)?<br>([\n]+)?)<br>([\n]+)?/$3/g;
	$$bodydat =~ s/\#space\#/@/g;
	$$bodydat =~ s/( )?F( )?/\:/g;
	$$bodydat =~ s/\#(li[\d]+|clc)\#/$TC->{$1}/g;
}

;######################################################################
;# t@C֘A
;######################################################################

sub FileListOpen
{	my $diropen = shift;
	my @filelist;
	opendir(DIR, "$$diropen"); @filelist = readdir(DIR); closedir(DIR); \@filelist;
}

sub FileOpen
{	my ($file, $type, $errpn) = @_;
	my $noCate = &CategCheck($$file);
	my (@ADATA, %HDATA, $CDATA, $linekey, $lineval, $line);
	local($_);
	if(!open(FILES, "<$$file"))
	{ $$file = 'FileOpen' . $type if !$$file; 
	  if( $errpn == 2 ){ my $error = "ERROR"; return $error; }
	  elsif( $errpn == 1 ){ $TMPFILE_NOCHENG = 1; &ShopSysError(54, "Can't Open $$file"); } 
	  else{ &Print(&ShopSysError(54, "Can't Open $$file")); } } else 
	{ if( !$type )
	  { @ADATA = <FILES>; } else
	  { while (<FILES>)
	    { if( $type == 1 )
	      { next if /^\#\#/;
		if(/^\#LIST_LINE\#(.*)(\r)?\n/){ $LIST_LINE = $1; next; }
		elsif(/^\#LIST\_TOP\#(.*)(\r)?\n/){ $LIST_TOP = $1; next; }
		elsif(/^\#LIST\_END\#(.*)(\r)?\n/){ $LIST_END = $1; next; }
		$CDATA .= $_; } else 
	      { s/(\r)?\n$//g;
		if( $type == 4 )
		{ next if $_ !~ /^($Lmatc)?SYS\_Priority/; $_ =~ s/^($Lmatc)?SYS_Priority//o; }
		elsif( $type == 5 )
		{ next if $_ !~ /^($Lmatc)?shop\_date/; }
		elsif( $type == 6 )
		{ next if $_ !~ /^($Lmatc)?OP\_/ || $_ =~ /^($Lmatc)?OP\_[\d]+\-/; }
		if( $line )
		{ if($line == 1 && $_ eq '_LINE_END_' ){ $line = 0; next; }
		  elsif($line =~ /^(\"|\')$/ && $_ =~ /(.*)$line/ ){ $line = 0; $_ = $1; }
		  if( $type != 3 ){ $HDATA{$linekey} .= $_ . "\n"; }
		  else { $lineval .= $_ . "\n"; push(@ADATA, $lineval) if !$line; }
		  next; }
	  	if(/^($Lmatc)?([\w\-\^\.]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/)
		{ my $key = $2; my $val = $6 || $7 || $8; 
		  next if $noCate && $key !~ /^[0]+$/ 
			|| !$noCate && $key =~ /^[0]+$/ || $key =~ /^rank/;
		  if(/^($Lmatc)?([\w\-\^\.]+)($Lmatc)?\=($Lmatc)?(\"|\')(.*)/)
		  { my $valc = $6; $line = $5;
		    unless (/^($Lmatc)?([\w\-\^\.]+)($Lmatc)?\=($Lmatc)?$line([^$line]*)$line/)
		    { if( $type != 3 ){ $HDATA{$key} = $valc . "\n"; } 
		      else { $lineval = $key . '|' . $valc . "\n"; } } else 
		    { undef $line; }
		  } $line = 1 if $val eq '_LINE_';
		  if( $line ){ $linekey = $key; next; }
		  if( $type != 3 )
		  { $HDATA{$key} = $val; } else 
		  { push(@ADATA,"$key\|$val"); }
		}
	      }
	    }
	  } close(FILES); $CD->{'000'} = 'ACeꗗ' if $noCate && !$CD->{'000'};
	} $type == 1 ? \$CDATA : $type && $type != 3 ? \%HDATA : \@ADATA;
}

sub FilePrintOpen
{	my ($file, $binary) = @_;
	if(!open(TMPFILE, ">$$file"))
	{ $$file = 'FilePrint' . $type if !$$file; 
	  &ShopSysError(52, "Can't Print $$file"); return 1; }
	eval 'flock(FILEP,2);'; return 0;
}

sub FileDataPrint
{	my $data = shift;
	print TMPFILE $$data; return 0;
}

sub FilePrintClose
{	my ($file, $tmp) = @_;
	close(TMPFILE);
	rename($$tmp, $$file) if $$file; return 0;
}

sub FilePrint
{	my ($file, $data, $type, $binary) = @_;
	$fdisp = !$type ? ">$$file" : ">>$$file";
	if(!open(FILEP, $fdisp))
	{ $$file = 'FilePrint' . $type if !$$file; 
	  &Print(&ShopSysError(53, "Can't Print $$file")) if !$ERROR_LOG; } else
	{ eval 'flock(FILEP,2);';
	  if( $binary ){ binmode(FILEP); binmode(STDOUT); }
	  print FILEP $$data . (!$binary ? "\n" : undef);
	  close(FILEP);
	} return 0;
}

;######################################################################
;# ETC f[^[
;######################################################################

sub CategCheck
{	my $file = shift;
	my $confc = $SS->{'CATE_CONF'}; $confc =~ s/\./\\./;
	$confc && !$SS->{'CATE_TYPE'} && $file =~ /$confc$/ ? 1 : 0;
}

sub PriceCheck
{	my $price = shift;
	my @kakaco = split(//,$$price);
	my ($kanma, $pey) = 1;
	for($i = $#kakaco; $i >= 0; $i--)
	{ my $priche = $kanma % 3;
	  if( !$priche && $i ){ $kakaco[$i] = "," . $kakaco[$i]; }
	  $pey = $kakaco[$i] . $pey; $kanma++; } \$pey;
}

sub DateEndDayCheck
{	my ($d, $y, $m) = (undef, @_);
	if($m != 2)
	{ $d = $m =~ /^(4|6|9|11)$/ ? 30 : 31; } else 
	{ $d = $y % 4 ? 28 : 29; } sprintf("%02d", $d);
}

sub IsalphaCheck
{	my ($is, $c) = @_;
	my @lower = ('a','b','c','d','e','f','g','h','i','j','k','l','m',
		     'n','o','p','q','r','s','t','u','v','x','y','z');
	my @upper = ('A','B','C','D','E','F','G','H','I','J','K','L','M',
		     'N','O','P','Q','R','S','T','U','V','X','Y','Z');
	for($i = 0; $i < 25; $i++)
	{ if( $c == 1 && $lower[i] eq $is ){ $is = $upper[i+$n]; last; }
	  elsif( $c == 2 && $upper[i] eq $is){ $is = $lower[i+$n]; last; } } $is;
}

sub FormAlphaCheck
{	my ($is, $c, $p) = @_;
	$is = $is eq 'a' &&  $c && $p ? 'A' : $is eq 'a' &&  !$c && $p ? 'a' :
	      $is eq 'n' &&  $c ? 'N' : $is eq 'c' && $c ? 'C' :
	      $is eq 'a' && !$c ? 'k' : $is eq 'A' && $c ? 'K' : 
	      $is eq 'k' && !$c ? 'k' : $is eq 'k' && $c ? 'K' : 
	      $is eq 'e' && !$c ? 'r' : $is eq 'E' && $c ? 'R' : $is;
}

;######################################################################
;# [֘A
;######################################################################

sub AdminMail
{	my ($uinfo, $errc, $mailmsg, $smail) = (undef, 0, @_);
	if( !$SYSERR && !$SS->{'LimitMail'} )
	{ $uinfo = "\n\n";
	  $uinfo .= "Date : $TIME[10]\n";
	  $uinfo .= "Browser : $USER->{'agent'}\n";
	  $uinfo .= "Host : $USER->{'host'}\n";
	  $uinfo = &JmclConv($uinfo, 'jis', 'sjis', 'mz', '', 0); }
	for ( 0 .. $#MAS_MAILS )
	{ if( !$NoMail && ($MAS_MAILS[$_] !~ /^$Mmatc$/
	   || !open(SMAIL,"| $SS->{'SENDMAIL'} -oi $MAS_MAILS[$_]")) )
	  { $MAILERROR = 1; &ErrorLog("110 : Can't Sendmail (Admin)"); last; } else
	  { my $mMsg = &MailMsgDisp($$mailmsg, $MAS_MAILS[$_], 0); return 0 if $NoMail;
	    print SMAIL "X-Mailer: SHOP SYS MAIL Ver1.0 (c) PMCJ\n";
	    print SMAIL $Prior if $Prior;
	    print SMAIL "Subject: $subje\n";
	    print SMAIL "From: " . ($smail ? $smail : $SS->{'MAIL_FROM'} ? $MAIL_FROM : '"SHOP System" <MAILER-DAEMON>') . "\n";
	    print SMAIL "To: $TO_MAILS[$_]\n";
    	    print SMAIL "Reply-To: $smail\n" if $smail;
	    print SMAIL "Content-Transfer-Encoding: 7bit\n";
	    print SMAIL "Content-Type: text/plain; charset=iso-2022-jp\n\n";
	    print SMAIL $$mMsg;
	    print SMAIL $uinfo;
	    print SMAIL "\n";
	    close(SMAIL); } } return $MAILERROR;
}

sub UserSend
{	my ($mailmsg, $umail) = @_;
	if( !$NoMail && !open(CMAIL,"| $SS->{'SENDMAIL'} -oi $umail") )
	{ $MAILERROR = 1; &ErrorLog("111 : SYS_ERROR_UserMailCommand( $umail )"); return 1; } else
	{ my $mMsg = &MailMsgDisp($$mailmsg, $umail, 1); return 0 if $NoMail;
	  print CMAIL "X-Mailer: WEB SHOP Mail Ver1.0 (c) PMCJ\n";
	  print CMAIL "Subject: $subje\n";
	  print CMAIL "From: $MAIL_FROM\n";
	  print CMAIL "To: $umail\n";
    	  print CMAIL "Reply-To: $MAIL_FROM\n";
	  print CMAIL "Content-Transfer-Encoding: 7bit\n";
	  print CMAIL "Content-Type: text/plain; charset=iso-2022-jp\n\n";
	  print CMAIL $$mMsg;
	  print CMAIL "\n";
	  close(CMAIL); } return 0;
}

sub TerminalMailData
{
	$PtbMail = 'docomo|ezweb|vodafone|jp.[a-z]|pdx';
	@MlineO = ('----------------------------------------------------------', 
		   $CGI->{'eOS'} ? '----------------' : $TC->{'ml1'});
	@MlineT = ('==========================================================', 
		   $CGI->{'eOS'} ? '================' : $TC->{'ml2'});
	if( $OS == 1 && !$CGI->{'eOS'} ){ $MlineO[1] =~ s/\-\-$//o;  $MlineT[1] =~ s/\=\=$//o; }
}

sub SendMail
{	my ($error, $subject, $mailmsg, $umail) = (0, @_);
	local($MAIL_FROM, $PtbMail, @MlineO, @MlineT, @MAS_MAILS, @TO_MAILS);
	local($SYS) = &FileOpen(\($SS->{'CONF_DIR'} . $SS->{'MAN_CONF'}), 4, 2) if !$SYS;
	local(@Priority) = ('', "X-Priority: 5\nX-MSMail-Priority: Low\n", 
				"X-Priority: 3\nX-MSMail-Priority: Normal\n",
				"X-Priority: 1\nX-MSMail-Priority: High\n");
	&TerminalMailData();
	my $check = $SYSERR ? 1 : $MEMADD_MAIL || $MEMB_MAIL ? 2 : $EPS_MAIL ? 3 : 0;
	my $type  = $check ? 3 : $CGI_CODE == 5 ? 2 : 0;
	my $subj  = !$SYSERR && $ORDER_MAIL ? $SS->{'ORDER_ADMIMSUBJ'} : $$subject;
	$subj = '' if !$subj;
	&MailCheckDisp($type, $check);
	local($subje)  = &JmclConv($subj, 'b64', 'sjis', 'jmz', '', 0);
	local($Dismsg) = $MEMB_MAIL || $EPS_MAIL ? $$subject : undef;
	local($Prior)  = $Priority[$check == 1 ?  $SYS->{'ErMail'} : 
					$ORDER_MAIL ? $SYS->{'OrMail'} : $SYS->{'MeMail'}];
	$error = &AdminMail($mailmsg, $umail);
	&MembMailLock() if !$error && $CGI_CODE == 5 && $CGI->{'mode'} =~ /^lin\_otoi/;
	return $error if !$umail || $SYSERR || $CGI->{'mode'} =~ /^lin\_otoi/ && !$CGI->{'copy'};
	&UserSend($mailmsg, $umail);
}

sub MailTempleDisp
{	my ($mailtmple, $maddmsg, $mailmsg) = ($SS->{'CMF_TMP'}, undef, shift);

	$mailmsg = $MAILMSG if ($MEMADD_MAIL || $MEMB_MAIL) && $MAILMSG;
	$mailmsg = $MAILMSG || $MINFOR if !$mailmsg;

	my $cardmsg = 0;
	if( ($ORDER_MAIL || $MEMADD_MAIL) && !$Convi ) 	  
	{ if($ORDER_MAIL && $mailmsg =~ /\- CARD INFOR \-/ )
	  { foreach my $msg (split(/\n/, $mailmsg))
	    { $cardmsg = $msg =~ /\-[\s]+CARD INFOR[\s]+\-/ ? 1 : 
				$msg =~ /\-[\s]+CARD END[\s]+\-/ ? 2 : 
						$cardmsg == 2 ? 0 : $cardmsg;
	      next if $cardmsg;
	      $maddmsg .= $msg . "\n"; } $mailmsg = $maddmsg; undef $maddmsg;
	  }
	  if( $DIS_CODE == 10 && $CGI->{'MEMB_ID'} || $DIS_CODE == 3 || $DIS_CODE == 31 )
	  { if( $CGI->{'MEMB_ID'} )
	    { my ($ssl, $pri) = (undef, 0);
	      foreach (@{&FileOpen(\($SS->{'MAI_TMP'} . 'madd_mail.dat'), 0, 1)})
	      { $pri = !$MEMADD_MAIL && $_ =~ /ORDER_MAIL\_PRINT/ || $DIS_CODE == 10 || $pri ? 1 : 0;
		last if $MEMADD_MAIL && $_ =~ /ORDER_MAIL\_PRINT/;
		next if /^##/ || !$pri;
		if( /\#MEMB\_URL(\_SSL)?\#/ )
		{ $ssl = $1; &DmainSslCheng(\$SS->{'MEMB_URL'}, 3) if $ssl;
		  s/\#MEMB\_URL(\_SSL)?\#/$SS->{'MEMB_URL'}/o; } else
		{ s/\#([\w]+)\#/$CGI->{$1}/o; } $maddmsg .= $_;
	      }
	    } $mailmsg = $maddmsg . $mailmsg;
	    my $defno = 0;
	    if( $MEMADD_MAIL )
	    { return $mailmsg; } else
	    { if( $CGI->{'st_code'} !~ /[\d]+\-[\d]+\-[\d]+/ )
	      { $defno = 70; $mailtmple .= $CGI->{'st_code'} + 70; } else
	      { ($defno, $Convi) = Eps::EpsMailTempleDisp(\$mailtmple, $term); }
	      $mailtmple .= '.dat';
	      if( !(-f $mailtmple) && $defno ){ $mailtmple =~ s/\_[\d]+(\.dat)$/\_$defno$1/o; }
	    }
	  } } else
	{ $Dismsg =~ s/(.*)ʒm(.*)$/ $1e /o if $Dismsg;
	  $mailtmple .= ($MEMB_MAIL || $EPS_MAIL ? '0' : 
				$DIS_CODE == 32 ? '50' : $ED->{'conveni_code'}) .  '.dat';
	  if( $DIS_CODE == 32 ){ return 0 if !(-f $mailtmple); } 
	} 
	my ($subject, $temple, $c) = (undef, undef, 0);
	foreach (@{&FileOpen(\$mailtmple, 0, 1)})
	{ s/(\r)?\n$//o;
	  if( !$c && $_ =~ /^\#mail\_subject\#(.*)/ )
	  { $subject = $1; $subject .= ' [ '. $Subsubj . ' ]' if $Subsubj; next; }
	  next if $Convi == 2 && $_ =~ /(\#ORDER\_MSG\#|\#CONVE\_NOTMSG\#)/;
	  s/\#user\_name\#/$CGI->{'user_name'}/o;
	  if( $ORDER_MAIL )
	  { s/\#ORDER\_MSG\#/$mailmsg/o; s/#CONVE\_NOTMSG\#//; } else
	  { $mailmsg .= "[ VPASS ]\t" . $CGI->{'upass'} . "\n" 
			if $CGI->{'upass'} && /\#disp\_msg\_pass\#/;
	    s/\#disp\_msg(\_pass)?\#/$Dismsg\n$mailmsg/o; 
	  } Eps::EpsConvDataConvert() if $DIS_CODE != 32 && $ED->{'payment_code'} == 3;
	  $temple .= $_ . "\n"; $c++;
	} return 1 if $SYSERR;
	my $subj = $Convi != 2 && $ORDER_MAIL && $SS->{'ORDER_USERSUBJE'}
			 ? $SS->{'ORDER_USERSUBJE'} : $subject ? $subject : '';
	$subje = &JmclConv($subj, 'b64', 'sjis', 'jmz', '', 0);
	!$temple ? $mailmsg : $temple;
}

sub MailMsgDisp
{	my ($mailmsg, $mail, $usend) = @_;

	local($term) = $mail =~ /\@([a-z]\.)?$PtbMail\.ne\.jp$/i ? 1 : 0;
	if( $usend )
	{ if( $CGI_CODE == 5 && $CGI->{'mode'} =~ /^lin\_otoi/ )
	  { $mailmsg .= '̃[̓Rs[[łB' . "\n"; } else
	  { $mailmsg = &MailTempleDisp($mailmsg); }
	  return 1 if $SYSERR;
	  my $mailfoot = $SS->{'MAI_TMP'} . ($term ? 'mailfut_k.dat' : 'mailfut_p.dat');
	  $mailmsg .= ${&FileOpen(\$mailfoot, 1, 1)} if -f $mailfoot; } 
	elsif( !$SYSERR )
	{ if( $CGI->{'MEMB_ID'} )
	  { $mailmsg = "VKo^\t[ USER-ID ]\n$CGI->{'MEMB_ID'}\n\n" . $mailmsg; } 
	  elsif( $CGI->{'mode'} =~ /^lin\_3/ )
	  { $mailmsg = "$Subsubj\n" . $mailmsg; }
	  elsif( $CGI->{'uid'} )
	  { $mailmsg = "\t[ USER-ID ] $CGI->{'uid'}\n\n" . $mailmsg; } 
	  elsif( $DIS_CODE == 32 )
	  { $mailmsg = " $SS->{'ORDER_ADMIMSUBJ'} \n\n" . $mailmsg; }
	}
	$mailmsg =~ s/\#LINE\_O\#/$MlineO[$term]/g;
	$mailmsg =~ s/\#LINE\_T\#/$MlineT[$term]/g;
	if( $term )
	{ $mailmsg =~ s/() /$1/g; $mailmsg =~ s/([^\:]+)\:/$1\n/g; 
	  $mailmsg =~ s/(\x81\x40|\.\n)//g; $mailmsg =~ s/\#space\#/@/g;
	  $mailmsg =~ s/\#Moji\_([A-Z0-9]+)\#/$IMG->{$1}/ig; $mailmsg =~ s/\t/\n/g; } else
	{ $mailmsg =~ s/(\t|(\])(Tel))/$2 $3/g; $mailmsg =~ s/\.\n/\n/g; $mailmsg =~ s/\#Moji\_([A-Z0-9]+)\#//ig; }
	$mailmsg = &JmclConv($mailmsg, 'jis', 'sjis', 'vmz', '', 0); \$mailmsg;
}

sub MailCheckDisp
{	my ($set, $type, $check) = (0, @_);
	my $command = 'cat ' . $SS->{'MEMB_DIR'} . $MANAG_HEDID . '/*/*/.info | grep Mail=';
	undef @MAS_MAILS; undef @TO_MAILS;
	return 0 if !$SS->{'MEMB_DIR'} || $type > 3 || $type < 0;

	if(!open(FD, "$command |"))
	{ &Print(&ShopSysError(60, "Can't CatCommand $command")); }
	while (<FD>)
	{ if(/^($Lmatc)?([\w]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/)
	  { my $key = $2; my $val = $6 || $7 || $8; 
	    my @Mail  = split(/\,/, $val);
	    next if !$Mail[$type];
	    if( $ORDER_MAIL && $Mail[0] || !$ORDER_MAIL && $Mail[2] )
	    { $MAIL_FROM = &JmclConv('"' . $Mail[4] . '" <' . $Mail[5] . '>', 
						'b64', 'sjis', 'jmz', '', 0); }
	    if( $check eq 'add' )
	    { if( $Mail[$type] && $Mail[6] ne $UIDC ){ $set = $type . ',' . $Mail[6]; last; } }
	    elsif( 
	     $type != 3 && ($ORDER_MAIL && $Mail[1] || !$ORDER_MAIL && $Mail[$type] ) || 
	     $type == 3 && ($Mail[3] == 5 || $check =~ /^(2|3)$/ && $Mail[3] == 4 || $check == $Mail[3] ) )
	    { push(@MAS_MAILS, $Mail[5]);
	      push(@TO_MAILS, &JmclConv('"' . $Mail[4] . '" <' . $Mail[5] . '>', 
						'b64', 'sjis', 'jmz', '', 0)); }
	  }
	} close(FD);
	if( !$NoMail && $check ne 'add' && !$MAS_MAILS[0] )
	{ if( $type == 2 && !$SYSERR ){ &ShopSysError(61, "Not Mail $type");  } 
	  elsif($type <= 1 ){ &Print(&ShopSysError(62, "Not Mail $type")); }
	} $set;
}

sub OrderMailNotiDisp
{	my ($mailmsg, $error) = (shift, undef);
	local($Convi) = $DIS_CODE == 32 ? 1 : 0;
	local($ORDER_MAIL) = 1 if $DIS_CODE =~ /^(3|31|32)$/;
	$mailmsg = \$MAILMSG if $DIS_CODE =~ /^(3|5|31|32)$/ || $SS->{'LimitMail'};

	if( &SendMail($SS->{'LimitMail'} ? \("WES SHOP System CZX") : undef, 
		$mailmsg, $DIS_CODE != 32 ? $CGI->{'user_mail'} : $CGI->{'user_mail_add'}) )
	{ return ${(ShopSysError(110))[0]} if $DIS_CODE != 32; }
	$ORDER_MAIL = 0; 
	if( $DIS_CODE != 32 && $Convi )
	{ local($PtbMail, @MlineO, @MlineT);
	  &TerminalMailData();
	  $Convi = 2; &UserSend(undef, $CGI->{'user_mail'}) }
	if( $DIS_CODE =~ /^(3|31)$/ && $CGI->{'MEMB_ID'} )
	{ &MembMailNotiDisp(1, undef); }
}

sub MembMailNotiDisp
{	my ($mailmsg, $error, $subject, $dis, $name, $ef) = ($MINFOR || $MAILMSG, undef, undef, @_);
	my $id = '' . ($dis != 1 ? $CGI->{'uid'} : $CGI->{'MEMB_ID'});
	my $umail = $CGI_CODE == 5 ? $CGI->{'user_mail'} : undef;
	local($Subsubj) = $name; $name =~ s/$/ʒm/o;
	if( $dis == 1 )
	{ $MEMADD_MAIL = 1; $MAILMSG =~ s/\#(MEMB\_ID)\#/$CGI->{$1}/o if $CGI_CODE == 5;
	  $subject = "o^ [ $id ]"; }
	elsif( $dis == 2 ){ $MEMB_MAIL = 1; $subject = "$name [ $id ]"; }
	elsif( $dis == 3 ){  $EPS_MAIL = 1; $subject = "$name [ $id ]"; }
	undef $CGI->{'upass'} if $ef < 9;
	$mailmsg = '#LINE_T#' . "\n\n" . $mailmsg;
	$error = ${(ShopSysError(110))[0]} if &SendMail(\$subject, \$mailmsg, $umail);
	$error;
}

;######################################################################
;# Qbgf[^[ & Conft@C 
;######################################################################

sub SysEngine
{	my $data = shift;
	my ($c, $inc) = 0;
	my ($datout, $len) = &EngiInDat(1 ,$data);
	my $command = $SS->{'SYSENGINE'} . " -S";
	   $command .= " -l " . $len if $SS->{'OS_TYPE'};

	local($ES, $ED, $IMG, $ENGINE_END);
	local($Formout, $Itemout, $Pupout, $Pupfile, $Puptmp) = (0, 0, 0, undef, undef);
	local($DisPrint) = $CGI_CODE != 10 || $CGI->{'sercate'} eq '.check2' ? 1 : 
			   $CGI_CODE == 10 && $DMO =~ /^3:1/ && 
				($CGI->{'disp'} =~ /^R./ || $CGI->{'searkey'}) ? 2 : 0;
	#$SIG{CHLD} = \&waitpid;
	&Print(&ShopSysError(90, "Not InData for $SS->{'SYSENGINE'}")) if !$len;
	$SS->{'SYSENGINE'} = 'Not WSEngine' if !$SS->{'SYSENGINE'};
	&Print(&ShopSysError(91, "chmod $SS->{'SYSENGINE'}"))
		if !$SS->{'OS_TYPE'} && !(-x $SS->{'SYSENGINE'}) || 
			$SS->{'OS_TYPE'} && !(-f $SS->{'SYSENGINE'});
	&Print(&ShopSysError(92, $SS->{'SYSENGINE'})) if( !(open2(RE, WR, "$command")) );
	print WR "$$datout"; close(WR); undef $$datout;
	while (<RE>)
	{ s/(\r)?\n$//g;
	  if(/\_ENGIN\_END\_/){ $ENGINE_END = 1; }
	  if( !$ENGINE_END )
	  { if(/^SYSTEM\_ERROR\^((.*)ENG\_[A-Z]+\_ERROR ([\d]+) (.*))/)
	    { $ERROR = $1; $ENO = int($3); $SYSTEM_ERROR = 1; last; }
	    elsif(/\_ENGIN\_END\_/){ $ENGINE_END = 1; }
	    elsif(/^(\d)\^([\w\-]+)\=(.*)/){ last if &EngGetDat($1, $2, $3); }
	    elsif(/^([\w]+)\^(.*)/){ &EngGetDat($1, $2, undef); }
	    elsif($Formout || $Itemout || $Pupout){ &EngGetDat(undef, $_); }
	  }
	} close(RE); &EngDatCheck(); $ES, $CD, $ED, $IMG, $CG;
}

sub ItemGetDat
{	if( $get[0] eq 'ILS' ){ $Itemout = 1; return 0; } 
	elsif( $get[0] eq 'ITS' ){ $Itemout = 2; return 0; } 
	elsif( $get[0] eq 'IES' ){ $Itemout = 3; return 0; } 
	elsif( $get[0] eq 'ILE' ){ $Itemout = 0; } 
	elsif( $get[0] eq 'IPS' )
	{ if( $DisPrint != 1 ){ $Pupout = 1; return 0  }
	  $Pupfile = $get[1]; $Puptmp = $Pupfile . '_tmp';
	  $Pupout = &FilePrintOpen(\$Puptmp) ? 2 : 1; return 0; }
	elsif( $get[0] eq 'IPE' )
	{ &FilePrintClose(\$Pupfile, \$Puptmp) if $DisPrint == 1 && $Pupout == 1; 
	  $Pupout = 0; } 
	if( $Pupout == 2 ){ return 0; }
	elsif( $Itemout == 1 || $Pupout == 1)
	{ $get[1] =~ s/#IMG_([A-Z0-9\/]+)#/&ItemImagDisp($1, $Itemout)/ie 
						if $CGI_CODE != 10 && !$Pupout;
	  $get[1] =~ s/^[\t\x20]+(<br>)?$//i;
	  if( $Pupout == 1 )
	  { if( $DisPrint == 1 ){ print TMPFILE $get[1] . "\n"; } 
	    elsif( $DisPrint == 2 ){ push(@FORM, $get[1]); } 
	    else { study $FORM; $FORM .= $get[1] . "\n"; } }
	  elsif( $Itemout == 1 )
	  { if( $DisPrint == 2 ){ push(@ITEMLIST, $get[1]); } 
	    else { $ITEMLIST .= $get[1] . "\n"; } }
	}
	elsif( $Itemout == 2 ){ $LISTTOP .= $get[1] . "\n"; }
	elsif( $Itemout == 3 ){ $LISTEND .= $get[1] . "\n"; }
	return 0;
}

sub FormGetDat
{	if( $get[0] eq 'FS' )
	{ ($Olim, $Plim) = MembOrderTimeDisp(1) if $CGI_CODE == 10 && !$CGI->{'disp'}; 
	  $Formout = 1; undef $FORM; return 0; } 
	elsif( $get[0] eq 'MS' ){ $Formout = 2; }
	elsif( $get[0] =~ /^(F|M)E$/ ){ $Formout = 0; } 
	elsif( $Formout )
	{ return 0 if !$get[1] || $get[1] =~ /^[\x20]+$/; 
	  if( $Formout == 2 )
	  { $get[1] = undef if $get[1] eq '.'; $get[1] =~ s/<br>(\n)?/$1 || " "/e;
	    study $MAILMSG; $MAILMSG .= $get[1] . "\n"; return 0; }
	  elsif( !$CGI->{'csvdown'} )
	  { $get[1] =~ s/\#BO\_([A-Za-z0-9]+)\#/&FBoCheck($1, 1)/ieg 
				    if $get[1] =~ /\#BO\_[A-Za-z0-9]+\#/;
	    if( $CGI_CODE == 10 )
	    { $get[1] =~ s/\#\_(([A-Z0-9]+)(\_)?)\_\#(<\/b>)/$2 . $4 
			. &MembUserPutData($1, 0)/eo if $get[1] =~ /\#\_[A-Z0-9]+(\_)?\_\#/;
	      if( $CGI->{'mode'} =~ /^1\.1\:3/ && $get[1] =~ /<img src\=\"([a-z\.\/]+)/ )
	      { my $img = $1; 
		$get[1] =~ s/(<img src\=)(\")?([\w\.\/\-]+)\/([\w\-\.]+\.[a-z]+)(\")?/$1 . 
				'"' . $SS->{'SHO_IMG'} . $4 . '"'/eio if $img !~ /^http/; }
	    } study $FORM; $FORM .= $get[1] . "\n"; } 
	  elsif( $CGI_CODE == 10 ){ &ManageDown($get[1]); } 
	} return 0;
}

sub FBoCheck
{	my ($key, $np) = @_;
	my ($val, %P);
	$I = &FormBoName() if !$I;
	if( $np )
	{ $val = !$PTB || $PTB && !$IMG->{$key} ? $I->{$key} : $IMG->{$key};
	  $val = undef if $val =~ /^<(img|inp|a)/; return $val; } else
	{ $val = !$PTB || $PTB && $IMG->{$key} ? $IMG->{$key} : $I->{$key}; return \$val; }
}

sub FormBoName
{	my %I;
	%I = $PTB ? 
	( 'Fnext'  => '', 'Freset' => '',     'Fkaku'  => 'mF',
	  'Fmedi'  => 'C', 'Fadd'   => 'o^',     'Fosen'  => '͐ǉ',
	  'Fregi'  => 'ύX', 'Memadd' => 'o^̫', 'Forder' => '',
	  'Ewith'  => 'މ', 'Emcan'  => 'މ', 'Epcan'  => 'ۋ' ) :
	( 'Fnext'  => '֐i', 'Freset' => '̓NA',   'Fkaku'  => 'mF',
	  'Fmedi'  => '͏C', 'Fadd'   => 'o^',     'Fosen'  => '͐悫ǉ',
	  'Fregi'  => 'ύX', 'Memadd' => 'o^tH[', 'Forder' => '',
	  'Ewith'  => 'މ', 'Emcan'  => 'މ',     'Epcan'  => 'ۋ' ); \%I;
}

sub EngGetDat
{	local(@get) = @_;
	if($get[0] =~ /^[\d]$/)
	{ if( $get[1] =~ /^ERROR_([\d]+)/ ){ $ENO = int($1); $ERROR = $get[2]; return 0; }
	  if( $get[0] == 1 )
	  { $SS->{$get[1]} = $get[2]; 
	    if( $get[1] eq 'IMAGE_MAGICK' && ($DIS_CODE == 1 || $CGI_CODE == 10) )
	    { $SS->{$get[1]} = 2 if $get[2] == 1 && &ModuleCheck(2);
	      &ImgMagLib() if $SS->{$get[1]} == 2;
	    }
	  } 
	  elsif( $get[0] == 2 ){ $ES->{$get[1]} = $get[2]; } 
	  elsif( $get[0] == 3 ){ $CD->{$get[1]} = $get[2]; }
	  elsif( $get[0] == 4 ){ $ED->{$get[1]} = $get[2]; } 
	  elsif( $get[0] == 5 ){ $CGI->{$get[1]} = $get[2]; } 
	  elsif( $get[0] == 7 ){ $MINFOR .= $get[1] . "\n"; } 
	  elsif( $get[0] == 0 ){ $IMG->{$get[1]} = $get[2]; } } else
	{ if($get[0] eq 'C'){ $COPYR .= $get[1] . "\n"; }
	  elsif( $get[0] =~ /^I[A-Z]S$/ || $Itemout || $Pupout ){ &ItemGetDat(); }
	  elsif( $get[0] =~ /^(F|M)S$/ || $Formout ){ &FormGetDat(); }
	  elsif( $DIS_CODE =~ /^3/ && $get[0] eq 'EPSI_HTML' )
	  { if( $get[1] =~ /<HTML/ ){ $ED->{'epshtml'} = 1 ; }
	    elsif( $get[1] =~ /(.*)<META [\w\/\"\=\-\s\;]+ charset=[\w\-]+\">(.*)/i ){ $get[1] = $1 . $HMIME[1] . $2; }
	    elsif( $get[1] =~ /(.*=\")(\/images\/.*)/ ){ $get[1] = $1 . 'http://' . $ES->{'epshost'} . $2; }
	    $EPSIHTML .= $get[1] . "\n"; }
	} return 0;
}

sub EngiInDat
{	my ($nc ,$data) = @_;
	my $datout;
	foreach (@{$data})
	{ s/(\r)?\n$//;
	  if( $_ ){ $datout .= $_; $datout .= $nc == 2 ? ":" : "\n" if $nc; }
	} undef @{$data}; \$datout, length($datout);
}

sub PutDataDisp
{	my ($key, $val, @param) = (undef, undef);
	my $rmatc = 'SYS_ENGINE|KEY_ENGINE|LANG|TERM_IZON';
	my $cmatc = $CGI_CODE ? 'datcv|array|tm|kizc|error|keyDeEn|Backkey' : undef;
	my $mmatc = $CGI_CODE == 10 && $VMO != 2 ? 'ID|(m|u|c)?PASS|ldate|login|(.*)key|p|mid|' . 
		'lcode|mode|view|vtype|oform|disp|Pup_Code|iname|(.*)cate(.*)|(.*)file(.*)' : undef;

	push(@param, "^SYS");
	while (($key, $val) = each %{$SS})
	{ push(@param, "$key=$val") if $key && $key !~ /^($rmatc)$/; }
	push(@param, "^CGI");
	if( $DIS_CODE == 1 ){ &StatRankCheck(\@param); }
	elsif( $CGI_CODE == 10 && ($VMO == 2 || $VMO == 3)
	&& ($DMO || $CGI->{'search'} || $CGI->{'searkey'} || $CGI->{'uskey'}) )
	{ my $err = &MembUserGetCheck(\@param); &ManageDataCheck($err) if $err; }
	$CGI->{'lcode'} =~ s/\x20/+/g if $CGI->{'lcode'} =~ /\x20/;
	$CGI->{'mode'} =~ s/\x20/+/g  if $CGI->{'mode'}  =~ /^L.(.*)\x20/;
	while (($key, $val) = each %{$CGI})
	{ if( $key && $key !~ /^($cmatc)/ && $key !~ /^(x|y)$/ )
	  { $val =~ s/^(\x20|\x81\x40|(\r)?\n)+//;
	    $val =~ s/(\x20|\x81\x40|(\r)?\n)+$//;
	    $val =~ s/\n/\xFF/g; 
	    $val = 'ofor_1_' if $CGI_CODE == 10 && $VMO == 2 && $key eq 'disp' && 
					$CGI->{'disp'} =~ /^4./ && $CGI->{'fileup'}[1];
	    push(@param, "$key=$val") 
		if $CGI_CODE != 10 || !$mmatc || $mmatc && $key =~ /^($mmatc)$/i; }
	} \@param;
}

sub EngDatCheck
{
	&LoginCheckDisp();
	$URL = &CgiUrlCheck();
	$CGI_CODE = 5 if $DIS_CODE == 31 && $CGI->{'mode'} =~ /lin_3./;
	$ERROR = 1 if !$SS->{'SYS_DISPERROR'} && !$ERROR && !$ENGINE_END;

	if( $SYSTEM_ERROR || $SS->{'SYS_DISPERROR'} )
	{ $SYSERR = 1 if $SYSTEM_ERROR; &ErrorLog($ERROR, 0); 
	  &Print(&ShopSysError(100 , "100")) if $SYSTEM_ERROR; }
	elsif( $ERROR && !$ENO )
	{ my $eno = $ENO eq '' ? 93 : 0;
	  &Print(&ShopSysError($eno, $ERROR)); }
	elsif( $SS->{'EXCL_TYPE'} )
	{ &Print(&ShopSysError($SS->{'EXCL_TYPE'})); }
	elsif( $SS->{'MENT'} )
	{ &Print(&ShopSysError(1, &MentCheck)); }
	elsif( $DIS_CODE == 32 || $SS->{'LimitMail'} )
	{ &OrderMailNotiDisp(undef); }
	else
	{ if( $SS->{'SetCookie'} )
	  { print $SS->{'SetCookie'} . "\n"; undef $SS->{'SetCookie'};
	    if( $SS->{'COOKIE_GET'} && !$SS->{'Location'} )
	    { $ENV{'QUERY_STRING'} =~ s/(\&)?T[\d]{4}//;
	      my $plus = 'T' . sprintf("%04d", int(rand(1000)));
	         $plus = '&' . $plus if $ENV{'QUERY_STRING'};
	      &LocationPrint(0, $SS->{'SHOP_URL'} . '?' . $ENV{'QUERY_STRING'} . $plus);
	    }
	  } 
	  main::MobCartInView($SS->{'Location'}, $CGI->{'mode'}) 
			if $DIS_CODE == 2 && $PTB && $SS->{'Location'} =~ /mode\=cglook\_/;
	  &LocationPrint($SS->{'LOCATION_NO'} ? 0 : 1, $SS->{'Location'}) if $SS->{'Location'};
	} if( $DIS_CODE =~ /^3/ && $ED->{'epshtml'} ){ Sys::Print(undef, undef, 5, '', 0); exit; }
}

sub waitpid 
{	my $child;
	while ($child = waitpid(-1,WNOHANG)) 
	{ $WaitStatas{$child} = $?; return 0 if $child <= 0; } $SIG{CHLD} = \&waitpid;
}

sub CgiUrlCheck
{	my %URL;
	$URL{'HOME_URL'}   = $SS->{'HOME'};
	$URL{'SHOP_TOP'}   = ${&CommHidden(!$PTB && $DIS_CODE == 1 ? 
				$SS->{'Shop_Link'} : $SS->{'SHOP_URL'}, '', 0, '', '')}; 
	$URL{'SHOP_CAGO'}  = ${&CommHidden($SS->{'CAGO_URL'}, '',  0, '', '')};
	$URL{'SHOP_CAGO'}  =~ s/^<a href="(.*)/$1/o;
 	$URL{'SHOP_CAGO'} .= ($URL{'SHOP_CAGO'} =~ /\?$/ ? '' : '&') . 
				'mode=look_' . sprintf("%04d", int(rand(1000))); 
 	$URL{'SHOP_CAGO'} .= '" target="' . $SS->{'CAGO_TRAGET'} if !$PTB && $SS->{'CAGO_TRAGET'};
	$URL{'SHOP_ORDER'} = ${&CommHidden($SS->{'ORDE_URL'}, '',  0, '', '')};
	$URL{'SHOP_ORDER'} =~ s/^<a href="(.*)/$1/o; $URL{'SHOP_ORDER'} =~ s/\?$//o;
 	$URL{'SHOP_ORDER'}.= '" target="' . $SS->{'ORDER_TRAGET'} if !$PTB && $SS->{'ORDER_TRAGET'};
	$URL{'CATE_URL'}   = $URL{'SHOP_URL'} = $URL{'SHOP_TOP'}; 
	$URL{'SHOP_TOP'}   =~ s/^<a href="(.*)/$1/o; $URL{'CATE_URL'} =~ s/^<a href="(.*)/$1/o;
 	$URL{'SHOP_URL'}  .= ($URL{'SHOP_URL'} =~ /\?$/ ? '' : '&') . 'cate=';
 	$URL{'CATE_URL'}  .= ($URL{'CATE_URL'} =~ /\?$/ ? '' : '&') . 'cate=';
	$URL{'SHOP_CTOP'}  = $URL{'SHOP_URL'}; 
	$URL{'SHOP_CTOP'} =~ s/^<a href="(.*)/$1/o; $URL{'SHOP_CTOP'} .= 'top';
  	$URL{'SHOP_URL'}   =~ s/^<a href/<a class=lb href/o if !$PTB;
	$URL{'MEMB_URL'}  = ${&CommHidden($SS->{'MEMB_URL'}, '',  0, '', '');}; \%URL;
}

sub LoginCheckDisp
{	my $error_no = !$ERROR || $ERROR && ($CGI->{'LOGIN'} || $ENO < 52 || $ENO > 79) ? 1 : 0;
								# $ENO =~ /^(34|35|36)$/)
	if( !$CGI->{'uid'} && $CGI->{'user_id'} )
	{ $CGI->{'uid'} = $CGI->{'user_id'}; undef $CGI->{'user_id'}; }

	$LOGIN = 1 if ( ($CGI->{'mode'} !~ /log(in|out)/ || $CGI->{'mode'} =~ /memb$/) 
			 && $CGI->{'uid'} && $CGI->{'lcode'} || $CGI->{'mode'} =~ /^L\./ )
				 			&& $error_no && !$CGI->{'LOGIN_ERROR'};
	if( !$ERROR && ($CGI_CODE =~ /^(4|5)$/ && $CGI->{'mode'} !~ /^(L\.|mfor\_|lin\_)/
		 && $CGI->{'lcode'} !~ /^madd\./ 
			|| $CGI_CODE != 5 && $CGI->{'mode'} eq 'login' ) )
				{ undef $CGI->{'uid'}; undef $CGI->{'lcode'}; }
	$CD->{'MontItem'} = &MembOrderMonthlyCheck($CGI->{'uid'}) 
				if $CGI_CODE =~ /^(1|5)$/ && $CGI->{'uid'} && 
					$SS->{'MEMB_SET'} && !exists $CD->{'MontItem'};
}

;######################################################################
;# JMClib 
;######################################################################

sub JmclForm
{	my ($ocode, $icode, $opt1, $opt2) = @_;
	my ($JGET, $JMC) = (undef, JMClib::Form($ocode, $icode, $opt1, $opt2));
	&Print(&ShopSysError(101, $mode . '-Form ' . $JMC->{'error'})) if $JMC->{'error'};
	my %Epsilon;
	if($Eps_type)
	{ if(!$JMC->xdata("Epsilon_result->result"))
	  { &Print(&ShopSysError(102, 'Epsilon Not XMLData')); }
	  foreach (@{$JMC->xdata("Epsilon_result->result")})
	  { my ($key, $val) = each %{$_}; $Epsilon{$key} = $val; } %Epsilon; } else
	{ $JMC->{'itemfile'} !~ /^ARRAY\(/ ? 
		$ArrayFile->[0] = $JMC->{'itemfile'} : $ArrayFile = $JMC->{'itemfile'};
	  %{$JGET} = %{$JMC}; undef %{$JMC}; $JGET; }
}
sub JmclConv
{	my ($data, $ocode, $icode, $opt1, $opt2, $nend) = @_;
	my ($Get, $JMC) = (undef, JMClib::Conv($data, $ocode, $icode, $opt1, $opt2));
	if($JMC->{'error'})
	{ !$nend ? &Print(&ShopSysError(100, $mode . '-Conv ' . $JMC->{'error'}))
		 : &ErrorLog(('100 : ' . $error), $JMC->{'error'}); }
	$JMC->{'datcv'};
}

;######################################################################
;# bNt@C
;######################################################################

sub lock
{	my $lockfile = shift;
	my $retry = 3;
	while (!symlink(".", $lockfile))
	{ if($retry == 3){ &lockche($lockfile); }
	  if (--$retry <= 0) { return (&ShopSysError(0))[0]; } 
	  sleep(2); 
	} return \(0);
}
sub lock2
{	my $lockfile = shift;
	my $retry = 3;
	while (-e $lockfile)
	{ if($retry == 3){ &lockche($lockfile); }
	  if(--$retry <= 0 ){ return (&ShopSysError(0))[0]; } 
	  sleep(2); 
	} open( LF, ">$lockfile"); close ( LF ); return \(0);
}
sub tmplock{
	my $tempfile = shift;
	$retry = 3;
	while (-e $tempfile)
	{ if($retry == 3){ &lockche($tempfile); }
	  if(--$retry <= 0 ){ return (&ShopSysError(0))[0]; } 
	  sleep(2); 
	} return \(0);
}
sub lockche
{	my $lockfile = shift;
	if ((stat($lockfile))[9] < time() - 180) { unlock($lockfile); } return 0;
}
sub unlock
{	my $lockfile = shift;
	if (-e $lockfile) { unlink($lockfile); } return 0;
}

;######################################################################
;# eEVXeG[
;######################################################################

sub MentCheck
{	my ($mentype, $mfile) = split(/\,/, $SS->{'MENT'});
	my $data = undef; 
	print "mfile $mfile";
	open(MFILE,"<$mfile");
	while (<MFILE>)
	{ s/(\r)?\n//g; $data .= "$_$BR\n";  } 
	close(MFILE);
	$data;
}

sub SysErrorDataDisp
{	my $fc = shift;
	if( $PTB && $SS->{'HeadFile'} !~ /\_top\.dat$/ )
	{ $SS->{'HeadFile'} = $SS->{'TEMPL_DIR'} . 'k_head_view.dat' if !(-f $SS->{'HeadFile'});
	  $SS->{'FootFile'} = $SS->{'TEMPL_DIR'} . 'k_foot_view.dat' if !(-f $SS->{'FootFile'}); }
	my ($tmph, $tmpf) = 
	   	!$PTB ? ( $SS->{'CGI_CODE'} != 5 ? ('p_head.dat', 'p_foot.dat') :
				$CGI->{'LOGIN_ERROR'} ? ('p_head_memb.dat', 'p_foot_mem.dat')
					 	  : ('p_head_mem.dat', 'p_foot_mem.dat') )
	  						 : ('k_head.dat', 'k_foot.dat');

	$SS->{'HeadFile'} = $SS->{'TEMPL_DIR'} . $tmph if !$fc || !(-f $SS->{'HeadFile'});
	$SS->{'FootFile'} = $SS->{'TEMPL_DIR'} . $tmpf if !$fc || !(-f $SS->{'FootFile'});
	$SS->{'JS'}  = $SS->{'JSCS_URL'} . 'openWin.js' if !$fc;
	$SS->{'CSS'} = $SS->{'JSCS_URL'} . 'style.css' if !$fc;
}

sub ErrorLog
{	my ($eps_pri, $error, $eMsg) = (undef, @_);
	local($ERROR_LOG) = 1;
	if( !$SYSTEM_ERROR && !$SS->{'SYS_DISPERROR'} )
	{ $error =~ s/\n$//g; $error .= " ... " . $eMsg if $eMsg;
	  $SS->{'ErrFile'} = $SS->{'LOG_DIR'} . 'ErrorLog' if !$SS->{'ErrFile'};
	  &FilePrint(\$SS->{'ErrFile'}, \("$TIME[10] $error"), $ERROR_LOG, 0); }
	return 0 if $CGI_CODE == 10;
	if( $DIS_CODE == 32 || $SS->{'EPS_GETERROR'} )
	{ while (my ($key, $val) = $DIS_CODE == 32 ? each %{$CGI} : each %{$ED})
	  { $eps_pri .= $key . '="' . $val . "\"\n"; }
	}
	my $subje    = "WEB SHOP [ SYSTEM ERROR ]";
	my $mailmsg  = "$subje\n";
	   $mailmsg .= "-----------------------------\n";
	   if( !$SS->{'SYS_DISPERROR'} )
	   { $mailmsg .= "ERROR : " if $error !~ /^ERROR/;
	     $mailmsg .= "$error\n"; } else
	   { my $date = $TIME[10]; $date =~ s/([^\(]+)(.*)/$1/;
	     if( open(READ,"cat < $SS->{'ErrFile'} | grep $date |") )
	     { while (<READ>) 
	       { $mailmsg .= $_; } close(READ); } }
	if($eps_pri)
	{  $mailmsg .= "-----------------------------\n";
	   $mailmsg .= "$eps_pri"; }
	$mailmsg .= "-----------------------------\n";
	&SendMail(\$subje, \$mailmsg, undef) if $SYSERR <= 1 && !$MAILERROR;
}

;#//////////////////// G[bZ[W ///////////////////////

sub ShopSysError
{	my ($eNo, $eMsg) = @_;
	my $subset = $eNo == 1 ? [ 'eiX', 'eiX' ] : 
			$eNo != 2 && $eNo <= 14 ? [ 'WEB Shop System', 'bZ[W' ] : 
							[ 'VXeG[', 'VXeG[' ];
	my ($ec, $nh, @error_msg) = (0, 0, undef);
	$error_msg[0]  = 'f|܂BAݍĂ悤łB';
	$error_msg[1]  = "<b>f|܂A݃eiXłB</b>";
	$error_msg[2]  = "y[W[hw肪s̈׃y[WJ܂B";
	$error_msg[8] = "VbvPCł͂po܂Bgђ[ɂĂzB";
	$error_msg[9] = "Vbv͌gђ[ł͂po܂BPCɂĂzB<br><br>";
	$error_msg[10] = "f|܂Bp̌gђ[ł͂po܂B";
	$error_msg[11] = "f|܂Bi-mode[p̕i[hΉHTML3.0ȏ㖔FOMA[ŃANZXĉB";
	my $vodamsg = $OS eq '2c' ? "[[U[IDo\\[" : "[";
	$error_msg[12] = "f|܂Bvodafone[p̕C3`ȍ~$vodamsgŃANZXĉB";
	$error_msg[13] = "f|܂BEZWeb[p̕WAP2.0Ή(HTMLΉ)̒[ŃANZXĉB";
	$error_msg[14] = "f|܂BKDDI POCKET[p̕CulubAirH\"[ŃANZXĉB";

	if( $eNo >= 50 )
	{ $eMsg = $CGI->{'EPS_ERROR'} if $CGI->{'EPS_ERROR'};
	  if( $eNo < 110 || $CGI_CODE == 10 )
	  { $error_msg[$eNo]  = $CGI->{'EPS_ERROR'} ? "EpsilonσVXeG[łB" : 
				$CGI_CODE != 10     ? "f|܂VXeG[łB" 
						    : "VXeG[܂B"; } else
	  { $error_msg[110]  =  "f|܂[G[v܂B"; }
	  $error_msg[$eNo] .= $CGI->{'EPS_ERROR'} || $CGI_CODE == 10 ? 
							$BR . " ( $eMsg )" : " 񉺂B"; 
	} $error_msg[$eNo] = '<font color="' . $SS->{'ERRCOL'} . '">' . $error_msg[$eNo] . '</font>';
	&SysErrorDataDisp(0) if $DIS_CODE !~ /^(2|3|31|33)$/ && ($eNo <=1 || $eNo >= 50)
								 || $eNo >= 9 && $eNo <= 14;
	$SYSERR++; $LISTVIEW = ''; $ORDER_MAIL = 0; 

	if( $eNo >= 50 )
	{ $IMG->{'Mail'} = 'Mail' if !$IMG->{'Mail'};
	  if( !$SYSTEM_ERROR && !$SS->{'SYS_DISPERROR'} && 
	      ($eNo !~ /(93|110|111)$/ || $eNo == 93 && $SS->{'NOT_ERRORLOG'}) )
	  { my $pri_eNo = sprintf("%03d", $eNo);
	    &ErrorLog($eNo >= 100 ? ("CGI_SYS_ERROR $pri_eNo : JMClib:" . $eMsg) :
		      $eNo >= 90  ? ("CGI_SYS_ERROR $pri_eNo : Engine " . $eMsg)
				  : ("CGI_SYS_ERROR $pri_eNo : CGI", $eMsg)); } 
	  if( $DIS_CODE == 32 )
	  { main::ConviEndPrint($Convi ? (1, 0, "ok") : (0, $eNo, $ERROR || $eMsg)); } else
	  { &MailCheckDisp(2, 1);
	    $error_msg[$eNo] = $IMG->{'Error'} . "ERROR : " . $error_msg[$eNo];
	    $error_msg[$eNo] .= "$BR$BR\n"
	     . "$IMG->{'Mail'}:<a href=\"mailto:$MAS_MAILS[0]\">$MAS_MAILS[0]</a>"
	     . "$BR$BR\n"; $ec = 1 if $eNo == 101; } } else
	{ $error_msg[$eNo] = $IMG->{'Error'} . $error_msg[$eNo]; 
	  if( !$CGI->{'CGI_SYS_ERROR'} && $eNo >= 10 && $eNo <= 14 )
	  { $CGI->{'CGI_SYS_ERROR'} = 1; &SysEngine(&PutDataDisp()); 
	    $error_msg[$eNo] = '<br>'. $error_msg[$eNo] . '<br><br>'; } 
	  $nh = 1 if $eNo == 8;
	} $error_msg[$eNo] = '<font CLASS=font14>' . $error_msg[$eNo] . '</font>' if !$PTB;
	if( $CGI_CODE != 10 && $CGI_CODE != 5 )
	{ $error_msg[$eNo] .= $BR . $BR . $eMsg if $eNo == 1;
	  $error_msg[$eNo] = '<p>@</p>' . $error_msg[$eNo] . 
				'<p>@</p><p>@</p><p>@</p>'if !$PTB; }
	\$error_msg[$eNo], $subset, 
		$ModeCheck =~ /^lin\_[A-Z]+/i ? 10 : $CGI_CODE == 10 ? 10 : 0, $ec, $nh;
}

sub ShopError
{	my ($eNo, $eMsg) = @_;
	my @error_msg = undef;
	$error_msg[1]  = "f|܂Bw肳ꂽi܂łB";
	$error_msg[$eNo];
}

sub ShopErrorPri
{	my ($error, $etp, $fs) = @_;
	my $font = ' CLASS=font' .  $fs if !$PTB;
	$$error = '<font color="' . $SS->{'ERRCOL'} . '"' . $font . '>' . $$error . '</font>';
	if( $etp )
	{ $$error = $IMG->{'Error'} . $$error; return $error; } else
	{ $$error = $IMG->{'Error'} . "ERROR : " . $$error; return $error, undef, 0, 0, 0; }
}

sub Error
{ 	my ($etp, $enc, $error) = (0, 0, undef);
	if( $ERROR !~ /<font color/ && $ERROR ) 
	{ ($etp, $enc) = $CGI_CODE =~ /^(5|10)$/ ? ($ENO, 14) : 
			($DIS_CODE == 3 && $CGI->{'mode'} =~ /memb/ ? 2 : 1, 14);
	  &ShopErrorPri(\$ERROR, $etp, $enc);
	  if( $DIS_CODE > 1 && $DIS_CODE < 4)
	  { $ERROR .= &ShopLink() if $ENO =~ /^(3|7)[\d]$/ && $CGI->{'mode'} !~ /^Rmemcheck/;
	    $ERROR .= $BR . $BR . "\n" if $PTB; 
	  }
	} $ENO, \$ERROR;
}

sub ErrorCheck
{	my @error = ($ENO, $ERROR, $CGI->{'LOGIN_ERROR'}); \@error;
}

1;



