;######################################################################
;#
;#    Managlib.pl  Managnent library Ver1.01 for WEB SHOP System
;#                  (manage.cgip Perl library)
;#
;#    Created on: 05/06/15 Modified 05/07/19
;#    (C) Copyright 2005 PMCJ by Tomio Sato
;#    http://www.pmcj.com/   info@pmcj.com
;#
$UCHECK = '[A-Z]{3}[\d]{6}';
;######################################################################

sub ManageDataCheck
{ my ($err, $mode) = (shift, undef);
  $CGI->{'mkey'} .= ':' . $CGI->{'mview'} if $CGI->{'mview'};
  $CGI->{'dpv'}  .= ':' . $CGI->{'lv'} if $CGI->{'dpv'} !~ /\:/;
  if( $err )
  { $CGI->{'mode'} = $mode = 2;
    $SearError = &ShopErrorPri(&ManageError($err, ''), 1 , 14); } else
  { $CGI->{'mode'} = $CGI->{'disCheck'} if $CGI->{'disp'} =~ /^0\./ && $CGI->{'disCheck'};
    $mode = $CGI->{'mode'}; 
  }
  ($VMO, $DMO) = $mode =~ /^[\d]\./ ? split(/\./, $mode) :(0, 0);
  ($UIDC, $UDIR) = ($1 . $3 . $5, $1 . $2 . $3 . $4 . $5 . $6 . $7) 
		if !$UIDC && $DMO =~ /\/([A-Z]{3})(\/)([\d]{3})(\/)([\d]{3})(\_)?(\/)/i;
  ($P, $L, $D) = split(/\./, $CGI->{'p'});
   $P = $P || 1; $L = $L || 1; $D = $D || 1;
   $HeadID = $VMO == 3 ? $MANAG_HEDID : $SS->{'MEMB_HEDID'};
   $MemDel = $CGI->{'uskey'} =~ /^udel\./ && $CGI->{'odis'} =~ /^D\./
							 ? ($CGI->{'card'} ? 2 : 1) : 0;
  if( $CGI->{'disp'} =~ /^(m|a)for\_/ )
  { my $dtype = $1 eq 'm' ? 1 : 0;
    ($AddError, $Mana) = &ManageAddDataCheck($1); $CGI->{'disp'} = $dtype . '.' if $$AddError; }
  if( $mode !~ /^4/ && !$CGI->{'sort'} )
  { $CGI->{'sort'} = $SForm->{'SYS_viewsort'};  $CGI->{'imp'} = $SForm->{'SYS_viewpic'}; } 
}

sub ManageData
{ $Uview = $SForm->{'SYS_Fview'} if $CGI->{'mode'} =~ /^1./;
  if( $FORM )
  { $FORM =~ s/(<table width=")100(\%".*)/$1 . '99' . $2/eg if $VMO == 4;
    $FORM =~ s/(.*)(<input type=\")radio(\"[^>]+>)(.*)/$1 . $2 . 
		'hidden' . $3 . $4/eo if $CGI->{'uskey'} eq 'uid'; }

  $VMO, $DMO, $P, $L, $D, $Dview, $Uview, \$FORM, $Uauto, $HeadID;
}

sub ManageUserCount
{ if( $CGI->{'searkey'} )
  { my $count = $CGI->{'searCount'} ? $CGI->{'searCount'} : $CGI->{'s'};
    @USER_DATA = split(/\,/, $count); }
  @USER_DATA;
}

sub ManageErrorData
{ $Error, $SearError;
}

sub ManageUseCapacity
{	my ($dsz, $SZ, $msg) = (0, undef, undef);
	my $back = $CGI->{'cddis'};
	my $htmin = $SS->{'ITE_ROOT'} =~ /^$SS->{'PC_DIR'}/ ? 1 : 0;
	local(@DC); $SZ->{'allsz'} = 0;
	while (my ($key, $val) = each %{$SS})
	{ if( -d $val && $key =~ /(ITE\_ROOT|\_DIR)$/ && !&ManageCheckDirDisp($key, $val) )
	  { last if !open(DU, "du -s $val | ");
	    while (<DU>)
	    { chop();
	      if( /([\d\w]+)[\s]+(.*)/ )
	      { my ($dsz, $root) = ($1, $2);
		if( $key =~ /^TMP\_/ ){ $SZ->{'tempsz'} += $dsz; }
		elsif( $key =~ /^SALE\_/ )
		{ $SZ->{'salesz'} += $dsz; $SZ->{'salert'} = ' ' . $val if $back; }
		elsif( $key =~ /^MEMB\_/ )
		{ $SZ->{'usersz'} += $dsz; $SZ->{'userrt'} = ' ' . $val if $back; }
		elsif( $key =~ /^(PC|PTB)\_/ )
		{ $SZ->{'htmsz'} += $dsz; $SZ->{'htmrt'} .= ' ' . $val if $back; }
		elsif( $key =~ /^(ITEM|ITE|PIUP)\_/ )
	        { $SZ->{'itemsz'} += $dsz; $SZ->{'simgsz'} = $dsz if $key =~ /^ITE\_/;
		  $SZ->{'itemrt'} .= ' ' . $val if $back && ($key !~ /^ITE\_/ || $key =~ /^ITE\_/ && !$htmin); } 
		else
		{ $SZ->{'syssz'} += $dsz; $SZ->{'sysrt'} .= ' ' . $val if $back; }
		$SZ->{'allsz'} += $dsz;
	      } push(@DC, $val);
	    } close(DU);
	  }
	} my $tarc = 0;
	if( $SZ->{'allsz'} )
	{ if( $back )
	  { if( $back > 1 && !(-d $SS->{'TMP_DIR'}) )
	    { $msg = Sys::ShopErrorPri(Sys::ManageError(100 , 'Not tmp dir'), 1 , 14); }
	    my ($backname, $backroot, $fperr, $last) = (undef, undef, 0, 0);
	    if( $CGI->{'downall'} )
	    { while (my ($key, $val) = each %{$SZ})
	      { if( $key =~ /([A-Z]+)rt$/i ){ $backroot .= ' ' . $val;  } } 
	      $backname = 'shopback'; } else
	    { foreach (@{$ArrayFile})
	      { if( /([A-Z]+)rt$/i )
		{ $backname = (!$tarc ? $1 : 'shop') . 'back'; 
	          $backroot .= ' ' . $SZ->{$_}; $tarc++; } }
	    } &ManageRepetitionFileCheck(\$SS->{'TMP_DIR'}, \$backname, 1);
	    my $file = $backname . '.tar.gz';
	    my $tarfile = $SS->{'TMP_DIR'} . $file;
	    #if( !open(TAR, "tar cz -f - $backroot | ") )
	    if( !open(TAR, "tar cvf - $backroot | gzip -c -f | ") )
	    { $$msg .= "<br>\n" if $$emsg;
	      $$msg .= Sys::ShopErrorPri(Sys::ManageError(100 , 'Cannot command tar'), 1 , 14); } else
	    { if( $back =~ /^(2|3)/ && &FilePrintOpen(\$tarfile, 1) )
	      { $$msg .= "<br>\n" if $$emsg;
		$$msg .= Sys::ShopErrorPri(Sys::ManageError(100 , 'Cannot file print'), 1 , 14); }
	      if( $back == 1 )
	      { print $content . JMClib::Content($file) . "\n";
	        print "Content-disposition: inline; filename=\"$file\"\n\n"; }
	      binmode(TAR); binmode(TMPFILE) if $back > 1 && !$$emsg;
	      while (<TAR>)
	      { binmode(STDOUT); if( /[\x00][\x00]+$/ ){ $last = 1; s/[\x00][\x00]+$//o; }
		if( $back == 1 ){ print $_; }
		elsif( $back > 1 && !$$emsg ){ print TMPFILE $_; } last if $last;
	      } close(TAR); &FilePrintClose(undef, undef) if $back > 1 && !$$emsg;
	      if( $back == 1 ){ exit; } 
	      elsif( $back == 3 ){ &ManageShopFilePrint($SS->{'TMP_DIR'}, $file); }
	      $$msg = '@ <b>pbNAbvt@C琬܂B</b><br>' .
		      '@ t@CF' . $file if $back == 2 && !$$emsg;
	    }
	  } return ('', $msg) if $CGI->{'cddis'};
	  if( $htmin )
	  { $SZ->{'htmsz'} -= $SZ->{'simgsz'}; $SZ->{'allsz'} -= $SZ->{'simgsz'}; }
	  while (my ($key, $val) = each %{$SZ})
	  { if( $key =~ /sz$/ && $val > 999 )
	    { $val = $val / 1000; $val =~ s/(\.\d)[\d]+/$1/; $val .= 'M'; } else
	    { $val .= 'K'; } $SZ->{$key} = $val;
	  } } else
	{ $SZ->{'allsz'} = 'TCY擾o܂łB'; }
	my @Sztable = ( 'itemsz:o^i֘A (f[^ 摜 etc)', 'htmsz:Vbv֘A (HTML 摜 etc)',
			'usersz:t@C֘A (EI[_[)', 'salesz:㓝v֘A (f[^t@C)', 
			'syssz:VXet@C֘A (conf cache etc)', 'tempsz:  obNAbv' );

	my $hd = $SForm->{'down_IMG'}; $hd2 = $hd; $hd2 =~ s/(\.[A-Z]+\"\>)$/'2' . $1/eoi;
	my $alldown = $tarc ? &ImgAltPut(\$hd, '_E[h', 1) : $hd;
	my $submit = '<input type="submit" name="cddis" value="1.obNt@C"> / <input type="submit" name="cddis" value="2._E[h">';
	my $cdpri = 
	'<table CLASS=font13 border=0>' . 
	${&ManageCommHidden($SS->{'MANAG_URL'}, 1, 1, "datdown")} . 
	'<input type="hidden" name="mode" value="CD">' . "\n" .
	'<tr><td colspan=3>@ <font CLASS=font14> <b>WebShopgpe y ' . $SZ->{'allsz'} . ' z</b></font></td></tr>' . "\n";
	foreach (@Sztable)
	{ my ($name, $szname) = split(/\:/, $_);
	  my $tmpd = $name eq 'tempsz' ? ' align=right' : undef;
	  my $bname = $name; $bname =~ s/sz$/rt/o;
	  $cdpri .= '<tr><td' . $tmpd . ' nowrap>' 
		 . (!$tmpd ? '@  <input type="checkbox" name="itemfile" value="' 
		 . $bname . '" onClick="FormCheck(0,1,\'\',1)">' . $hd2 : '( ') 
		 . $szname . '</td><td align=right>@' . $SZ->{$name} . '</td>' . "\n"
		 . '<td>' . ($tmpd ? '  )' : undef) . '</td></tr>' . "\n";
	} 
	$cdpri .= '<tr><td colspan=3>@  <input type="checkbox" name="downall" value="1"' .
	' onClick="FormCheck(0,1,4,0)"' . $SForm->{'form_checked'} . '>' . $hd2 . '<b>S</b></td></tr>' . "\n";
	$cdpri .= '<tr><td colspan=3>@ [ s^Cv F' . ${Sys::ManageRadioFormDisp('cddis', 
	[ "1:_E[h", "2:obNt@C琬", "3:"  ], $CGI->{'cdType'} ? $CGI->{'cdType'} : 1)} . ' ] </td>' . 
	'<tr><td colspan=3>@ ' . &ImgAltPut(\$hd, 'DownLoad / Backup', 1) . '</td></tr>' . "\n" .
	'</form></table>' . "\n"; \$cdpri, $msg;
}

sub ManageCheckDirDisp
{	my ($dc, $key, $cdir) = (0, @_);
	if( $key !~ /^ITE\_/ ){ foreach my $dir (@DC){ $dc = 1 if $cdir =~ /^$dir/; } } $dc;
}
;####################################################
;###################  ֘A   ################
;#################################################### 

sub MembUserInvalDisp
{	my ($lave1, $lave2, $err) = (undef, undef, 0);
	return 0 if $Admin[1] != 7;

	if( $UIDC !~ /^$UCHECK$/i )
	{ $InvMsg .= ${&ShopErrorPri(&ManageError(100, 
			'GetID_Inva ' . $UIDC), 1 , 14)} . "<br>\n"; $err = 1; }
	if( !$InvMsg )
	{ my $udir = &MembUidDir($UIDC);
	  my $pFile = $SS->{'MEMB_DIR'} . $udir . '.' . $UIDC . '_P';
	  my $pFinv = $pFile . '_'; $udir =~ s/\/$//o;
	  my $uDirc = $SS->{'MEMB_DIR'} . $udir;
	  my $uDinv = $uDirc . '_';
	  my $dis   = $CGI->{'odis'} =~ /^([\d]|D)\./ ? $1 : $Odisp;
	  $err = $dis =~ /^(1|D)$/ && !(-f $pFinv) || $dis == 8 && !(-f $pFile) ? 20 :
		 $dis == 2 && !(-d $uDinv) || $dis == 9 && !(-d $uDirc) ? 21 : 0;
	  $InvMsg .= ${&ShopErrorPri(&ManageError($err, $UIDC), 1 , 14)} . "<br>\n" 
								if $err && $err != 1;
	  if( !$InvMsg )
	  { if( $MemDel )
	    { &MembDeleDisp(-d $uDinv ? $uDinv : $uDirc) if -d $uDinv || $uDirc; }
	    elsif( $dis == 1 ){ rename($pFinv, $pFile); }
	    elsif( $dis == 8 || $dis == 9 ){ rename($pFile, $pFinv); }
	    if( $dis == 2 ){ system("mv $uDinv $uDirc"); rename($pFinv, $pFile); }
	    elsif( $dis == 9 ){ system("mv $uDirc $uDinv"); } }
	  if( $dis ne 'D' )
	  { $lave1 = -f $pFile ? '8.PASS' : 
		     -f $pFinv ? '1.PASSL' : -d $uDinv ? 'PASS---' : undef;
	    $lave2 = -d $uDirc ? '9.ID'   : -d $uDinv ? '2.IDL' : undef;
	    if( !$lave1 || !$lave2 )
	    { $InvMsg .= ${&ShopErrorPri(
		&ManageError(!$lave1 ? 20 : 21 , ''), 1, 14)} . "<br>\n"; $err = 1; } } else
	  { $InvMsg .= ${&ShopErrorPri(
		&ManageError(25 , $UIDC), 1 , 14)} . "<br>\n" if -d $uDirc || -f $uDinv; 
	    $InvMsg .= '폜܂B' if( $CGI->{'disp'} =~ /^6/ && !$InvMsg ); }
	} if( !$Odisp ){ \$InvMsg, $lave1, $lave2; } else { $err ? 1 : 0; }
}

sub MembDeleDisp
{	my $udir = shift;
	my $odir = $udir . '/order/';
	foreach (sort @{Sys::FileListOpen(\$odir)})
	{ unlink($odir . $_) if /^([\d]+\_[\d]+|Card|DelCard)/;
	} rmdir $odir;
	foreach (sort @{Sys::FileListOpen(\$udir)})
	{ unlink($udir . '/' . $_) if /^(\.$UIDC\_|LoginTime)/;
	} rmdir $udir;
	if( $udir =~ /\_$/ ){ $udir =~ s/\_$//o; rmdir $udir; }
}

;####################################################
;############  [U[Xg֘A   #############
;#################################################### 

sub MembUserGetCheck
{	my ($param, $dis) = (shift, $CGI->{'disp'});
	my $sear = $DMO =~ /^$MANAG_HEDID/ ? 5 : 
		   $DMO eq $SS->{'MEMB_HEDID'} ? 4 : !$dis && $CGI->{'uskey'} ? 1 : 
		   $DMO =~ /[\/]+[\d]+/ ? $DMO : undef;
	my $dEnd = $dis =~ /^5/ && $CGI->{'odis'} ? 1 : 0;

	return 0 if !$dEnd && $CGI->{'odis'} || 
		    $VMO == 3 && ($dis =~ /^0\./ || $dis !~ /^0\./ && $UDIR);

	if( !$dis && $CGI->{'uskey'} eq 'uid' || $dEnd )
	{ if( $CGI->{'uskey'} eq 'uid' )
	  { return 11 if $CGI->{'searkey'} !~ /^$UCHECK$/i; } else
	  { return (100, 'GetID_D5') if $UIDC !~ /^$UCHECK$/i; }
	  if( $dEnd  )
	  { &MembCardFlugDisp($UIDC, $CGI->{'card_1'}, $CGI->{'card_2'}); undef $CGI->{'odis'}; }
	  my $err = &MembUserGet($param, $dEnd ? $UIDC : $CGI->{'searkey'}); 
	  return $err if $err; return 0; } 
	elsif( !$dis && ( $CGI->{'uskey'} || $CGI->{'searkey'}) )
	{ my $skey = undef; $CGI->{'searkey'} =~ s/\x81\x40/\x20/g;
	  foreach ( split(/ /, $CGI->{'searkey'}) )
	  { next if length($_) < 1; $skey .= $_ . ' '; } $CGI->{'searkey'} = $skey;
	  if( $skey )
	  { push(@{$param}, "MEM_SKEY=$skey"); push(@{$param}, "skey=1"); 
	    push(@{$param}, "uview=$Uview"); push(@{$param}, "page=$L"); }
	  if( !$sear )
	  { return 10 if !$skey; $CGI->{'mode'} = 'mGetSera'; $VMO = 2; 
	    $DMO = $CGI->{'disMode'} =~ /^[\d]\.(.*)/ ? $1 : '/'; return 0; }
	} &MembUserGetList($param, $sear) if $sear; return 0;
}

sub MembUserGet
{	my ($param, $uidc) = @_;
	my $udir = &MembUidDir($uidc);
	my $dfile = $SS->{'MEMB_DIR'} . $udir . '.' . $uidc . '_D';
	return 12 unless -f $dfile;
	$udir =~ s/^([A-Z0-9\/]+)[\d]{3}\/$/$1/;
	$CGI->{'mode'} = 'mGetData';
	push(@{$param}, "MEM_USER_CHECK=$dfile"); return 0;
}

sub MembUserGetList
{	my ($param, $sear) = @_;
	local($Start, $End, $Lc, $Ac, @udData);
	local($Down) = !$CGI->{'csvdown'} ? 0 : !$CGI->{'p'} ? 2 : 1;
	if( $sear == 2 )
	{ $Olim = (Sys::MembOrderTimeDisp(2))[0];
	  for(my $i = 0; $i < 5; $i++){ $USER_DATA[$i] = 0; } } 
	elsif( $sear >= 4 )
	{ ($Start, $End, $Lc) = &PageViewCheck($Uview, $L); }

	if( $sear =~ /^[\d]$/ )
	{ $check_dir = $SS->{'MEMB_DIR'} . $HeadID . '/';
	  if( $VMO == 3 && $SS->{'ADMIN_ID'} =~ /^($MANAG_HEDID)([\d]{3})([\d]{3})$/ )
	  { my ($admindir, $fdir) = ($SS->{'MEMB_DIR'} . $1 . '/' . $2, '/' . $3);
	    mkdir($admindir, 0755) unless -f $admindir; $admindir .= $fdir;
	    mkdir($admindir, 0755) unless -f $admindir; }
	  foreach (sort @{Sys::FileListOpen(\$check_dir)})
	  { next if $_ =~ /^\./ || $_ !~ /^[\d]{3}$/;
	    last if &MembUserListCheck($check_dir . $_ . '/', 
		$HeadID . '/' . $_ . '/', $HeadID . $_, $sear); } } else
	{ my $uidc = $sear; $sear =~ s/^\///o; $uidc =~ s/\///g; 
	  &MembUserListCheck($SS->{'MEMB_DIR'} . $sear . '/', $sear, $uidc); }
	if( $MemDel )
	{ if( !$InvMsg )
	  { $InvMsg = !$udData[0] ? 
		'0.폜Ώۉ܂łB' : 
		'1.' . $udData[0] . '̍폜܂B'; } \$InvMsg; }
	elsif( $sear == 4 )
	{ @USER_DATA = (&MembUserCount(2), $Start, $End);
	  foreach (@udData)
	  { push(@{$param}, "MEM_USER_CHECK=$_"); $CGI->{'mode'} = 'mGetData'; } }
	elsif( $sear == 5 )
	{ @USER_DATA = ($Ac, $Start, $End); &ManageUserListDisp(); }
	elsif( $sear != 2 )
	{ my ($start, $end, $lc) = &PageViewCheck($Uview, $L);
	  @USER_DATA = ($#udData + 1, $start, $end);
	  if( $USER_DATA[0] )
	  { foreach (@udData)
	    { if( $c >= $start && $c <= $end || $Down == 2 )
	      { push(@{$param}, "MEM_USER_CHECK=$_"); } $c++; last if $Down != 2 && $c > $end; }
	    $CGI->{'mode'} = 'mGetData';
	  } } 
	else { &MembUserCount(1); }
}

sub MembUserListCheck
{	my ($check_dir, $udir, $uidc, $sear) = @_;
	my $Vmo = $sear == 2 || $VMO == 2 ? 2 : 0;
	my $en  = 0;
	local($Odisp) = 0;
	foreach (sort @{Sys::FileListOpen(\$check_dir)})
	{ next if $_ =~ /^\./ || $_ !~ /^[\d]{3}(\_)?$/;
	  if( $sear == 2 && $_ !~ /\_$/ )
	  { $UIDC = $uidc . $_; $UDIR = $udir . $_ . '/';
	    if( $Olim && !(&MembOrderRead($UIDC, 2, 0))[4] && !&ManageLoginListDisp(1) )
	    { $Odisp = 9; $_ .= '_' if !&MembUserInvalDisp(); $Odisp = 0; }
	  }
	  my ($uRoot, $check) = ($check_dir . $_ . '/', 0);
	  my $uid = $_; $uid =~ s/\_$//o;
	  my $dfile = $uRoot . '.' . ($Vmo == 2 ? $uidc . $uid . '_D' : 'info');
	  unless( -f $dfile )
	  { next if ($uidc . $_) ne $SS->{'ADMIN_ID'}; &FilePrint(\$dfile, undef, 0); }
	  if( $Vmo == 2 )
	  { next if( &MembUserListSerach(\$uRoot, $_, $uidc . $_, $sear) ); }
	  { next if $_ !~ /^[\d]{3}$/; }
	  if( $MemDel ){ $UIDC = $uidc . $uid; &MembUserInvalDisp(); $udData[0]++; } 
	  elsif( $sear == 2 ){ return \$InvMsg; }
	  elsif( $sear >= 4 )
	  { if( $Ac >= $Start && $Ac <= $End || $Down == 2){ push(@udData, $dfile); } 
	    $Ac++; if( $sear == 4 && $Ac > $End && $Down != 2 ){ $en = 1; last; } }
	  else{ push(@udData, $dfile); }
	} return $en;
}

sub MembUserListSerach
{	my ($uRoot, $dir, $uidc, $sear) = @_;
	$uidc =~ s/\_$//o;
	my ($cardadd, $carddel) = (&MembOrderFileCheck($uidc))[1 .. 2];
	my $pfile = $$uRoot . '.' . $uidc . '_P_';
	if( $sear == 2 )
	{ if( $dir =~ /^[\d]{3}$/ )
	  { -f $pfile ? ($USER_DATA[2] += 1) : ($USER_DATA[0] += 1); }
	  $USER_DATA[1] += 1 if $dir =~ /^[\d]{3}\_$/;
	  if( !(-f $pfile) && $dir =~ /^[\d]{3}$/ )
	  { $USER_DATA[3] += 1 if -f $cardadd && !(-f $carddel);
	    $USER_DATA[4] += 1 if -f $carddel; return 1; } } else
	{ if( $CGI->{'uskey'} =~ /^(card|udel)\.([\d])$/ )
	  { my ($t, $d) = ($1, $2);
	    if( $t eq 'card' )
	    { return 1 if $dir !~ /^[\d]{3}$/;
	      return 0 if !$d && -f $cardadd || 
		  $d == 1 && -f $cardadd && !(-f $carddel) || $d == 2 && -f $carddel; } else
	    { return 1 if $d == 1 && $dir !~ /^[\d]{3}$/ || $d == 2 && $dir !~ /^[\d]{3}\_$/;
	      return 1 if $MemDel == 2 && (-f $cardadd || -f $carddel);
	      return 0 if !$d && ($dir =~ /^[\d]{3}\_$/ || -f $pfile ) || $d == 1 && -f $pfile || $d == 2; } } else
	  { return 0 if $dir =~ /^[\d]{3}$/; }
	} return 1;
}

sub MembUserCount
{	my ($v, $count) = (shift, undef);
	my ($cfile, $data) = ($SS->{'CACHE_DIR'} . 'admin/UserCount.dat', undef);
	if( $v == 1 )
	{ foreach (@USER_DATA){ $data .= $_ . ','; } &FilePrint(\$cfile, \$data,0); } else
	{ my $uc = FileOpen(\$cfile, 0 ,1);
	  return (split(/\,/, $uc->[0]))[0] if $v == 2;
	  my @Count = split(/\,/, $uc->[0]); 
	  for(my $i = 0; $i < 5; $i++){ $Count[$i] = 0 if !$Count[$i]; }
	  $count  = '<br>@@<b>' . $IMG->{'Maru'} . ' o^</b>';
	  $count .= '@@ ' . ($Count[0] +  $Count[1] + $Count[2]) . '<br><br>' . "\n";
	  $count .= '@@@' . ' L F ' . $Count[0] . '<br>' . "\n";
	  $count .= '@@@@@' . ' J[h ' . ($Count[3] + $Count[4]) . '' . 
		    ' (  - ' . $Count[4] . ')<br>' . "\n";
	  $count .= '@@@' . '  F ' . ($Count[1] + $Count[2]) . '' . 
		    ' ( PASS - ' . $Count[2] . ' ' . ' ID - ' . $Count[1] . ' )<br><br>' . "\n";
	} \$count;
}

sub MembUserLogin
{	my ($v, $name) = @_;
	my ($login, $c, $w, $m, @WSM, @MAS) = (undef, 0, 0, 0);
	my ($lfile, $data) = ($SS->{'CACHE_DIR'} . 'login/', undef);

	foreach (sort @{&FileListOpen(\$lfile)})
	{ if( /^(($SS->{'MEMB_HEDID'}|MAS)[\d]+)\_/ )
	  { my($id, $uh) = ($1, $2);
	    if( $uh eq $SS->{'MEMB_HEDID'} ){ push(@WSM, $id); $w++; }
	    else {  push(@MAS, $id); $m++; }
	  }
	} $login  = '<br>' . ($CGI->{'mode'} eq 'LD' ? '@' : undef) . '<b>' . $IMG->{'Maru'};
	if( $v == 1 )
	{ my ($line) = '-----------------------------'; $line .= $line if !$CGI->{'lov'};
	  my $ah = ${&ManageCommHidden($SS->{'MANAG_URL'}, 1)};
	     $ah .= '<input type="hidden" name="mode" value="LD">' . "\n";
	  $login .= ' ' . $name . '</b>' . ($CGI->{'lov'} ? ' ( l' . ($w +  $m) . 'l )' : undef) . '<br>' ."\n";
	  $login .= '<table><tr>' . $ah . '</tr></table>';
	  $login .= '@ y' . ${Sys::ManageRadioFormDisp('lov', 
		[ '0:`', '1:OCXg' ], $CGI->{'lov'} ? $CGI->{'lov'} : 0)} . ' z<br>' . "\n";
	  if( !$CGI->{'lov'} )
	  { $login .= '@ \ F ' . ${Sys::ManageSelectFormDisp('log', 
		[ '10:10', '30:30', '50:50', '75:75', '0:S' ], 
			$CGI->{'log'} ? $CGI->{'log'} : 0, 0)} . "\n" . 
	 		' [h F ' . ${Sys::ManageSelectFormDisp('retime', 
		[ '0:Ȃ', '30:30b', '60:1', '180:3', '600:10' ], 
			$CGI->{'retime'} ? $CGI->{'retime'} : 2, 0)} . "\n"; } else
	  { $login .= '@@'; }
	  $login .= ' <input type="submit" value="\">' . "\n";
	  $login .= '<font CLASS=font7 size=1><br><br></font>' . "\n";
	  $login .= '@' . $line . '<br>' ."\n";
	  if( $CGI->{'lov'} )
	  { $login .= '</form>' . "\n";
	    $login .= '@@@ OC F ' . $w . 'l<br>';
	    foreach (@WSM){ $c++; $login .= '@@@@' . $c . '. ' . $_ . '<br>' . "\n"; } $c = 0;
	    $login .= '<br>@@@ ǗOC F ' . $m . 'l<br>'; 
	    foreach (@MAS){ $c++; $login .= '@@@@' . $c . '. ' . $_ . '<br>' . "\n"; } } else
	  { $ah .= '<input type="hidden" name="retime" value="' . $CGI->{'retime'} . '">' . "\n" if $CGI->{'retime'};
	    $ah .= '<input type="hidden" name="log" value="' . $CGI->{'log'} . '">';
	    $login .= '<table><tr></form>' . $ah . '</tr></table>';
	    $login .= '<input type="hidden" name="retime" value="' . $CGI->{'retime'} . '">' . "\n";
	    $login .= '@  F <input type="text" size=14 name="name" value="' . $CGI->{'name'} . '">' . "\n";
	    $login .= '<nobr>@ (  pass F <input type="password" size=8 name="vpass" value="' . $CGI->{'vpass'} . '"> )</nobr><br>' . "\n";
	    $login .= '@  F <input type="text" size=45 name="comment">' . "\n";
	    $login .= ' <input type="submit" value="`/"><br>' . "\n";
	    $login .= '<font CLASS=font7 size=1><br><br></font>' . "\n";
	    $login .= '<table width=98%><tr></form>';
	    $login .= $ah . '</tr></table>' . "\n";
	    $login .= ${&ManageChatDisp()};
	    $login .= '<table width=98% CLASS=font13><tr><td align=right>' . "\n";
	    $login .= '<input type="hidden" name="deldate" value="' . $TIME[10] . '">' . "\n";
	    $login .= '<input type="hidden" name="name" value="' . $CGI->{'name'} . '">' . "\n" if $CGI->{'name'};
	    $login .= '<input type="hidden" name="vpass" value="' . $CGI->{'vpass'} . '">' . "\n" if $CGI->{'vpass'};
	    $login .= '<input type="checkbox" name="cdat" value="ALL">SNA' . "\n";
	    $login .= '<input type="password" size=10 name="bpass">' . "\n";
	    $login .= ' <input type="submit" value="폜">' . "\n";
	    $login .= '</td></form></tr></table>' . "\n";
	  } } else
	{ $login .= ' OC / Ǘ`</b><br><br>' . "\n";
	  $login .= '@ ' . ' OC F ' . $w . 'l<br>';
	  $login .= '@ ' . ' ǗOC F ' . $m . 'l<br>';
	  $login .= '<br>' . "\n";
	  $login .= '@@@' . &PageJavaLink(\(${&ManageCommHidden($SS->{'MANAG_URL'}, 0)} . '&mode=LD&lov=1'), 
	  		'OCXg', 'memlogin', '250', '300', 'no');
	  $login .= ' / ' . &PageJavaLink(\(${&ManageCommHidden($SS->{'MANAG_URL'}, 0)}	. '&mode=LD'), 
	  		'`', 'memlogin', '550', '400', 'no');
	} $login .= '<br><br>' . "\n" if $CGI->{'lov'}; \$login;
}

sub ManageChatDisp
{	my ($logile, $logtmp, $chat, $error) = 
				($SS->{'CACHE_DIR'} . 'admin/Chat.dat', undef, undef, undef);
	&FilePrint(\$logile, undef, 0, 0) if !(-f $logile);
	my ($Cd, $pri, $c, @com) = (&FileOpen(\$logile, 0, 2), 
				$CGI->{'bpass'} ? 2 : $CGI->{'comment'} ? 1 : 0, 0);

	return \('LogFile Open Error') if $Cd eq 'ERROR';
	if( $pri )
	{ $pri = 3 if $CGI->{'bpass'} && $SForm->{'SYS_ChatMasKey'} eq $CGI->{'bpass'};
	  if( $pri == 1 || $pri == 3 && $CGI->{'cdat'} eq 'ALL' )
	  { foreach (@{$Cd})
	    { @com = split(/\,/, $_); my $date = $com[0]; $date =~ s/(\r)?\n$//o;
	      if( $pri == 1 && $com[2] eq $CGI->{'name'} && $com[3] eq $CGI->{'comment'} 
			|| $pri == 3 && $_ !~ /\,/ && $date eq $CGI->{'deldate'} )
	      { $error = ${&ShopErrorPri(&ManageError(15 , undef), 1 , 14)} if $pri == 3; 
		$pri = 0; last; } } 
	  } if( $pri == 3 && $SForm->{'SYS_ChatMasKey'} eq $CGI->{'bpass'} 
		&& $CGI->{'cdat'} eq 'ALL' ){ undef @{$Cd}; push(@{$Cd}, "$CGI->{'deldate'}\n"); }
	  if( $pri )
	  { $logtmp = $logile . '_tmp';
	    unshift(@{$Cd}, "$TIME[10]\, $CGI->{'mid'}\,$CGI->{'name'}\,$CGI->{'comment'}\,$CGI->{'vpass'}\,\n") if $pri == 1;
	    return \$error if ($error = ${&tmplock($logtmp)});
	    return \('LogTmpFile Open Error') if &FilePrintOpen(\$logtmp); }
	} $chat .= $error . "\n" if $error;
	$chat .='<hr size=1>' . "\n";
	my $end = $CGI->{'log'} || $SForm->{'SYS_ChatView'};
	foreach (@{$Cd})
	{ if( $c < $SForm->{'SYS_ChatView'} )
	  { @com = split(/\,/, $_);
	    next if( !$_ || $_ =~ /^(\r)?\n$/ || $_ =~ /^\,/ 
		|| ($pri == 3 || $com[4] && $CGI->{'bpass'} eq $com[4]) && &ManageChatDelCheck($com[0]) );
	    &FileDataPrint(\$_) if $pri; next if $_ !~ /\,/;
	    if( $c < $end )
	    { $chat .= '<input type="checkbox" name="cdat" value="' . $com[0] . '">' . "\n";
	      $chat .= $com[2] . ' F ' if $com[2];
	      $chat .= $com[3] . ' ( ' . $com[0] . ' )' . '<hr size=1>' . "\n"; }
	  } $c++;
	} &FilePrintClose(\$logile, \$logtmp) if $pri; \$chat;
}

sub ManageChatDelCheck
{	my ($del, $date) = (0, shift);

	#if( exists $CGI->{'cdat'}[0] )
	if( $#{$CGI->{'cdat'}} > 0 )
	{ foreach (@{$CGI->{'cdat'}} )
	  { if( $_ eq $date ){ $del = 1; last; } } } 
	elsif( $CGI->{'cdat'} eq $date )
	{ $del = 1; } $del;
}

;####################################################
;#############  Ǘ[U[֘A   ##############
;#################################################### 

sub ManageListReget
{	undef $CGI->{'disp'}; 
	&MembUserGetList(undef, 5);
}

sub ManageUserListDisp
{	my ($maneg, $c) = (undef, 0);
	$FORM .= "<br><table width=\"99%\" CLASS=font14 cellspacing=1 cellpadding=2 border=0>\n";
	$FORM .= "<tr bgcolor=\"#88BBAA\"><td></td><td> ( ID )</td><td>[</td><td>l</td></tr>\n";
	foreach (@udData)
	{ if( $_ =~ /(\/([A-Z]+)\/([\d]+)\/([\d]+)\/)\.info$/ )
	  { my ($mode, $uid) = ($1, $2 . $3 . $4);
	    my $Mana  = &FileOpen(\$_, 2, 1);
	    my @Mail  = split(/\,/, $Mana->{'Mail'});
	    my @admi  = split(/\,/, $Mana->{'ManaType'});
	    my $color = $c % 2 ? '#FFFFEE' : '#EEEEEE';
	    my $name  = !$Mana->{'Name'} ? '(  Null )' : '<b>' . $Mana->{'Name'} . '</b>';
	    my $mname = !$Mail[4] ? '( Null )' : $Mail[4];
	    my $mail  = !$Mail[5] ? ' Null' : '<a class=lm href=mailto:$Mail[5]>' . $Mail[5] . '</a>';
	    my ($etc, $etc2)   = (undef, undef);
	    if( $SS->{'ADMIN_ID'} eq $uid )
	    { $etc  = '<font color="#FF0000">Ǘ</font>' . 'A'; } else
	    { $etc  = ${&ManageRadioFormData(0, $admi[0])} . 'A' if $admi[0];
	      $etc .= ${&ManageRadioFormData(1, $admi[1])} . 'A' if $admi[1]; }
	    $etc =~ s/(.*)A$/$1/o;
	    $etc = '<b>ǗF</b>' . $etc if $etc;
	    $etc2  = ($Mail[0] && $Mail[1] ? 'OrderM' : 
		      $Mail[0] ? 'OrderM' : 'OrderM') . 'A' if $Mail[0] || $Mail[1];
	    $etc2 .= 'Error\' . 'A' if $Mail[2];
	    $etc2 .= ${&ManageMailNotiList($Mail[3], 0)} . 'A' if $Mail[3];
	    $etc2 =~ s/(.*)A$/$1/o;
	    $etc .= '<br>' if $etc && $etc2;
	    $etc = $etc . '<b>MailF</b>' . $etc2 if $etc2;
	    $etc .= '<br>' if $etc;
	    $etc .= '' . $Mana->{'Etc'} if $Mana->{'Etc'};
	    $Mana->{'Name'} = '( None )' if !$Mana->{'Name'};
	    $FORM .= "<tr bgcolor=\"$color\">\n";
	    $FORM .= "<td width=10><input type=\"radio\" name=\"mode\" value=\"3.$mode\"></td>\n";
	    $FORM .= "<td width=100>$name ( $uid )</td>\n";
	    $FORM .= "<td width=200>$mname<br> &lt; $mail &gt;</td>";
	    $FORM .= "<td>$etc</td>\n</tr>\n"; undef %{$Mana}; $c++;
	  }
	} $FORM .= "\n</table>\n";
}

sub ManageAdminDisp
{	my $dis = shift;
	if( $dis && $dis <= 2 )
	{ $udir = $dis == 1 ? &MembUidDir($CGI->{'mid'}) : $UDIR;
	  $Mana = $CGI->{'disp'} !~ /^0\./ || $dis == 1
	   ? &ManageInfoData($udir, 0) : &ManageAddDataPut() if $CGI->{'disp'} !~ /(a|m)for\_/;
	  if( $dis == 2 )
	  { return &ManageInfoFormDisp(); } else
	  { @Admin = $SS->{'ADMIN_ID'} eq $CGI->{'mid'} 
		? (7, 7, 7) : split(/\,/, $Mana->{'ManaType'}); 
		my $sid = $MANAG_HEDID . '000000';
		$Admin[2] = 8 if $CGI->{'mid'} =~ /^$sid$/i; return @Admin; } } else
	{ my $error = &ManageInfoData($UDIR, $dis == 3 ? 1 : 2); 
	  &ManageListReget(); return $error; }
}

sub ManageInfoData
{	my ($udir, $dis) = @_;
	my $dir = $SS->{'MEMB_DIR'};
	my $rdir = $dir . $udir;
	my $mfile = $rdir . '.info';

	if( !$dis )
	{ &FileOpen(\$mfile, 2, 0) if -f $mfile; } else
	{ if( $$AddError ) 
	  { &ManageAdminDisp(2); } else
	  { my ($error, $data, $root) = (undef, undef, $dir . $HeadID . '/');
	    my ($dir1, $dir2) = 
	       ($root . $1, $root . $1 . '/' . $2) if $udir =~ /^$MANAG_HEDID\/([\d]{3})\/([\d]{3})\/$/;
	    if( $dis == 2 )
	    { my $err = !(-d $rdir) ? 39 : $SS->{'ADMIN_ID'} eq $UIDC ? 40 : 0;
	      return &ShopErrorPri(&ManageError($err, undef), 1 , 14) if $err;
	      foreach (@{&FileListOpen(\$rdir)}){ next if /^(\.|\.\.)$/; unlink($rdir . $_); } 
	      $error = &ManageAddClean($dir1, $dir2, 1); } else
	    { my $mtmp = $mfile . '_tmp';
	      mkdir($dir1, 0755) if !(-d $dir1); mkdir($dir2, 0755) if !(-d $dir2);
	      if( &FilePrintOpen(\$mtmp) )
	      { $error = &ManageAddClean($dir1, $dir2); } else
	      { while (my ($key, $val) = each %{$Mana})
	        { $data .= $key . '="' . $val . '"' . "\n" if $key; }
	        print TMPFILE $data;
	        &FilePrintClose(\$mfile, \$mtmp);
	        if( -f $mtmp || !(-f $mfile) )
	        { unlink($mtmp); $error = &ManageAddClean($dir1, $dir2); } }
	    } $error;
	  }
	}
}

sub ManageAddClean
{ 	my @dir = @_;
	rmdir $dir[1] if -d $dir[1];
	foreach (@{&FileListOpen(\$dir[0])}){ next if /^./; $c++; } 
	rmdir $dir[0] if !$c;
	if( !$dir[2] )
	{ &ShopErrorPri(&ManageError(35, 'o^'), 1 , 14); } else
	{ -d $dir[1] ? &ShopErrorPri(&ManageError(35, '폜'), 1 , 14) : "ID [ $UIDC ] 폜܂B"; }
}

sub ManageInfoFormDisp
{ 	my $mform = undef;
	return \$mform if !$Admin[2];
	my @mail  = split(/\,/, $Mana->{'Mail'});
	my $add = 1 if $CGI->{'disp'} =~ /^(0\.|afor)/;
	my $selec = &ManageMailNotiList(0, $mail[3]);
	my ($width, $color1, $color2) = (120, '#F7F7F7', '#FFFFFF');
	my $mark = "<font color=\"$color2\"></font>";

	$mform .= ${&ShopErrorPri($AddError, 1 , 14)} . "<br>\n" if $$AddError;
	$mform .= "<br>\n";
	$mform .= "<table width=\"99%\" CLASS=font14 bgcolor=\"#DDDDDD\" cellspacing=1 cellpadding=2 border=0>\n";
	if( $add ) 
	{ $mform .= <<"CANCELL";
  <tr>
    <td width=$width bgcolor="$color1">$mark o^ID</td>
    <td bgcolor="#F7F7F7">$HeadID<input type="text" size="10" name="M_id" value="$CGI->{'M_id'}"> (*6p)</td>
  </tr>
CANCELL
	}
	$mform .= <<"CANCELL"; 
  <tr>
    <td width=$width bgcolor="$color1">$mark </td>
    <td bgcolor="$color2"><input type="text" size="20" name="M_Name" value="$Mana->{'Name'}"></td>
  </tr>
  <tr>
    <td width=$width valign=top bgcolor="$color1">$mark E-mail</td>
    <td bgcolor="$color2">Mail Name F <input type="text" size="20" name="M_mName" value="$mail[4]"><br>
        Mail Address F <input type="text" size="30" name="M_mail" value="$mail[5]"></td>
  </tr>
CANCELL
	local($checked) = $SForm->{'form_checked'};	
	if( $add || $UIDC ne $SS->{'ADMIN_ID'} ) 
	{ local(@mana) = split(/\,/, $Mana->{'ManaType'});
	  my ($admi0, $admi1) = $mana[2] ? (undef, $checked) : ($checked, undef);
	  my $sysp = &ManageRadioFormDisp('M_sys', ${&ManageRadioFormData(7, undef)}[0], $mana[0]);
	  my $memp = &ManageRadioFormDisp('M_mem', ${&ManageRadioFormData(7, undef)}[1], $mana[1]);

	  $mform .= <<"CANCELL";
  <tr>
    <td width=$width valign=top bgcolor="$color1">$mark Ǘ`FbN</td>
    <td valign=top bgcolor="$color2">VXe<br>[ $$sysp ]<br>
    Ǘ<br>[ $$memp ]<br>
    <font color="#FF0000">AdminǗ</font><br>[ <input type="radio" name="M_admin" value="0"$admi0>Ǘ
    <input type="radio" name="M_admin" value="1"$admi1>Ǘ ]</td>
  </tr>
CANCELL
	}
	my $ord1  = $checked if $mail[0];
	my $ord2  = $checked if $mail[1];
	my $errm  = $checked if $mail[2];
	$mform .= <<"CANCELL";
  <tr>
    <td width=$width valign=top bgcolor="$color1">$mark t[</td>
    <td valign=top bgcolor="$color2"><input type="checkbox" name="M_ord1" value="1"$ord1>Mp
    <input type="checkbox" name="M_ord2" value="1"$ord2>Mp</td>
  </tr>
  <tr>
    <td width=$width valign=top bgcolor="$color1">$mark [\\</td>
    <td valign=top bgcolor="$color2"><input type="checkbox" name="M_err" value="1"$errm>G[̕\\[ɐݒ肷</td>
  </tr>
  <tr>
    <td width=$width bgcolor="$color1">$mark [ʒm</td>
    <td bgcolor="$color2">$$selec</td>
  </tr>
  <tr>
    <td width=$width bgcolor="$color1">$mark l<br></td>
    <td valign=top bgcolor="$color2"><input type="text" size="30" name="M_etc" value="$Mana->{'Etc'}"></td>
  </tr>
</table>
CANCELL
\$mform;

}

sub ManageRadioFormData
{	my ($v, $val) = @_;
	my ($ADVAL, $data)=
	([ [ '0:Ǘ', '1:i֘AǗ', '2:SystemݒǗ', '7:SystemǗ' ],
	  [ '0:Ǘ', '1:OrderǗ','2:Ǘ', '7:Ǘ' ] ], undef);
	if( $v == 7 )
	{ $ADVAL; } else
	{ foreach (@{${$ADVAL}[$v]})
	  { if( $val eq (split(/\:/, $_))[0] ){ $data = (split(/\:/, $_))[1]; last; } }
	  \$data;
	}
}

sub ManageRadioFormDisp
{	my ($radio, $name, $val, $valc) = (undef, @_);
	$valc = 1 if $valc eq '';
	foreach (@{$val})
	{ my @valp = split(/\:/, $_);
	  my $check = $valp[0] eq $valc ? $SForm->{'form_checked'} : undef;
	  $radio .= "<input type=\"radio\" name=\"$name\" value=\"$valp[0]\"$check>$valp[1]\n";
	} \$radio;
}

sub ManageSelectFormDisp
{	my ($select, $name, $val, $valc, $noc, $date) = (undef, @_);
	$valc = 1 if !$noc && $valc eq '';
	$select = "<select name=\"$name\" size=\"1\">\n";
	$select .= "<option value=\"\">$noc</option>\n" if $noc;
	foreach (@{$val})
	{ my @valp = split(/\:/, $_);
	  next if !$date && !$valp[1];
	  $valp[0] = sprintf("%02d", $valp[0]) if $date > 1;
	  $valp[1] = $valp[0] if $date;
	  my $check = $valp[0] eq $valc ? $SForm->{'form_selected'} : undef;
	  $select .= "<option value=\"$valp[0]\"$check>$valp[1]</option>\n";
	} $select .= "</select>\n"; \$select;
}

sub ManageMailNotiList
{	my ($forc, $sele, $noti) = (shift, shift, undef);
	my @keyc = ('0,[ʒm', '1,VXeG[[ʒm', 
			'2,o^EύX[ʒm', '3,Epsilonϊ֘A[ʒm', 
				'4,֘ASẴ[ʒm', '5,SẴ[ʒm');
	foreach (@keyc)
	{ my @key = split(/\,/, $_);
	  next if !$SS->{'EPSI_SET'} && $key[0] =~ /^(3|4)/;
	  if( !$forc )
	  { my $select = $key[0] eq $sele ? $SForm->{'form_selected'} : undef;
	    $noti .= "<option value=\"$key[0]\"$select>$key[1]</option>\n"; } else
	  { if( $forc eq $key[0] ){ $noti = $key[1]; last; } }
	}
	$noti = '<select name="M_noti" size="1">' . $noti . "</select>\n" if !$forc;
	\$noti;
}

sub ManageAddDataCheck
{	my $add = $_[0] eq 'a' ? 1 : 0;
	$UIDC = $HeadID . $CGI->{'M_id'} if $add; $UDIR = &MembUidDir($UIDC);
	$CGI->{'Did'} = $UIDC;
	my $error = undef;
	my $Mana  = &ManageAddDataPut();
	my @mail  = split(/\,/, $Mana->{'Mail'});
	if( $add )
	{ return &ManageError(31, 'o^ID'), $Mana if $Mana->{'Aid'} !~ /^$HeadID[\d]{6}$/;
	  return &ManageError(30, undef),    $Mana if -d $SS->{'MEMB_DIR'} . $UDIR; } else
	{ return &ManageError(13, undef),    $Mana unless -d $SS->{'MEMB_DIR'} . $UDIR; }
	return &ManageError(33, $u),       $Mana if $mail[0] && ($u = &MailCheckDisp(0, 'add'));
	return &ManageError(33, $u),       $Mana if $mail[2] && ($u = &MailCheckDisp(2, 'add'));
	return &ManageError(32, undef),    $Mana if !$mail[5] && 
				       ($mail[0] || $mail[1] || $mail[2] || $mail[3]);
	return &ManageError(31, 'Mail'),   $Mana if $mail[5] && 
		$mail[5] !~ /^([\w\.\-\+\/]+)\@([\w\-]+)\.([\w\.\-]+)$/; return $error, $Mana;
}

sub ManageAddDataPut
{	my %Mana = undef;
	$CGI->{'M_sys'}   = 0 if !$CGI->{'M_sys'};
	$CGI->{'M_mem'}   = 0 if !$CGI->{'M_mem'};
	$CGI->{'M_admin'} = 0 if !$CGI->{'M_admin'};
	$Mana{'ManaType'} = "$CGI->{'M_sys'}\,$CGI->{'M_mem'}\,$CGI->{'M_admin'}\,";
	$Mana{'Name'} =  $CGI->{'M_Name'};
	$Mana{'Mail'} = "$CGI->{'M_ord1'}\,$CGI->{'M_ord2'}\,$CGI->{'M_err'}\,$CGI->{'M_noti'}\," . 
			"$CGI->{'M_mName'}\,$CGI->{'M_mail'}\,$UIDC";
	$Mana{'Etc'}  =  $CGI->{'M_etc'};
	$Mana{'Aid'}  = $UIDC;
	#while (my ($key, $val) = each %{$CGI}){	undef $CGI->{$key} if $key =~ /^M\_/; } 
	\%Mana;
}

;####################################################
;###############  OC֘A   ################
;#################################################### 

sub LoginAttackCheck
{	my ($atype, $vfile) = @_;
	my $adir = $SS->{'CACHE_DIR'} . 'attack/';
	my $addr = $USER->{'addr'}; $addr =~ s/(\.|\:)/\_/g; $addr = s/\_[A-Z0-9]$//o if $PTB;
	my (@Attack, @Alog);
	if( $vfile )
	{ my $file = $adir . $vfile;
	  if( $atype != 9 ){ @Alog = @{&FileOpen(\$file, 0, 1)}; } 
	  else { if( -f $file ){ unlink($file); } 
	  else { $Error = &ShopErrorPri((&ManageError(2, ''), 1, 14)); } } } 
	else
	{ foreach (@{&FileListOpen(\$adir)})
	  { my $file = $adir . $_;
	    if( /^[A-Z0-9]+\_[A-Z0-9\_]+\_Attack$/ )
	    { if( $atype == 9 ){ unlink($file); }
	      else{ push(@Attack, $_ . '^' . ${&FileOpen(\$file, 0, 1)}[0]); } 
	    } @Attack = sort @Attack;
	  }
	} \@Attack, \@Alog;
}

sub ManageLoginListDisp
{	my $tfc = shift;
	my $ltfile = $SS->{'MEMB_DIR'} . $UDIR . 'LoginTime';
	if( !$tfc )
	{ @LTime = @{&FileOpen(\$ltfile, 0, 1)};
	  $lmsg = &MembLoginMsg(1); \$lmsg; } 
	elsif( $SS->{'MEMB_LIMIT'} )
	{ !(-f $ltfile) ? 1 : &FileDateCheck($ltfile, $SS->{'MEMB_LIMIT'}); }
}

;####################################################
;###############  I[_[֘A   ################
;#################################################### 

sub ManageOrderDispCheck
{	my ($order, $refile) = @_;
	my ($clean, $oNo, $opt, @odata) = (0, split(/\./, $CGI->{'opNo'}));
	local($EMsg, %OFCheck, %RFCheck) = (undef, undef, undef);
	$ERROR = &ShopErrorPri(&ManageError(100, 'GetID_O'), 1 , 14) if !$DMO;
	if( !$ERROR && $CGI->{'odis'} =~ /^[\d]\./ )
	{ $ERROR = &ShopErrorPri(&ManageError(1, 'I[_['), 1 , 14) if !$CGI->{'opNo'};
	  $ERROR = &ShopErrorPri(&ManageError(4, $oNo), 1 , 14) if $refile->{$oNo}; }

	if( !$ERROR )
	{ my $orderDir = (&MembOrderFileCheck($DMO))[0];
	  my $orderfile = $orderDir . (split(/\,/, $order->{$oNo}))[0];
	  if( $CGI->{'odis'} =~ /^(R|U)\./ ){ %OFCheck = %{$order}; %RFCheck = %{$refile}; $clean = $1; }
	  elsif( $CGI->{'odis'} =~ /^9\./ ) { rename($orderfile, "$orderfile\-\-"); } 
	  elsif( $CGI->{'odis'} =~ /^N\./ )
	  { local($OIV) = ManageOrderInevData();
	    my ($prifile, $upoNo, $data) = ($orderDir . $CGI->{'fileup'}[1], undef, undef);
	    if( $CGI->{'fileup'}[1] =~ /^([\d]{12}[\d]{6})\_[\d]+(\.[\d]+)?(\-[\d]+\_)?$/ )
	    { $upoNo = $1;
	      my $chcfile = $orderDir . (split(/\,/, $order->{$upoNo}))[0];
	      $errc = $CGI->{'fileup'} =~ /^ERROR Size/ ? 49 : 
		$CGI->{'fileup'} =~ /^ERROR/ ? 50 : -f $chcfile ? 18 : 0; } else { $errc = 17; }
	    if( !$errc )
	    { foreach (split(/\n/, $CGI->{'fileup'}[0]))
	      { if(/^($Lmatc)?([\w\-\^\.]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/)
	        { ($errc, $emsg) = &ManageOrderDataCheck($2, $6 || $7 || $8); 
		  last if $errc; $data .= $_ . "\n"; } 
	      } ($errc, $emsg) = &ManageOrderInevDataCheck($OIV) if !$errc;
	      $emsg = 'Abvt@C' . $emsg if $errc;
	    }
	    if( $errc )
	    { $ERROR = &ShopErrorPri(&ManageError($errc, $emsg), 1 , 14); } else
	    { &FilePrint(\$prifile, \$data, 0, 0); 
	      undef $CGI->{'fileup'}; undef $CGI->{'odis'};
	      $EMsg = '<b>VKI[_[t@CAbv܂B</b>'; } }
	  else
	  { my ($orename, $stc, $ptc, $rec, $std) = (undef, 0, undef, 0, 0); 
	    ($orename, $stc, $ptc, $pend) = ($1, $2, $3, $4) 
	      if $orderfile =~ /(.*[0-9]+\_)([\d]+)(\.[\d]+)?(\-[\d]+\_)?$/; #$ptc = undef if $std == 1;
	    if( $CGI->{'odis'} =~ /^(1|2)\./ )
	    { $std = $1;
	      $rec = $CGI->{'odis'} =~ /^1\./ ? 
		($stc == 11 ? 1 : $stc == 31 ? 3 : $stc == 41 ? 4 : $stc == 61 ? 6 : $stc == 71 ? 7 : 0) :
		 $stc == 1 ? 11 : $stc == 3 ? 31 : $stc == 4 ? 41 : $stc == 6 ? 61 : $stc == 7 ? 71 : 0; } else 
	    { $orename = $orderfile; $orename =~ s/(.*)\.[\d]+(.*)/$1/o; }
	    system("cp $orderfile $orderfile\-\-") if !$std || $std && $rec;
	    if( $std && $rec )
	    { my $reofile = $orename . $rec . $ptc . $pend; rename($orderfile, $reofile);
	      &MembOrderDateDisp($reofile) if $CGI->{'odis'} =~ /^2\./ && $CGI->{'Date'}; }
	    elsif( $CGI->{'odis'} =~ /^3\./ )
	    { $CGI->{'Order'} =~ tr/0-9//cd;
	      $orename .= $ptc; $orename .= '-' . $CGI->{'Order'} . '_' if $CGI->{'Order'} =~ /^[\d]{18}$/;
	      rename($orderfile, $orename); }
	    elsif( $CGI->{'odis'} =~ /^4\./ && $CGI->{'opt'} =~ /^[\d]+$/ )
	    { rename($orderfile, $orename . '.' . $CGI->{'opt'} . $pend); }
	  } @odata = &MembOrderRead($DMO, 0, $clean);
	} $ERROR, \@odata, \$EMsg;
}

sub ManageOrderDataCheck
{	my ($errc, $key, $val) = (0, @_);
	my %lim = ( 'order_number' => 18, 'conveni_code' => 2, 'paid' => 1, 'payment_code' => 1 );
	if( $key =~ /(date|limit|time)$/ ){ $val =~ tr/0-9\: \-\///cd; } 
	elsif( $key eq 'user_id' ){ $val =~ tr/A-Z0-9//cd; }
	elsif( $key eq 'item_code' ){ $val =~ tr/A-Z0-9\-\.\/\@//cd; }
	elsif( $key eq 'st_code' ){ $val =~ tr/0-9\-//cd; }
	elsif( $key !~ /(_name|_url)$/ )
	{ $val =~ tr/0-9//cd; 
	  if( $val && $lim{$key} && $lim{$key} != length($val) )
	  { $errc = 8; $emsg = $ES->{$key} . "[$key]"; } 
	} $OIV->{$key} = $val if !$errc && exists $OIV->{$key};	$errc, $emsg;
}

sub ManageOrderInevData
{	my %OIV = ( 'shop_date' => '', 'st_code'   => '', 'order_number' => '', 
		    'item_code' => '', 'item_name' => '', 'item_price'   => '' ); \%OIV;
}

sub ManageOrderInevDataCheck
{	my ($errc, $emsg, $OD) = (0, undef, shift);
	while (my ($key, $val) = each %{$OD})
	{ if( $key && !$val )
	  { $errc = 16; $emsg = $ES->{$key} . "[$key]"; $ErrorKey = $key; last; } 
	} $errc, $emsg;
}

sub MembOrderDateDisp
{	my ($pridata, $o, $orderfile) = (undef, 0, shift);
	my $keypri = $orderfile =~ /^[\d]+\_3/ ? 'conveni_date' : 'last_update';
	my $OD = &FileOpen(\$orderfile, 0, 2);
	return if $OD eq 'ERROR';
	foreach (@{$OD})
	{ if( /^($Lmatc)?($keypri)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/ )
	  { $_ = $2 . '="' . $CGI->{'Date'} . "\"\n"; $o = 1; }
	  $pridata .= $_;
	} $pridata .= $keypri . '="' . $CGI->{'Date'} . "\"\n" if !$o;
	&FilePrint(\$orderfile, \$pridata, 0, 0);
}

sub MembOrderRegForm
{	my ($order, $rfile, $rec, $error, $aerr, $NOD, 
		$dis, $ofile, $OD, $orderf, $refile) = (undef, undef, 0, undef, undef, 0, @_);
	my $noviwe = 'contract_code|memo|result';

	local($OIV) = undef;
	if( $dis == 1 )
	{ $order = "$TC->{'li5'}<br>\n" }
	elsif( $dis == 2 )
	{ $OIV = ManageOrderInevData();
	  $rfile = $$ofile . '--';
	  if( -f $rfile ){ $error = &ShopErrorPri(&ManageError(4 , 
		"̃I[_[t@C"), 1 , 14); $rec = 1; } }
	elsif( $CGI->{'odis'} =~ /^(R|U)\./ )
	{ my $clean = $1; local(%OFCheck) = %{$orderf}; local(%RFCheck) = %{$refile};
	  $rec = (&MembOrderRead($DMO, 0, $clean))[3];
	  return FileOpen($ofile, 2, 0), $rec;
	}
	foreach (@{$OD})
	{ my ($key, $val) = split(/\=/, $_);
	  if( $dis =~ /^(1|3)/ )
	  { next if $key =~ /^($noviwe)/;
	    $order .= '<font color="#FF00FF"><b>I</b>Error</font> ' if $dis == 3 && $ErrorKey eq $key;
	    if( $key =~ /(item\_|st\_|paid|receipt\_|conveni_|last\_|\_url)/ )
	    { $val = $CGI->{$key} if $dis == 3;
	      my $len = length($val) + 2;
	      my $size = !$len ? 15 : $len > 40 ? 40 : $len + 2;
	      $val = "<input type=\"text\" size=\"$size\" name=\"$key\" value=\"$val\">\n"; } else
	    { $order .= "<input type=\"hidden\" name=\"$key\" value=\"$val\">\n"; }
	    $order .= $ES->{$key} . ' ( ' . $key . ' ) = ' . $val . '<br>'; } 
	  elsif( $dis == 2 )
	  { $nval = $key =~ /^($noviwe)/ ? \$val : \$CGI->{$key};
	    my ($errc, $emsg) = &ManageOrderDataCheck($key, $$nval);
	    if( $errc )
	    { $ERROR = &ShopErrorPri(&ManageError($errc, $emsg), 1 , 14);
	      $ErrorKey = $key; last; 
	    } $order .= $key . '="' . $$nval . '"' . "\n" if !$$error; $NOD->{$key} = $$nval; }
	} 
	if( $dis =~ /(1|3)$/ )
	{ if( $$ERROR ){ $NOD->{'ERROR'} = $$ERROR;  $aerr = 1; }
	  $order .= "ǉf[^ <input type=\"text\" size=\"10\" name=\"addkey\"> = " .
		    "<input type=\"text\" size=\"20\" name=\"addval\"><br>\n"; return $NOD, 0, \$order, $aerr; } 
	elsif( $dis == 2 )
	{ if( !$$ERROR )
	  { ($errc, $emsg) = &ManageOrderInevDataCheck($OIV);
	    $ERROR = &ShopErrorPri(&ManageError($errc, $emsg), 1 , 14) if $errc; }
	  return &MembOrderRegForm(3, $ofile, $OD, $orderf, $refile) if $$ERROR;
	  if( $CGI->{'addkey'} )
	  { $order .= $CGI->{'addkey'} . '="' . $CGI->{'addval'} . '"' . "\n" if !$$error;
	    $NOD->{$CGI->{'addkey'}} = $CGI->{'addval'}; }
	  if( !$$error )
	  { system("cp $$ofile $refile"); $rec = 1;
	    &FilePrint($ofile, \$order, 0, 0); } else
	  { $NOD->{'ERROR'} = $$error; } return $NOD, $rec; 
	}
}

sub ManageSalesDisp
{	my ($dir, $file) = @_;
	my ($refile, $fname, $stc) = (undef, $1, $2) if $file =~ /^([\d]+)\_([\d]+)(\.(.*))/;
	my $command = 'ls ' . $dir . ' | grep ' . $fname . '_';
	if(!open(FD, "$command |"))
	{ &Print(&ShopSysError(56, "Can't ls Command $command")); }
	$refile = <FD>; close(FD); chop($refile);
	if( $refile =~ /^([\d]+\_)([\d]+)(\.(.*))/ )	
	{ my $restc = $2;
	  if( $stc ne $restc )
	  { local($retype) = $restc =~ /^(11|31|41|61|71)$/ ? 1 : $restc =~ /^(1|3|4|6|7)$/ ? 0 : -1;
	    local($OD) = &MembOrderNoGet($dir . $refile, 2);
	    $OD->{'order_number'} = $fname if !$OD->{'order_number'};
	    $OD->{'shop_date'} = $fname if !$OD->{'shop_date'};
	    &ManageSalesDataDisp() if $OD->{'shop_date'} && $retype >= 0;
	  }
	} 
}

sub ManageSalesDataDisp
{	my ($y, $m, $d) = ($1 + 2000, $2, $3) if $OD->{'shop_date'} =~ /^([\d]{2})([\d]{2})([\d]{2})/; 
	my ($sfile, $y1, $m1, $d1, $y2, $m2, $d2, @Sfile) = (undef, $y, $m, $d, $y, $m, $d);
	$Sfile[0] = $y . '/' . $y . sprintf("%02d", $m) . sprintf("%02d", $d);
	if( $d1 == 1 )
	{ $y1 -= 1 if $m1 == 1; $m1 = $m1 == 1 ? 12 : $m1 - 1; $d1 = &DateEndDayCheck($y1, $m1); } 
	else { $d1 -= 1; }
	$Sfile[1] = $y1 . '/' . $y1 . sprintf("%02d", $m1) . sprintf("%02d", $d1);
	if( $d2 == &DateEndDayCheck($y2, $m2) )
	{ $y2 += 1 if $m2 == 12; $m2 = $m2 == 12 ? 1 : $m2 + 1; $d2 = 1; } 
	else { $d2 += 1; }
	$Sfile[2] = $y2 . '/' . $y2 . sprintf("%02d", $m2) . sprintf("%02d", $d2);
	foreach my $sname (@Sfile)
	{ $sfile = $SS->{'SALE_DIR'} . $sname . '.dat';
	  &ManageStatiErrData($sfile, $sfile . '_err') if -f $sfile . '_err';
	  last if -f $sfile && grep(/^[\d]+\,$OD->{'order_number'}\,/, 
						@{&FileOpen(\$sfile, 0, 0)}); undef $sfile;
	} return 0 if !$sfile;
	my $saltemp = $sfile . '_tmp';
	&lockche($saltemp);
	unless( -f $saltemp )
	{ system("cp $sfile $saltemp");
	  if( -f $saltemp )
	  { my ($SD, $data) = (&FileOpen(\$saltemp, 0, 0), undef);
	    foreach my $line (@{$SD})
	    { $line =~ s/(\r)?\n$//g;
	      $line = $1 . $retype . $4 if $line =~ /^([\d]+\,$OD->{'order_number'}\,(.*)\,)([\d]+)?(\,)$/;
	      $data .= $line . "\n" if $line;
	    } $data =~ s/\n$//o; &FilePrint(\$saltemp, \$data, 0); rename($saltemp, $sfile);
	  }
	}
}

sub ManageStatiErrData
{	my ($file, $efile) = @_;
	my $saltemp = $file . '_tmp';
	Sys::lockche($saltemp);
	unless( -f $saltemp )
	{ system("cat $file $efile > $saltemp");
	  if( -f $saltemp ){ unlink($efile) if rename($saltemp, $file); }
	}
}

sub MembCardFlugDisp
{	my ($uid, $add, $del) = @_; 
	my ($cardadd, $carddel) = (&MembOrderFileCheck($uid))[1 .. 2];
	if( $add || $del)
	{ &FilePrint(\$cardadd, \$CGI->{'Card'}, 0) if !(-f $cardadd); } else
	{ unlink($cardadd) if -f $cardadd; }
	if( $del )
	{ &FilePrint(\$carddel, undef, 0) if !(-f $carddel); } else
	{ unlink($carddel) if -f $carddel; }
}

sub LicenLimitDayCheck
{	my ($d, $ldata) = (undef, shift);
	for($d = 31; $d >= 0; $d--)
	{ my @Date = localtime(time + ($d*24*60*60 + $SS->{'TIME_ADJUST'}*60*60));
	  $Date[5] = $Date[5] > 100 ? $Date[5] + 1900 : $Date[5] + 2000;
	  my $date = sprintf("%d%02d%02d", $Date[5], $Date[4] + 1, $Date[3]);
	  if( $ldata == $date){ $d += 1; last; }
	} $d;
}

sub LicenLimitDateDisp
{	my ($lmsg, $date, $mup, $up) = (undef, @_);
	my $Now = "20" . $TIME[11];
	my $Time = &DateCheckDisp(30, 1, 1);
	my $ltype = 1 if $date =~ /^\-1\,/;
	($mup, $date) = split(/\,/, $date);
	$Now =~ s/([\d]{8})(.*)/$1/o; $date =~ s/\///g;
	if($date =~ /^([\d]{4})([\d]{2})([\d]{2})$/)
	{ my ($y, $m, $d) = ($1, $2, $3);
	  if( $mup )
	  { $m =~ s/^0//; $mup = 1 if $up; $m += $mup;
	    if( $m > 12 ){ $y += 1; $m = $m % 12; }
	    elsif( $m == 0 ){ $y -= 1; $m = 12; }
	    if( $up ){ $d = 1; }
	    elsif( $m != 2 ){ $d = $m =~ /^(4|6|9|11)$/ ? 30 : 31; } 
	    else { $d = $y % 4 ? 28 : 29; }
	  } my $limit = sprintf("$y%02d%02d", $m, $d);
	  my ($color, $msg) = 
	  $limit < $Now  ? ('#FF0000', ' ؂') :
	  $limit < $Time ? ('#FF00FF', ' L' . LicenLimitDayCheck($limit) . '') : (undef, undef);
	  $lmsg = !$ltype ? ' ' : 'CZX ';
	  $lmsg .= "<font color=\"$color\">" . sprintf("$y/%02d/%02d", $m, $d) . "$msg</font>"; } else 
	{ $lmsg = 's 0000/00/00'; }
	if( $SS->{'Licence'} )
	{ $SS->{'Licence'} =~ s/\_/\-/g;
	  $LiceNo = ($SS->{'Licence'} =~ /^WS/ ? 'Trial ' : undef) . 'LicenseNo. ' . $SS->{'Licence'};
	} $lmsg = ($LiceNo ? '@ ' . $LiceNo . '<br>' : undef) . '@ ( ' . $lmsg . " )\n";
}

;####################################################
;#############  ev[g֘A   ##############
;#################################################### 

sub ManageTempDirDisp
{	my ($TF, $tdir, $vis) = (undef, @_);
	my $tmach = $vis == 1 ? '(k|p)\_(head|foot)(\_[a-z]+)?' :
		    $vis == 2 ? 'mail[\w]+|[\w]+\_(mail|otoi(E)?)' :
		    $vis == 3 ? '(cart|order|list|explan|picup)[\w]+' : 
		    $vis == 5 ? '(convi\_)[\d]+' : undef;

	foreach (@{&FileListOpen($tdir)})
	{ if( $_ =~ /^($tmach)\.[a-z]+$/ ) { $TF->{$1} = 1; } } $TF;
}

sub ManageTempFileConvert
{	my ($TFCVT, $vis) = (undef, shift);
	if( $vis == 1 )
	{ $TFCVT =
	  { 'P_SH' => [ 
	    [ 'p_head',       'SHOP(default)' ], [ 'p_head_top',   'gbvy[W' ],
	    [ 'p_head_list',  'Xgy[W'],   [ 'p_head_cate',  'JeS[y[W' ],
	    [ 'p_head_cart',  'y[W' ],    [ 'p_head_order', 'I[_[y[W' ] ],
	    'P_SF' => [ 
	    [ 'p_foot', 'SHOPtb^(default)' ], [ 'p_foot_top',   'gbvtb^' ],
	    [ 'p_foot_list',  'Xgtb^' ],  [ 'p_foot_cate',  'JeS[tb^' ],
	    [ 'p_foot_cart',  'tb^' ],    [ 'p_foot_order', 'I[_[tb^' ] ],
	    'P_MH' => [ 
	    [ 'p_head_mem',   '(default)' ], 
	    [ 'p_head_login', 'LOGINy[W(SHOP)' ], [ 'p_head_memin', 'LOGINy[W()' ],
	    [ 'p_head_mema',  'o^y[W' ], [ 'p_head_memb'  => 'C' ] ],
	    'P_MF' => [
	    [ 'p_foot_mem',   'tb^(default)' ], 
	    [ 'p_foot_login', 'LOGINtb^(SHOP)' ], [ 'p_foot_memin', 'LOGINtb^()' ],
	    [ 'p_foot_mema',  'o^tb^' ], [ 'p_foot_memb', 'Ctb^' ] ],
	    'K_SH' => [
	    [ 'k_head', 'SHOP(default)' ], 
	    [ 'k_head_top', 'gbvy[W' ], [ 'k_head_view', 'Cy[W' ] ],
	    'K_SF' => [ 
	    [ 'k_foot', 'SHOPtb^(default)' ],
	    [ 'k_foot_top', 'gbvtb^' ], [ 'k_foot_view', 'Ctb^' ] ],
	    'K_MH' => [ 
	    [ 'k_head_login', 'LOGINy[W(SHOP)' ], [ 'k_head_memin', 'LOGINy[W()' ],
	    [ 'k_head_mema', 'o^y[W' ] ],
	    'K_MF' => [
	    [ 'k_foot_login', 'LOGINtb^(SHOP)' ], [ 'k_foot_memin', 'LOGINtb^()' ],
	    [ 'k_foot_mema', 'o^tb^' ] ] 
	  }; }
	elsif( $vis == 2 )
	{ 
	  $TFCVT =
	  { 'M_FOOT' => [
	    [ 'mailfut_p', 'PC[ptb^' ], [ 'mailfut_k', 'gу[ptb^' ], [  ],
	    [ 'Title', '@y[W' ], [ 'memb_otoi', '⍇tH[' ], 
	    [ 'memb_otoiE', 'MbZ[W' ] ],
	    'C_NOTI' => [
	    [ 'madd_mail', 'o^ʒm' ], # [ 'memb_mail', 'ύXʒm' ],
	    [ 'mail_0', 'y[Wʒm' ], [ 'mail_cart', 'I[_[[J[g\' ],
	    [ 'mail_1', 'J[hI[_[ʒm' ], [ 'mail_3', 'RrjI[_[ʒm' ] ],
	    'C_USER' => &ManageUserTempFileConvert(),
	    'C_CONV' => [ 
	    [ 'mail_11', 'ZuCutʒm' ], [ 'mail_21', 't@~[}[gtʒm' ],
	    [ 'mail_31', '[\tʒm' ],       [ 'mail_32', 'ZCR[}[gtʒm' ],
	    [ 'mail_33', '~jXgbvtʒm' ],   [ 'mail_34', 'fC[}ULtʒm' ],
	    [ 'mail_50', 'Rrjxʒm' ] ]
	  }; }
	elsif( $vis == 3 )
	{ $TFCVT =
	  { 'P_ITEM' => [ 
	    [ 'list', 'Xg\' ], [ 'explan', 'ڍו\' ],
	    [ 'cart', 'J[g\' ], [ 'order',  'I[_[\' ], [ 'orderE',  'I[_[ŏI\' ],
	    [ 'picup', 'sbNAbv\' ] ],
	    'K_ITEM' => [ 
	    [ 'list_k',      'Xg\' ], [ 'explan_k',    'ڍו\' ], 
	    [ 'explancag_k', '\' ],   [ 'explanpic_k', 'i摜\' ], 
	    [ 'cart_k',      'J[g\' ], [ 'order_k',     'I[_[\' ], [ 'orderE_k',  'I[_[ŏI\' ] ],
	  }; }
	elsif( $vis == 5 )
	{ $TFCVT =
	  { 'C_CONV' => [ 
	    [ 'convi_11', 'ZuCut\\' ], [ 'convi_21', 't@~[}[gt\\' ],
	    [ 'convi_31', '[\t\\' ],        [ 'convi_32', 'ZCR[}[gt\\' ],
	    [ 'convi_33', '~jXgbvt\\' ],   [ 'convi_34', 'fC[}ULt\\' ] ]
	  }; } $TFCVT;
}

sub ManageUserTempFileConvert
{	my $cfile = $SS->{'CONF_DIR'} . $SS->{'FORM_CONF'};
	my ($OD, $c, @Muser, $keydat) = (&FileOpen(\$cfile, 6, 0), 0);
	$Muser[$c] = [ 'mail_70', 'ʃI[_[ʒm' ];
	foreach (sort { $a cmp $b } keys(%{$OD}))
	{ if( $_ =~ /^OP\_([\d]{2})/ )
	  { my $mc = $1; $c++;
	    $Muser[$c] = [ 'mail_' . (70 + $mc), $OD->{$_} . 'I[_[ʒm' ];
	  }
	} \@Muser
}

sub ManageTempFileKey
{	my ($Hkey, $Hval, $TFCVT, $vis) = (undef, undef, @_);
	if( $vis == 1 && $CGI->{'temfile'} =~ /^(p|k)_(head|foot)(\_(\w))?/ )
	{ my ($o, $f, $t) = ($1, $2, $4);
	  $Hkey = $o eq 'p' ? 'P_' : 'K_'; $Hkey .= $t =~ /^(m|l)$/ ? 'M' : 'S';
	  $Hkey .= $f eq 'head' ? 'H' : 'F'; }
	elsif( $vis == 2 )
	{ if( $CGI->{'temfile'} =~ /\_(mail|cart)$/ ){ $Hkey = 'C_NOTI'; } 
	  elsif( $CGI->{'temfile'} =~ /^(mail|memb)([\w]+)/ )
	  { my $f = $2; $Hkey = $f =~ /\_(p|k|otoi)$/ ? 'M_FOOT' : 
		$f =~ /\_7(\d)$/ ? C_USER : $f =~ /\_(\d)$/ ? 'C_NOTI' : C_CONV; } } 
	elsif( $vis == 3 && $CGI->{'temfile'} =~ /[\w]+\_(p|k)$/ )
	{ my $f = $1; $Hkey = $f eq 'k' ? 'K_ITEM' : 'P_ITEM'; }
	elsif( $vis == 5  ){ $Hkey = 'C_CONV'; } 
	my ($key, $c) = (undef, undef);
	if( $vis == 3 && $Hkey eq 'P_ITEM' )
	{ ($key, $c) = ($1, $2) if $CGI->{'temfile'} =~ /^([A-Z]+)(\d)?\_p$/i; } else
	{ $key = $CGI->{'temfile'}; }
	foreach (@{$TFCVT->{$Hkey}})
	{ if( $_->[0] eq $key ){ $Hval = $_->[1] . $c; last; } } $Hkey, $Hval;
}

;####################################################
;#############  ݒtH[֘A   ##############
;#################################################### 

sub ManageEditFormDisp
{	my ($c, $file, $cfile, $vim, $vis) = (0, @_);
	my $spl = $vis == 2 && $CGI->{'temfile'} =~ /^mail\_cart/
		 		|| $vis == 3 && $CGI->{'temfile'} !~ /^picup/ ? 1 : 0;
	&FilePrintOpen($file);
	if( $vim == 2 )
	{ my @key = $spl ? ('LIST_LINE', 'LIST_TOP', 'LIST_VIEW', 'LIST_END') : ('temdate');
	  foreach (@key)
	  { $c++;
	    print TMPFILE $c . "\.\#$_\#\n" if $spl;
	    foreach (split(/\n/, $CGI->{$_}))
	    { s/\r$//o; if( $_ ){ s/\&quot\;/\"/g; s/\&lt\;/</g; s/\&gt\;/>/g; print TMPFILE $_ . "\n"; } }
	    print TMPFILE "\n"; } } else
	{ foreach (@{&FileOpen($cfile, 0, 0)})
	  { s/(\r)?\n$//o;
	    if( $_ =~ /^\#/ || !$_ )
	    { print TMPFILE $_ . "\n"; } 
	    elsif( /^($Lmatc)?([\w\-]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/ )
	    { my $key = $2; my $next = 0;
	      if( $DMO =~ /^3:1/ && $key eq 'Item_Date' && $CGI->{'DateAout'} )
	      { $CGI->{$key} = $TIME[10]; $CGI->{$key} =~ s/\([A-Z]+\)/ /oi; }
	      if( $key =~ /^(FORM\_SET\_[A-Z]+)$/ || !(exists $CGI->{$key}))
	      { $_ = ${&ManageTextareaDisp($1)} if $key =~ /^(FORM\_SET\_[A-Z]+)$/; 
		$_ .= "\n_LINE_END_" if /($Lmatc)?\=($Lmatc)?\_LINE\_$/;
		print TMPFILE $_ . "\n"; next; }
	      s/^($Lmatc)?([\w\-]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?//o;
	      $CGI->{$key} =~ s/\x20/\+/g if $key =~ /\_((BASIC)?KEY|(CRY)?PASS)/;
	      my $etc = $_ ? "\t\t\t" . $_ : undef;
	      my $val = undef; $CGI->{$key} =~ s/\&quot\;/\"/g;
	      if( $key =~ /^Item\_Explanation/ )
	      { $val = $CGI->{$key};
		$val =~ s/[\r\n]+$//go; $val = "_LINE_\n" . $val . "\n_LINE_END_"; } else
	      { $quot = $CGI->{$key} =~ /\"/ ? "'" : '"';
		$val = $CGI->{$key} =~ /[\#\n\x20]+/ ? $quot . $CGI->{$key} . $quot : $CGI->{$key}; }
	      print TMPFILE $key . ' = ' . $val . $etc . "\n";
	    }
	  }
	  if( $CGI->{'UserKey'} =~ /^(User\_[A-Z0-9]+|[A-Z0-9]+\_Mark)$/i && $CGI->{'UserVal'} )
	  { $CGI->{'UserVal'} =~ s/\&quot\;/\"/g; $quot = $CGI->{'UserVal'} =~ /\"/ ? "'" : '"';
	    print TMPFILE $CGI->{'UserKey'} . ' = ' . ($CGI->{'UserVal'} =~ /[\#\n\x20]+/ ? 
				$quot . $CGI->{'UserVal'} . $quot : $CGI->{'UserVal'}) . "\n"; }
	} &FilePrintClose(undef, undef);
}

sub ManageTextareaDisp
{	my ($value, $Keys, $txtkey) = (undef, undef, shift);
	my $keyc = $1 . '_' if $txtkey =~ /^FORM\_SET\_([A-Z]+)$/;
	foreach (split(/\n/, $CGI->{$txtkey}))
	{ if(/^#/){ $value .= $_ . "\n"; } 
	  elsif(/^($Lmatc)?([\w]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/)
	  { my $key = $2; my $val = $6 || $7 || $8; 
	    next if $keyc eq 'CATEGO_' && $key !~ /^[A-Z0-9\_]+$/i ||
		    $keyc eq 'PICUP_' && $key !~ /^(picup[\d]{1}|rank([\d]{1})?)$/  ||
		    $keyc eq 'WISI_' && ($key !~ /^$keyc[A-Z]{1}$/ || 
		    $val !~ /^[0-9]+$/) || $Keys->{$key};
	    $Keys->{$key} = 1;
	    if( $keyc eq 'CATEGO_' || $key =~ /^($keyc|picup[\d]{1}|rank([\d]{1})?)/ )
	    { $value .= $key .' = ' . $val . "\n"; } } 
	} $value =~ s/\n$//o; \$value;
}

sub ManageSysTempDisp
{	local($sfile, $cols, $vis, $disp, $SData) = @_;
	my ($c, $cs, $rows, $dat, $keyc, $form) = (0, 0, 0, undef, undef, "<br>\n");
	my $spl = $vis == 2 && $CGI->{'temfile'} =~ /^mail\_cart/
			|| $vis == 3 && $CGI->{'temfile'} !~ /^picup/ ? 1 : 0;
	my $KN = { 'LIST_LINE' => '1. \\㉺̃C', 'LIST_TOP' => '2. \\̃bZ[W', 
		   'LIST_VIEW' => '3. \\C', 'LIST_END' => '4. \\̃bZ[W' };

	foreach (@{$SData})
	{ s/(\r)?\n$//o;
	  if( $spl )
	  { if( /^\d\.\#(LIST\_[A-Z]+)\#/ )
	    { my $key = $1; $rows = $c < 10 ? 10 : $c < 40 ? $c + 2 : 40; 
	      $form .= ${&ManageFromTextarea($cols, $rows, $keyc, \$dat)} . "<br><br>\n" if $cs;
	      my $none = $CGI->{'temfile'} =~ /^explan/  && $cs =~ /^(0|3)$/ ? ' (  )' : undef;
	      $form .= '<b>' . $KN->{$key} . '</b>' . $none . "<br>\n"; $keyc = $key;
	      $c = 0; undef $dat; $cs++; next; } $dat .= $_ . "\n"; } else 
	  { $dat .= $_ . "\n"; } $c++;
	}
	if( $vis )
	{ $keyc = 'temdate' if !$spl;
	  $rows = $c < 10 ? 10 : $c < 40 ? $c + 2 : 40; 
	  $form .= ${&ManageFromTextarea($cols, $rows, $keyc, \$dat)}; } \$form;
}

sub ManageSysFormDisp
{	local($sfile, $file, $vis, $disp, $SData) = @_;
	local($sys, $trc, $tdc, $tds, $tde, $key, $val, $check, $line, $value, $sub, @dche);
	local($DCheck, $Alp, $DZ, $Errfrom, $Erropri, $Kindc, $error) = 
	( [ '', '[A-Z0-9\+\/\n]+', '[\w\-]+\.[a-z]+', '[0-9]+', '[A-Z0-9]+', '\.[a-z]+',
	    'http(s)?\:\/\/[\w\-\.\/]+', '(\#[A-F0-9]+|[A-Z]+)', '[\w\-]+', '[0-9]+(\%)?',
	    '(.*)\_(.*)', '(.*)\|(.*)', '[0-9\,]+', '(.*)\,(.*)', '(.*)\|[\d]{4}\/[\d]{2}\/[\d]{2}', 
	    '[\d]{5}-[\d]{4}-[\d]{5}', '', '', '', '', '[\d]{4}\/[\d]{2}\/[\d]{2}\x20[\d]{2}\:[\d]{2}\:[\d]{2}' ],
		undef, undef, 0, undef, -2, '<font color="#FF00FF"><b>I</b>Error</font> ');
	my $checform = undef;
	if( $vis == 4 || $DMO =~ /^3:1/ )
	{ my $conf = $SS->{'CONF_DIR'} . ($vis == 4 ? $SS->{'FORM_CONF'} : $SS->{'POSTAGE_CONF'});
	  $checform = '( <input type="checkbox" name="DateAout" value="1" checked="checked">ݒ肷 )' if $vis != 4;
	  $DZ = &FileOpen(\$conf, 2, 1);
	  $Alp = [ 'A','B','C','D','E','F','G','H','I','J','K','L','M',
		   'N','O','P','Q','R','S','T','U','V','X','W','Z' ]; 
	}
	if( !open(FORM, "<$$file") )
	{ $$file = 'FileOpen' . $vis . $disp if !$$file; 
	  &ShopErrorPri(&ManageError(5, $$file), 1 , 14); } else
	{ while (<FORM>)
	  { s/#DATE_AOUT#/$disp ? $checform : undef/eo if $DMO =~ /^3:1/;
	    s/#(form\_(col|siz|mar)[A-Z0-9]+)#/$SForm->{$1}/ig;
 	    if( !$disp )
	    { ($trc, $tdc, $line) = (0, 0, 0) if $trc && $_ =~ /(.*)<\/tr[^>]*>/i;
	      $trc++ if /((.*)<tr[^>]*>)/i;
	      $tdc++ if $trc && $_ =~ /(.*)<td[^>]*>/i;
	      $tds = $1 if $tdc == 2 && !$tds && $_ =~ /((.*)<td[^>]*>)/i; }
	    if( /\#(FORM\_SET\_[A-Z]+([\d]+)?)\#/i )
	    { if( $value ){ $sys .=  $tds . $value; undef $tds; undef $key; undef $value; undef $etc; }
	      &ManageSysFormB($1); } else 
	    { &ManageSysFormA(); }
	  } close(FORM);
	} \$sys, $Errfrom;
}

sub ManageSysFormA
{
	if( !$disp )
	{ if( $tdc == 2 && $tds )
	  { $key = $1 if !$key && $_ =~ /name=\"([A-Z]+(\_[A-Z0-9]+)?(\_[A-Z]+)?)\"/i;
	    if( $key =~ /(DPRICE_|_00|Free)/ ) { $SData->{$key} = ${&PriceCheck(\$SData->{$key})}; }
	    if( (!$value || $line ) 
	    && $key && ($_ =~ /value=\"([^\"]+)\"/i || $_ =~ /(<select |<textarea )/i) )
	    { $val = $1 if /value=\"([^\"]+)\"/;
	      if( !$check )
	      { if( /(<\!\-\- ([\d]+)(\+)? \-\->)?(<select |<textarea |<input[\x20]+type=(\")?([a-z]+)(\")?)/i )
		{ @dche = ($2, $3); my $type = $6 || $4; $check = $type =~ /^<text/ || $type eq 'text' ? 1 : 2; }
	      } s/<\!\-\- [\d]+(\+)? \-\->//o;
	      if( /(.*F([\x20])?)<input([^>]+)>([^<]*)/ ){ $sub = $1; $line = 1; $etc = $4; }
	      if( $check == 1 )
	      { if( $key eq 'Item_Kind' )
		{ my @kind = split(/\,/, $SData->{$key});
		  $Kindc = $SData->{$key} =~ /\,/ ? $#kind : -1; undef @kind; }
	        if( $key =~ /^(Fixed_Price|Item_Price|Item_Tax|Item_Class)$/ && $SData->{$key} ne '')
		{ if( $Kindc < 0 && $SData->{$key} =~ /\,/ ){ $Erropri = 1; } 
		  else
		  { my @kind = split(/\,/, $SData->{$key});
		    my $kipc = $SData->{$key} =~ /\,/ ? $#kind : -1; undef @kind;
		    $Erropri = 1 if $Kindc != $kipc;
		  }
		} 
		if( $Erropri || $dche[0] && (!$dche[1] || $dche[1] && $SData->{$key}) 
		 && ($dche[0] > 20 && !$SData->{$key} || $dche[0] <= 20 && $SData->{$key} !~ /^$DCheck->[$dche[0]]$/i) )
		{ ($SData->{$key}, $Errfrom) = ($error . $SData->{$key}, 1); $Erropri = 0; }
		$SData->{$key} = '<code>' . $SData->{$key} . '</code>' if $key =~ /\_((BASIC)?KEY|(CRY)?PASS)/;
		$SData->{$key} .= ' ( <font color="'. $SData->{$key} . '"></font> )' 
				if $key =~ /(^(B\_|FCOL\_|ErrCOL)|\_COLOR([A-RT-Z0-9])?$)/i;
		if( $DMO =~ /^3:1/ && !$disp && $dche[0] == 10)
		{ my $keyc = $key; $keyc =~ s/(.*)\_VI$/$1/;
		  my $valc = $keyc =~ /\_Price$/ ? (split(/\,/, $SData->{$keyc}))[0] : $SData->{$keyc};
		  $SData->{$key} =~ s/\_/$valc/o; }
		$value .= $sub . $SData->{$key} . $etc;
		if( $line ){ $value .= "<br>\n"; undef $sub; undef $etc; }
		$etc = $_; $etc =~ s/(.*)<(\/textarea|input)[^>]*>([^<]*)<(.*)/$3/; }
	      elsif( $check == 2 )
	      { my $valc = $_ =~ /value=(\")?([^\"\x20]+)(\")?/ ? $2 : undef;
		$value = $sub . $2 if $valc ne '' && $valc eq $SData->{$key} 
					&& $_ =~ /<(option|input)[^>]+>([^<\n]+)/; 
		if( $line ){ $value .= "<br>\n"; undef $sub; undef $etc; } }
	    }
	    if( $line ){ undef $key; $check = 0; undef $etc; }
	    if( /(.*)(<\/td>(.*))/i )
	    { my ($selm, $etag) = ($1, $2); $etc = $1 if $selm =~ /<\/select>(.*)/;
	      if( $check == 2 && !$value ){ ($value, $Errfrom) = ($error, 1); }
	      $sys .=  $tds . $value . $etc . $etag;
	      undef $tds; undef $tde; undef $key; undef $value; undef $etc; $check = 0; } else { next; }
	  } else { $sys .= $_; } } 
	else
	{ if(  $_ =~ /<\!\-\- ([\d]+)(\+)? \-\-><(select |textarea |input[\x20]+type=)/i )
	  { @dche = ($1, $2); my $keyc = $1 if $_ =~ /name=\"([A-Z]+(\_[A-Z0-9]+)?(\_[A-Z]+)?)\"/i;
	    my $epri = $dche[0] && (!$dche[1] || $dche[1] && $SData->{$keyc}) && 
			($dche[0] > 20 && !$SData->{$keyc} || $dche[0] <= 20 && 
				$SData->{$keyc} !~ /^$DCheck->[$dche[0]]$/i) ? $error : undef;
	    s/<\!\-\- [\d]+(\+)? \-\->/$epri/o; 
	  } $check = 1 if !$check && $_ =~ /(<\!\-\- ([\d]+)(\+)? \-\->)?<(select|input[\x20]+type=(\")?(radio|checkbox)(\")?)/i;
	  if( $check )
	  { $key = $1 if !$key && $_ =~ /name=\"([A-Z]+(\_[A-Z0-9]+)?(\_[A-Z]+)?)\"/i;
	    $val = /value=\"([^\"]+)\"/ ? $1 : undef;
	    $check = /\#form\_(checked|selected)\#/i && $val eq $SData->{$key} ? 2 : /<\/tr>/i ? 3 : 1;
	    if( $check >= 2 )
	    { s/\#(form\_(checked|selected))\#/$check == 2 ? $SForm->{$1} : undef/ei;
	      $check = 0; undef $key; undef $val; } else
	    { s/\#(form\_(checked|selected))\#//i; }
	  } s/\#(form\_(checked|selected))\#//i;
	  s/#([A-Z]+(\_[A-Z0-9]+)?(\_[A-Z]+)?)#/&ManageSysFormValue($check, $_, $1)/eig; $sys .= $_;
	}
}

sub ManageSysFormValue
{	my ($check, $line, $key) = @_;
	if( !$check && $DMO =~ /^3:1/ && $line =~ /type=(\")?text(\")?/ )
	{ $SData->{$key} =~ s/\"/\&quot\;/g; } $SData->{$key};
}

sub ManageSysFormB
{	my $fType = shift;
	my ($pri, $cols, $rows) = (undef, 0, 0);

	if( $fType =~ /\_CATEGO$/ )
	{ my $catec = undef;
	  $pri = ${&ManageCategoryFileDisp($disp, $SData)};
	  ($cols, $rows) = (70, 30) if $disp; }
	elsif( $fType =~ /\_PICUP$/)
	{ $SForm->{'mfline_IMG'} =~ s/(<.*)(\.[a-z]+".*)/$1 . '2' . $2/e;
	  foreach my $data (@{$SData})
	  { if($data =~ /^(picup|rank)/ 
	    && ($data =~ /^($Lmatc)?([\w]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/ 
		 || $disp && $data =~ /^\# sbNAbv/ ) )
	    { if( !$disp )
	      { my $key = $2; my $val = $6 || $7 || $8; 
		$pri .= $SForm->{'mfline_IMG'} . $SForm->{'mfolder_IMG2'} 
		     .  ' ' . $val . " ( $key )<br>\n"; } else { $pri .= $data; } }
	  } ($cols, $rows) = (70, 10) if $disp; }
	elsif( $fType =~ /\_(WISI|ZD)$/ )
	{ my $keyc = $1; my $fdis = $keyc eq 'WISI' ? 1 : $keyc eq 'ZD' ? 2 : 0;
	  foreach (sort { $a cmp $b } keys(%{$SData}))
	  { if( $_ =~ /^$keyc\_[A-Z0-9]+$/ )
	    { if( !$disp )
	      { $pri .= $fdis == 1 ? &ManagePostageView($_, $SData->{$_}, 2) : 
			&ManagePostageView($_, $SData->{$_}, 0); } else
	      { $pri .= $fdis == 1 ? $_ . ' = ' . $SData->{$_} . "\n" : 
			&ManagePostageView($_, $SData->{$_}, 1); } }
	  } 
	  if( $fdis == 2 || $fdis == 1 && !$disp )
	  { my $table = '<table CLASS=font13 bgcolor="' . $SForm->{'form_color0'} . 
						'" cellspacing=1 cellpadding=1 border=0>';
	    if( $fdis == 2 && !$disp )
	    { $table .= '<tr bgcolor="' . $SForm->{'form_color1'} . '"><td>@</td>'; 
	      for(0 .. $SData->{'ZDCOUNT'} - 1){ $table .= '<th>' . $Alp->[$_] . '</th>'; }
	      $table .= '</tr>'; }
	    $pri = $table . $pri . '</table>'; }
	  ($cols, $rows) = $fdis == 1 ? (20, 10) : (0, 0) if $disp; }
	elsif( $fType =~ /\_IMAGE([\d]+)$/ )
	{ my ($type, $imgc) = ($1, undef);
	  $pri .= '<tr bgcolor="' . $SForm->{'form_color1'} . '"><td>@</td>'; 
	  $pri .= '<th>PC</th><th>i-mode</th><th>vodafone(J-Sky)</th><th>EZ</th><th>H"</th></tr>' . "\n"; 
	  foreach my $data (@{$SData})
	  { if( $data =~ /^\#/ || $imgc eq '' || $type > $imgc )
	    { $imgc = $1 if $data =~ /^\#SHOP\=([\d]+)/; next; } 
	    elsif( $type < $imgc ){ last; }
	    elsif( $data =~ /^[A-Z0-9]+[\x02\t]+/i )
	    { $data =~ s/(\r)?\n$//o; my @img = split(/[\x20\t]+/, $data); 
	      $pri .= '<tr bgcolor="' . $SForm->{'form_color2'} . '">'; 
	      for (0 .. 5)
	      { my $td = !$_ ? '<td bgcolor="' . $SForm->{'form_color1'} . '">' : '<td>'; 
		$img[$_] =~ s/^(p[\d]+\_[\d]+\_|n|x|y|z)//o; $img[$_] = "( Null )" if !$img[$_];
		$pri .= $td . $img[$_] . '</td>'; } $pri .= '</tr>' . "\n"; }
	  } }
	elsif( $fType =~ /\_FORM$/ )
	{ my ($data, $Hdat) = (undef, undef);
	  foreach my $line (@{&FileOpen($sfile, 3, 2)})
	  { my ($key, $val) = ($1, $2) if $line =~ /^([^\|]+)\|([\x00-\xFF]+)/;
	    next if $key !~ /^(FORM|[a-z0-9]+|END|SEND|CART)\_/;
	    $val =~ s/</&lt;/g; $val =~ s/>/&gt;/g;
	    $pri .= '<tr><td bgcolor="' . $SForm->{'form_color1'} . '">' . $key . '</td>';
	    my @Dat = split(/[\x20\t]+/, $val);
	    if( $key =~ /^(ns|or|se|oh|op)\_[a-z]+/ )
	    { my $c = 0;
	      if( $#Dat != 8 )
	      { $Errfrom = 1; $pri .= '<td bgcolor="' . $SForm->{'form_color2'} . '" colspan=9>' . $error . '</td>'; } else
	      { foreach $data (@Dat)
		{ $Hdat->{$data} = $data if $c == 2 && $data =~ /[A-Z]\_/; $c++;
		  $pri .= '<td bgcolor="' . $SForm->{'form_color2'} . '">' . $data . '</td>'; } } } else
	    { if( $key =~ /\_TITLE/ && $#Dat != 2){ $Errfrom = 1; $val = $error; }
	      $pri .= '<td bgcolor="' . $SForm->{'form_color2'} . '" colspan=9>' . $val . '</td>'; }
	    $pri .= '</tr>' . "\n";
	  }
	  $pri .= '<tr><td bgcolor="#FFFFEE" colspan=10> ȉALf[^[ɔselect/radio/checkbox֘Af[^[</td></tr>' . "\n";
	  foreach $data (sort { $a cmp $b } keys(%{$Hdat}))
	  { my $c = 0; foreach my $key (sort { $a cmp $b } keys(%{$SData}))
	    { if( $data && $key =~ /^$data/ )
	      { $c++; $pri .= '<tr><td bgcolor="' . $SForm->{'form_color1'} . '">' . $key . '</td>';
	        $pri .= '<td bgcolor="' . $SForm->{'form_color2'} . '" colspan=9>' . $SData->{$key} . '</td></tr>' . "\n"; } }
	    if( !$c )
	    { $Errfrom = 1; $pri .= '<tr><td bgcolor="' . $SForm->{'form_color1'} . '">' . $data . '**</td>'
	       .  '<td bgcolor="' . $SForm->{'form_color2'} . '" colspan=9>' . $error . '</td></tr>' . "\n"; } 
	  } }
	elsif( $fType =~ /\_EPSILON$/ )
	{ foreach (sort { $a cmp $b } keys(%{$SData}))
	  { next unless /^(ST_CODE_|CONVI_|[a-z]+\_|M|P)/;
	    my $val = $SData->{$_};
	    if( /^PROCESS\_[\d]/ )
	    { $val =~ s/</&lt;/g; $val =~ s/>/&gt;/g;
	      my @Dat = split(/[\x20\t]+/, $val);
	      if( $#Dat != 2 ){ $Errfrom = 1; $val = $error . $val; } }
	    $pri .= '<tr><td bgcolor="' . $SForm->{'form_color1'} . '">' . $_ . '</td>';
	    $pri .= '<td bgcolor="' . $SForm->{'form_color2'} . '">' . $val . '</td></tr>' . "\n";
	  } }
	elsif( $fType =~ /\_POSTAGE$/ )
	{ if( $DZ->{'ZDCOUNT'} && $SData->{'Post_Code'} && $SData->{'Post_Code'} !~ /^[A-Z]$/ )
	  { $pri .= $error . ' '; $Errfrom = 1; }
	  $SData->{'Post_Code'} = 'ݒ薳' if !$DZ->{'ZDCOUNT'} || !$SData->{'Post_Code'};
	  if( !$disp )
	  { $pri .= $SData->{'Post_Code'}; } 
	  elsif( $DZ->{'ZDCOUNT'} )
	  { my $select = $SData->{'Post_Code'} eq $Alp->[$_] ? $SForm->{'form_selected'} : undef;
	    $pri .= "<option value=\"\"$select>R[hFw薳</option>\n";
	    for ( 0 .. $DZ->{'ZDCOUNT'} - 1 )
	    { $select = $SData->{'Post_Code'} eq $Alp->[$_] ? $SForm->{'form_selected'} : undef;
	      $pri .= "<option value=\"$Alp->[$_]\"$select>R[hF$Alp->[$_]</option>\n"; }
	    $pri = '<select name="Post_Code" size="1">' . $pri . "</select>\n";
	  } }
	elsif( $fType =~ /\_USER$/ )
	{ my $c = 0; foreach (sort { $a cmp $b } keys(%{$SData}))
	  { if( $_ =~ /(^User\_|\_Mark$)/ )
	    { next if $_ =~ /^Item_/; $c++;
	      $pri .= '<tr><td bgcolor="' . $SForm->{'form_color1'} . '">' . $_ . '</td>';
	      if( !$disp )
	      { $pri .= '<td bgcolor="' . $SForm->{'form_color2'} . '">' . $SData->{$_} . '</td></tr>' . "\n"; } else
	      { $SData->{$_} =~ s/\"/\&quot\;/g;
		$pri .= '<td bgcolor="' . $SForm->{'form_color2'} . 
			'"><input type="text" size="55" name="' . $_ . '" value="' . $SData->{$_} . '"></td></tr>' . "\n"; }
	    }
	  } $pri .= '<tr><td colspan=2>ݒ薳</td></tr>' if !$c;
	    $pri .= '<tr><td bgcolor="' . $SForm->{'form_color1'} . '">Name:<input type="text" size="25" name="UserKey" value="User_xxx or xxx_Mark"></td>' .
			'<td bgcolor="' . $SForm->{'form_color2'} . '">Value:<input type="text" size="55" name="UserVal" value=""></td></tr>' . "\n" if $disp;

	  $disp = 0;
	}
	if( !$disp || !$cols )
	{ s/\#$fType\#/$pri/i; } else
	{ s/\#($fType)\#/${&ManageFromTextarea($cols, $rows, $1, \$pri)}/ei; }
	$sys .= $_;
}

sub ManagePostageView
{	my ($zd, $key, $val, $v) = (undef, @_);
	return $zd if $key =~ /\_00$/;
	
	if( $v == 2 )
	{ my $keyp = $key; $keyp =~ s/^WISI\_([A-Z])$/$1/;
	  $zd .= '<tr><th bgcolor="' . $SForm->{'form_color1'} . '">' . $keyp . 
		 '</th><td align=right bgcolor="' . $SForm->{'form_color2'} . '">' . ${&PriceCheck(\$val)} . '</td></tr>' ."\n"; } else
	{ $zd .= '<tr bgcolor="' . $SForm->{'form_color2'} . '"><td>' . $DZ->{$key} . '</td>' ."\n";
	  if( $v == 1 )
	  { $zd .= '<td><input type="text" size="60" name="' . $key . 
						 '" value="' . $val . '"></td></tr>' ."\n"; } else
	  { my @code = split(/\:/, $val);
	    for(0 .. $SData->{'ZDCOUNT'} - 1)
	    { #my $pey = $code[$_] !~ /^[0-9]+$/ ? $error : ${&PriceCheck(\$code[$_])};
	      if( !$code[$_] || $code[$_] !~ /^[0-9]+$/ )
	      { $pey = $error; $Errfrom = 1; } else { $pey = ${&PriceCheck(\$code[$_])}; }
	      $zd .= '<td align=right>' . $pey . '</td>'; }
	    $zd .= '</tr>' ."\n"; }
	} $zd;
}

sub ManageFromTextarea
{	my ($cols, $rows, $key, $val) = @_;
	$$val =~ s/<((\/)?textarea)>/\&lt\;$1\&gt\;/g;
	my $textarea = "<textarea cols=\"$cols\" rows=\"$rows\" name=\"$key\">$$val</textarea>\n";
	\$textarea;
}

;####################################################
;##############  JeS[֘A   ###############
;#################################################### 

sub ManageCategoDirDisp
{	my ($puptype, $picup, $error, $file, $form) = (undef, undef, undef, @_);

	local($CD) = &FileOpen($file, 2, 1);
	if( !$CGI->{'Pup_Code'} )
	{ $puptype = $1 if $CGI->{'itemfile'} =~ /^[^\.]+\.(\d)?\.[A-Z]+$/i; } else
	{ $puptype = $CGI->{'Pup_Code'}; } $puptype =~ s/^\.//o;
	foreach (sort { $a cmp $b } keys(%{$CD}))
	{ if( /^picup(\d)$/ )
	  { if( $form )
	    { my $pupc = $1;
	      if( $form == 2 )
	      { $picup = '[ ' . $CD->{$_} . ' ]<input type="hidden" size=10 name="Pup_Code" value=".' . 
							$pupc . '">' if $pupc eq $puptype; } else
	      { my $select = $pupc eq $puptype ? $SForm->{'form_selected'} : undef;
	        $picup .= "<option value=\"\.$pupc\"$select>$pupc\.$CD->{$_}</option>\n"; } } else
	    { my $picDr = $SS->{'PIUP_DIR'} . $_; 
	      $error = 'picup' if( !(-d $picDr) && !(mkdir($picDr, 0755)) ); } }
	  elsif( $_ !~ /^rank/ && !$form )
	  { my $dir = $_; $dir =~ s/\_/\//g;
	    my ($iteDr, $iteIr) = ($SS->{'ITEM_DIR'} . $dir, $SS->{'ITE_ROOT'} . $dir);
	    $error = 'catego-dat' if( !(-d $iteDr) && !(mkdir($iteDr, 0755)) );
	    $error = 'catego-img' if( !(-d $iteIr) && !(mkdir($iteIr, 0755)) ); }
	} 
	if( !$form )
	{ &ManageFileCheck($SS->{'PIUP_DIR'}, 2); if( $Error ){ $error = 'dir-picup'; undef $Error; }
	  &ManageFileCheck($SS->{'ITEM_DIR'}, 2); if( $Error ){ $error = 'dir-catego-dat'; undef $Error; }
	  &ManageFileCheck($SS->{'ITE_ROOT'}, 2); if( $Error ){ $error = 'dir-catego-img'; undef $Error; }
	  return $error; } else 
	{ $picup = '<select name="Pup_Code" size="1">' . "\n"
		 . "<option value=\"\">0.ʏ폤i</option>\n" . $picup 
		 . "</select>\n" if $form == 1; return \$picup;
	}
}

sub ManageItemFileDisp
{	my ($lsroot, $cname, $pup, $dis, $iteDr, $iteIr) = @_;
	my ($DelF, $Iimg, $Iimc, $c, $pfile, $delf) = (undef, undef, undef, 0, undef, $CGI->{'delf'});
	my $alldele = $$cname eq 'ALL:DEL' ? 1 : 0;
	my ($namemach, $imgkaku) = ($$cname, 'jpg|jpe|jpeg|gif|png'); 
	my $math = $$cname !~ /[._]$/ ? '[._]' : undef;
	if( $dis == 2 )
	{ $namemach = $1 . '[-_]' . $2 if $$lsroot =~ /\/itemdel\/$/ && $namemach =~ /([\w]+)\-([\w]+)$/i; }
	my $command = 'ls ' . $$lsroot . (!$alldele ? ' | grep \'' . $namemach . $math . '\'' : undef);
	my $root = [ '', $iteDr, $iteIr, $iteDr ];

	local($_);
	if(!open(FD, "$command  |"))
	{ &Print(&ShopSysError(56, "Can't ls Command $command")); }
	while (<FD>)
	{ chop(); $_ = $$lsroot . $_ if $_ !~ /^$$lsroot/;
	  my ($rc, $tmp) = (0, $_);
	  if( $dis == 9 && $_ =~ /\/$$cname([\.\w]+)?(\(([\d]+)\))?\.([A-Z]+)(\.gz)?$/i )
	  { my $no = $3 || 0; $DelF->[$no] = $no; }
	  elsif( $dis == 2 && $alldele || ($dis == 2 || $dis == 7) 
	  && $_ =~ /\/($namemach(\.\d|\_(l|m|s))?\.([A-Z]+))((\_|\.)tmp)?$/i)
	  { my ($key, $kaku) = ($1, $4); 
	    my $idat = $SS->{'ITEM_FILEKAKU'} =~ /^\.$kaku$/i ? 1 : 0;
	    if( $dis == 2 )
	    { unlink($_) if !$delf || $delf == 1 && $idat || $delf == 2 && !$idat; } else 
	    { $Iimc = $idat && $Iimc !~ /^1/ ? ($Iimc + 10) : $Iimc !~ /2/ ? ($Iimc + 2) : $Iimc;
	      $Iimg->{$key} = $_; } }
	  elsif( $dis == 1 )
	  { my $pupc = $pup == $CGI->{'Pup_Code'} ? $pup : $CGI->{'Pup_Code'};
	    if( $pup && !$pupc )
	    { unlink($_) if /\/$$cname(\d)?(\.[A-Z]+)$/i; } else 
	    { s/(.*)\/$$cname(\d)?(\.[A-Z]+)(\_tmp)?$/&ManageItemFileAdd($pupc, $3, $4, $root)/ei; 
	      $pfile = $_; $rc = 1; } }
	  elsif( $dis == 6 )
	  { if( $Move )
	    { $Iimg->[$c] = $_ if /\/$$cname(\_(l|m|s))?\.$imgkaku(\.tmp)?$/i; } else
	    { $Iimg->{$$cname} = $_ if /\/$$cname($imgkaku)?\.tmp$/i; } $c++; }
	  elsif( $dis =~ /^(0|5)$/ && $_ =~ /\/($$cname(\.\d|\_(l|m|s))?\.[A-Z]+)(\.tmp)?$/i )
	  { if( $dis == 5 )
	    { my ($key1, $key2) = ($1, $3);
	      next unless /($imgkaku)(\.tmp)?$/;
	      $key2 = 'p' if !$key2;
	      $Iimg->{$key1} = $_ if !$Move; $Iimc->{$key2} = !$Move ? 1 : $_; } else
	    { s/(.*)\/$$cname(\.\d|\_(l|m|s))?(\.[A-Z]+)(\.tmp)?$/&ManageItemFileAdd($2, $4, $imgkaku, $root)/ei; 
	      $rc = $_ eq 'NoRename' ? 2 : 1; }
	  } if( $rc == 1 ){ rename($tmp, $_); } elsif( $rc == 2 ){ unlink($tmp); }
	} close(FD);
	$Iimg->[$c] = undef if $dis == 6 && !$c && $Move;
	$dis =~ /^(5|6|7)$/ ? ($Iimg, $Iimc) : $dis == 9 ? $DelF : undef;

}

sub ManageItemFileMov
{	my ($disp, $cdir) = @_;
	$CGI->{'categ'} = $CGI->{'sercate'} if $CGI->{'searkey'};
	my ($chead, $cname, @errc) = ($CGI->{'categ'}, undef);
	my $tempdc = $disp == 8 ? 2 : $CGI->{'movdir'} =~ /^safe:/ ? 3 : $CGI->{'movdir'} =~ /^item:/ ? 1 : 0;
	my $catedc = $chead =~ /^safe:/ ? 3 : $chead =~ /:tmp$/ ? 1 : $chead =~ /:del$/ ? 2 : 0;
	my $caplus = $chead =~ /\:/ && $CGI->{'movdir'} =~ /\:/ ? -1 :
		     $chead !~ /\:/ && $CGI->{'movdir'} !~ /\:/ ? 0 :
		     $chead !~ /\:/ && $CGI->{'movdir'} =~ /\:/ ? 1 :
		     $chead =~ /\:/ && $CGI->{'movdir'} !~ /\:/ ? 2 : 0;

	my @cachedir = ($$cdir . 'itemtmp/', $$cdir . 'itemdel/', $$cdir . 'itemDat/', $$cdir . 'itemImg/');
 	my ($iDatdir, $iImgdir, $iPupdir) = ($SS->{'ITEM_DIR'} . $SS->{'ITE_ROOT'}, $SS->{'PIUP_DIR'});
	my $catdir = $chead; $catdir =~ s/\_/\//g; $catdir .= '/';
	my $catmdir = $CGI->{'movdir'}; $catmdir =~ s/\_/\//g; $catmdir .= '/';
	my ($iddir, $idmdir) = ($catedc ? $cachedir[$catedc - 1]  : $SS->{'ITEM_DIR'} . $catdir, 
				$tempdc ? $cachedir[$tempdc - 1]  : $SS->{'ITEM_DIR'} . $catmdir);
	my ($grdir, $grmdir) = ($catedc == 3 ? $cachedir[$catedc] : 
				$catedc ? $cachedir[$catedc - 1]  : $SS->{'ITE_ROOT'} . $catdir, 
				$tempdc == 3 ? $cachedir[$tempdc] :
				$tempdc ? $cachedir[$tempdc - 1]  : $SS->{'ITE_ROOT'} . $catmdir);
	my ($pddir, $pdmdir) = ($catedc ? $cachedir[$catedc - 1]  : $SS->{'PIUP_DIR'}, 
				$tempdc ? $cachedir[$tempdc - 1]  : $SS->{'PIUP_DIR'});
	#my @{$file};
	$file = $CGI->{'movType'} != 2 && $CGI->{'delType'} != 2  ? 
					 		$ArrayFile : &FileListOpen(\$iddir);
	if( $catedc =~ /^(1|2)$/ && $disp == 10 )
	{ &ManageItemFileDisp(\$cachedir[$catedc - 1], \('ALL:DEL'), 0, 2); 
	  return undef, \@errc; 
	} local($Move) = 1;
	foreach my $ifname (@{$file})
	{ if( $ifname =~ /^((([\w]+)(\_|\-))?([^\.\/]+))(\.\d)?(\.[A-Z]+)(\.tmp)?$/i )
	  { my ($aname, $cate, $dp, $iname, $pupc, $kaku, $tmp) = ($1, $3, $4, $5, $6, $7, $8);
	    my $puc = $pupc; $puc =~ s/^\.//;
	    next if $disp == 9 && $catedc == 1 && !$tmp;
	    if( $CGI->{'searkey'} && $cate )
	    { $ifname =~ s/^[\w]+\-([A-Z0-9\.]+)$/$1/i; 
	      $aname =~ s/^[\w]+\-([A-Z0-9\.]+)$/$1/i;
	      $catdir = $cate; $catdir =~ s/\_/\//g; $catdir .= '/'; $aname = $iname;
	      $iddir = $SS->{'ITEM_DIR'} . $catdir; $grdir = $SS->{'ITE_ROOT'} . $catdir; 
	    } $cate = $chead if !$cate;
	    if( $disp == 9 )
	    { &ManageItemFileDisp(\$cachedir[$catedc - 1], \$aname, 0, 2); } else
	    { my $fNo = undef;
	      if( $disp == 8 )
	      { $fNo = &ManageRepetitionFileCheck(\$cachedir[1], \$aname, 0); }
	      else
	      { my $cname = $CGI->{'movdir'} !~ /\:/ ? $iname : $cate . '-' . $iname;
	        if( &ManageItemFileDisp($dp eq '_' ? \$pdmdir . 'picup' . $puc : \$idmdir, \$cname, 0, 7) )
	        { push(@errc, "60,$iname" ); next; } 
	      }
	      # DATA REGI #
	      my $mfname = $caplus == 1 ? $cate . '-' . $iname . $pupc . $kaku : 
			   $caplus == 2 ? $iname . $pupc . $kaku : $ifname;
	      $mfname =~ s/$kaku/$fNo$kaku/ if $disp == 8 && $fNo;
	      my ($idfile, $idmfile) = ($iddir . $ifname,  $idmdir . $mfname);
	      next unless -f $idfile;
	      rename($idfile, $idmfile);

	      unless( -f $idmfile ){ push(@errc, "62,$iname" ); next; }
	      # PICUP REGI #
	      if( $pupc && $cate )
	      { my $pupdir  = 'picup' . $puc . '/' if !$catedc;
	        my $pupmdir = 'picup' . $puc . '/' if !$tempdc;
	        my $pupname = $cate  . '_' . $iname . $pupc . $kaku;
	        my ($pdfile, $pdmfile, $pdata) = 
			($pddir . $pupdir . $pupname, $pdmdir . $pupmdir . $pupname, undef);
		if( -f $pdfile )
		{ if( !$CGI->{'searkey'} && !$tempdc && $cate ne $CGI->{'movdir'} )
	          { $catdir = $cate; $catdir =~ s/\_/\//g; $catdir .= '/';
		    $pdmfile =~ s/\/$cate(\_$iname$pupc$kaku)/\/$CGI->{'movdir'}$1/; $catdir =~ s/\//\\\//o;
		    foreach my $line (@{&FileOpen(\$pdfile, 0, 1)})
		    { $line =~ s/(\"|\=)(\#Detail\_URL\#)$cate\_$iname(\.|\")/$1$2$CGI->{'movdir'}\_$iname$3/;
		      $line =~ s/(\/|\#IMG\_)$catdir$iname/$1$catmdir$iname/; $pdata .= $line; }
		    &FilePrint(\$pdmfile, \$pdata, 0, 0); unlink($pdfile) if $pdfile ne $pdmfile;
	          } else { rename($pdfile, $pdmfile) if $pdfile ne $pdmfile; } 
		}
	      }
	      # IMAGE REGI #
	      my $mifname = $caplus == 1 ? $cate . '-' . $iname : $caplus == 2 ? $iname : $aname;
	      foreach my $img (@{(&ManageItemFileDisp(\$grdir, \$aname, 0, 6))[0]})
	      { my $grmfile = $img; 
		$grmfile =~ s/$grdir$aname(\_(l|m|s))?/$grmdir$mifname$1/;
		rename($img, $grmfile) if $img ne $grmfile; }
	      my $c = 0;
	      if( $CGI->{'searkey'} )
	      { foreach my $delf (@ITEMLIST)
		{ if( $delf eq ($catdir . $ifname)){ splice (@ITEMLIST, $c, 1); last; } $c++; } }
	    }
	  }
	} undef, \@errc;
}

sub ManageItemFileAdd
{	my ($imc, $kaku, $imgkaku,  $root) = @_;
	my $dat = $imgkaku =~ /^\_/ ? 3 : $kaku =~ /^$SS->{'ITEM_FILEKAKU'}$/i ? 1 : 
					  $kaku =~ /^\.($imgkaku)$/i ? 2 : 0;
	my $rroot = ${$root->[$dat]};

	if( $dat != 3 )
	{ $rroot .= $CGI->{'iname'} . ($dat == 1 ? $CGI->{'Pup_Code'} : $imc);
	  if( $dat == 2 && !$Move )
	  { foreach (split(/\|/, $imgkaku))
	    { my $cimg = $rroot . '.' . $_;
	      if( -f $cimg )
	      { unlink($cimg) if !$CGI->{'Imgrename'} && $kaku ne "\.$_"; 
	        return 'NoRename' if $CGI->{'Imgrename'} == 2; }
	    } 
	  } $rroot .= $kaku; } else
	{ $rroot .= $CGI->{'categ'} . '_' . $CGI->{'iname'} . '.' . $imc . '.dat'; } $rroot;
}

sub ManagePupImgDisp
{	my ($pup, $pupdir, $chadir) = @_;
	my $pupfile = $CGI->{'iname'} . '.' . $pup . '.dat';
	$$pupdir .= $CGI->{'categ'} . '_' . $pupfile; 
	$$chadir .= $CGI->{'categ'} . '-' . $pupfile . '_tmp';
	&FilePrintOpen($chadir);
	foreach (@FORM)
	{ # s/#IMG_([A-Z0-9\/]+)#/&ItemImagDisp($1, 1)/ie; 
	  print TMPFILE $_ . "\n"; 
	} &FilePrintClose($pupdir, $chadir);
}

sub ManageHDIsFileMov
{	my ($disp, $cdir) = @_;
	my $disroot = &ManageSysHIPageList(0, $CGI->{'categ'});
	my ($fname, $kaku, $rfname, $rkaku, $fno, $fmo, $fok, $AddMsg, @errc) = 
					(undef, undef, undef, undef, 0, 0, 0, undef);
	if( $disp == 10 )
	{ &ManageItemFileDisp(\$disroot, \('ALL:DEL'), 0, 2); } 
	elsif( $disp == 11 )
	{ ($fname, $kaku) = ($1, $2) if $CGI->{'fileup'}[1] =~ /(.*)(\.[A-Z]+)$/i;
	  if( !$CGI->{'itemfile'} )
	  { &ManageRepetitionFileCheck(\$disroot, \$fname, 1); } else
	  { ($fname, $rkaku) = ($1, $2) if $CGI->{'itemfile'} =~ /(.*)(\.[A-Z]+)$/i; }
	  my $upfile = $disroot . $fname . $kaku;
	  &FilePrint(\$upfile, \$CGI->{'fileup'}[0], 0, $kaku =~ /($Imagc)$/ ? 1 : 0); 
	  unlink($disroot. $CGI->{'itemfile'}) if $rkaku ne $kaku;
	  undef $CGI->{'fileup'}[0]; 
	  if( -f $upfile )
	  { $AddMsg  = 'Abv܂B';
	    $AddMsg .= ' (t@C̕ύX܂B)' if $fno; } else
	  { push(@errc, "100,t@C琬s" ); } } 
	elsif( $disp == 12 )
	{ ($fname, $kaku)   = ($1, $2) if $CGI->{'itemfile'} =~ /(.*)(\.[A-Z]+)$/i;
	  ($rfname, $rkaku) = ($1, $2) if $CGI->{'filename'} =~ /(.*)(\.[A-Z]+)$/i;
	  if( $rkaku !~ /^($Htmlc|$Imagc)$/ ){ $rkaku = $kaku; $fno = 1; }
	  my ($file, $refile) = ($disroot . $CGI->{'itemfile'}, $disroot . $rfname . $rkaku);
	  unless( -f $file )
	  { $AddMsg = 'łɕύXĂ悤łB'; }
	  elsif( -f $refile ){ push(@errc, "57," ); }
	  elsif( !$errc && -f $file )
	  { rename($file, $refile);
	    if( -f $refile )
	    { $AddMsg = 't@CύX܂B'; 
	      $AddMsg .= ' (gq̕ύX͂܂łB)' if $fno } else
	    { push(@errc, "100,t@CύXs"); } 
	  } }
	elsif( $disp =~ /^(7|8|9)/ )
	{ my $reroot = &ManageSysHIPageList(0, $disp == 7 ? $CGI->{'movdir'} : 'shop:del');
	  $ArrayFile = &FileListOpen(\$disroot) if $CGI->{'movType'} == 2;
	  my $co = $#{$ArrayFile} + 1;
	  foreach (@{$ArrayFile})
	  { my $fmact = $_ =~ /^ErrorLog/ ? '(ErrorLog)(\.[0-9])?' : '(.*)(\.[A-Z]+)';
	    if( /$fmact$/i )
	    { ($fname, $kaku) = ($1, $2);
	      &ManageRepetitionFileCheck(\$reroot, \$fname, 1) if $disp == 8;
	      my ($file, $refile) = ($disroot . $_, $reroot . $fname . $kaku);
	      next unless -f $file;
	      if( $disp == 9 ){ unlink($file); $fmo++; } 
	      else { if( $disp == 7 && -f $refile ){ $fmo++; next; }
		     rename($file, $refile); -f $refile ? $fok++ : $fno++; }
	    }
	  }
	  if( !$fno && !$fmo )
	  { $AddMsg = (!$fok ? 'ł' : undef) . 't@C' . 
	    ($disp == 7 ? 'ړ' : '폜') . ($fok ? '܂B' : 'Ă悤łB'); } 
	  elsif( $disp == 7 )
	  { my $ec = $co == 1 && $fmo ? 60 : $fmo ? 63 : 62; push(@errc, "$ec," ); }
	} $AddMsg, \@errc;
}

sub ManageRepetitionFileCheck
{	my ($fc, $fno, $root, $name, $pri) = (0, undef, @_);
	my $fcheck = &ManageItemFileDisp($root, $name, 0, 9); 
	if( $fcheck =~ /^ARRAY/ )
	{ foreach (@{$fcheck}){ if( $_ eq '' ){ last; } $fc++; } }
	$$name .= '(' . $fc . ')' if $fc && $pri; $fno;
}

sub ManageSysItemView
{	my ($c, $fc, $onClick, $page, $start, $end, $err) = (0, 0, undef, @_);
	local($categ, $catep) = (\$CGI->{'categ'}, $CGI->{'categ'});
	local($Pv, $Sear, $DMO, $DIS) = ($page->[2], $CGI->{'searkey'} ? 1 : 0, split(/\:/, $DMO));
	undef $CGI->{'categ'} if $Sear && !$CGI->{'sercate'};

	my ($imgurl, $nossl) = ($SS->{'ITE_IMG'}, $SForm->{'SYS_vsslno'}); 
	my $droot = $CGI->{'categ'} =~ /\:/ || $DIS == 2 && $CGI->{'categ'} eq '007' ? 1 : 0;
	my $imgv  = $CGI->{'imp'} && !$droot ? 1 : 0;
	local($Pmsg) = $DIS == 1 ? 'i' : 't@C';
	local($NoCate) = 1 if !$SS->{'CATE_TYPE'};
	local($Catche) = $CGI->{'movdir'} || 1 if $$err;
	local($IMache, $Move, $Mc) = (Sys::ModuleCheck(1), 1, 0);
	local($New, $Tmp, $Del) = ($$categ eq 'item:tmp' ? 1 : 0, $$categ eq 'safe:tmp' ? 1 : 0, 
			$$categ =~ /^(item|shop):del$/ ? 1 : $DIS == 2 && $CGI->{'categ'} =~ /^(007|006)$/ ? 2 : 0);
	local($MoChec) = 1 if $DIS == 2 && $Del && $Pv == 2;

	my ($ftype, $targ) = $CGI->{'dpv'} == 2 || $Del ? ('checkbox', undef) : 
							('radio', $DIS == 1 ? '_blank' : undef);
	my ($file, $chadir, $item, $idat, $plink) = 
		($SS->{'CONF_DIR'} . $SS->{'CATE_CONF'}, $SS->{'CACHE_DIR'} . 'admin/', 
									undef, undef, undef);
	$item = "<table width=100% CLASS=font13 cellpadding=5><tr>\n" 
	      . ${&ManageCommHidden($SS->{'MANAG_URL'}, $DIS == 2 && !$Del ? 2 : 1, 1, $targ)}
	      . "<input type=\"hidden\" name=\"mode\" value=\"$CGI->{'mode'}\">\n"
	      . "<input type=\"hidden\" name=\"dpv\" value=\"$CGI->{'dpv'}\">\n";
	$item .= $Sear ? "<input type=\"hidden\" name=\"sercate\" value=\"$CGI->{'sercate'}\">\n" :
			 "<input type=\"hidden\" name=\"categ\" value=\"$catep\">\n";
	$item .= "<input type=\"hidden\" name=\"searkey\" value=\"$CGI->{'searkey'}\">\n" if $CGI->{'searkey'};
	$item .= "<input type=\"hidden\" name=\"lv\" value=\"$CGI->{'lv'}\">\n" if $CGI->{'lv'};
	$item .= "<input type=\"hidden\" name=\"imp\" value=\"$CGI->{'imp'}\">\n"
	      .  "<input type=\"hidden\" name=\"sort\" value=\"$CGI->{'sort'}\">\n"
	      .  "<input type=\"hidden\" name=\"p\" value=\"$P\"><td rowspan=2 valign=top>\n"
	      . ${&ManageCategoryFileDisp(0, $DIS == 1 ? Sys::FileOpen(\$file, 0, 1) : 
		&ManageSysHIPageList(1), \$chadir)} . '</td><td width=80% valign=top>' . "\n";

	$idat = "<table width=100% CLASS=font13 cellspacing=2 cellpadding=2 border=0>\n";
	if( $$categ || $Sear )
	{ local($itdir) = undef; 
	  my $cadir = $DIS == 1 ? $CGI->{'categ'} : &ManageSysHIPageList(0, $CGI->{'categ'}) 
								if !$Sear || $Sear && $$categ;
	  if( $DIS == 2 || $droot )
	  { $link = ${&ManageCommHidden($SS->{'MANAG_URL'}, 0)} 
			 . '&mode=' . $CGI->{'mode'} . '&categ=' . $CGI->{'categ'}; }
	  if( $DIS == 1 )
	  { if( $New ){ $cadir =~ s/\://g; $itdir = $chadir . $cadir . '/'; $itimgdir = $itdir; } 
	    elsif( $Tmp ){ $itdir = $chadir . 'itemDat/'; $itimgdir = $chadir . 'itemImg/'; }
	    elsif( $Del ){ $cadir =~ s/\://g; $itdir = $chadir . $cadir . '/'; $itimgdir = $itdir; }
	    else
	    { $cadir =~ s/\_/\//g; $cadir .= '/' if $cadir; 
	      $itimgdir = $SS->{'ITE_ROOT'} . $cadir; $itdir = $SS->{'ITEM_DIR'} . $cadir; } } else 
	  { $itdir = $cadir; }

	  &ManageShopFilePrint($DIS == 1 ? $itimgdir : $itdir, $1) if $CGI->{'disp'} =~ /^pv\:(.*)/;
	  foreach (@{&ManageFileSortDisp($Sear ? \@ITEMLIST : &FileListOpen(\$itdir))})
	  { s/^[\d]+\:(.*)/$1/o if $CGI->{'sort'} >= 3;
	    if( $DIS == 1 && $_ =~ /^(([^\-]+|[\w\/]+)(\-|\/))?([A-Z0-9\.]+)$SS->{'ITEM_FILEKAKU'}(\.tmp)?$/i || 
 		$DIS == 2 && $_ =~ /(Log(\.[0-9])?|\.(html|htm|dat|jpg|jpeg|jpe|gif|png|tar.gz|js|css))$/i )
	    { my ($fmatc, $tmp) = ($4, $5);
	      next if $DIS == 1 && ($New && (!$tmp || $fmatc !~ /^[\d]{18}(\.)?/) || !$New && $tmp);
	      if( $c >= $start && $c <= $end )
	      { my ($catc, $cate, $fname, $pu) = (undef, $2, $DIS == 1 ? split(/\./, $fmatc) : $_);
		if( $Sear )
		{ $_ =~ s/^[\w\/]+\/([A-Z0-9\.]+)$/$1/io; 
		  if( !$$categ )
		  { $catc = $cadir = $cate; $cadir .= '/'; $catc =~ s/\//\_/g; $catc .= '-';
		    $itdir =  $SS->{'ITEM_DIR'} . $cadir; $itimgdir = $SS->{'ITE_ROOT'} . $cadir; }
		  undef $cate; 
		}
		my $ifile = $itdir . $_;
		my $rdata = $_ if $DIS == 2;
	        my $Idata = Sys::FileOpen(\$ifile, 2, 2) if $DIS == 1;
		my $color = $c % 2 ? '#FFFFF7' : '#F7F7F7';
	        $idat .= "<tr bgcolor=\"$color\">";
		if( $Idata eq 'ERROR' )
	        { $idat .= "<td>@</td><td>$_(Error)</td>"; } else
		{ my $puname = '<font color="#FF00FF">( ' . $PU->{"picup" . $pu} . ' )</font>' if $pu;
		  my $check = undef;
		  if( ($DIS == 2 || $Pv == 2) && $Catche && $ArrayFile )
		  { foreach my $cfile (@{$ArrayFile})
		    { if( $_ eq $cfile ){ $check = $SForm->{'form_checked'}; last; } } } else
		  { $check = $SForm->{'form_checked'} if $DIS == 1 && $ftype eq 'radio' && $c == $start;  }
		  $fc++;
		  my $onClick = ' onClick="FormCheck(1,7,0,' . $fc . ')"' if $DIS == 2 && $Pv != 2 && !$Del;
		  $idat .= "<td valign=top width =10><input type=\"$ftype\" name=\"itemfile\" value=\"$catc$_" 
			. ($DIS != 2 && $Pv != 2 ? "\^$Idata->{'Item_Name'}" : undef) . "\"$check$onClick></td>" 
								if !$Del || $Del && $Pv == 2;
		  if( $DIS == 1 )
		  { my ($imgfile, $imgview, $pcimg) = (undef, undef, 0);
		    my $cname = $cate ? $cate . '-' . $fname : $fname;
		    my $cimg = (&ManageItemFileDisp(\$itimgdir, \$cname, 0, 5))[1];
		    if( $imgv || !$cimg->{'p'} )
		    { foreach my $img ('l', 's', 'm'){ if( $cimg->{$img} ){ $imgfile = $cimg->{$img}; last; } } }
		    if( !$imgfile && $cimg->{'p'} )
		    { $imgfile = $cimg->{'p'};
		      if( $SS->{'LIST_PIC'} ){ $hei = ' height=' . ($SS->{'LIST_PIC'} * 0.8); $hei =~ s/\.[\d]+$//o; }
		    } $nossl = 1;
		    if( $imgfile )
		    { if( !$droot )
		      { $imgurl =~ s/^https\:/http\:/ if $nossl; $imgfile =~ s/^$itimgdir/$imgurl$cadir/; } else
		      { $imgfile =~ s/^$itimgdir//; $imgfile = $link . "&disp=pv:" . $imgfile; } }
		    if( $imgv )
		    { $imgview = !$imgfile ? $SForm->{'lnoImg_IMG'} :
		      '<img src="' . $imgfile . '" width=' . $SS->{'LIST_PIC'} . $hei . '>'; } 
		    elsif( $imgfile )
		    { $imgview = &PageJavaLink(\$imgfile, $Idata->{'Item_Name'}, 'shopimg', '500', '400', 'yes'); } 
		    if( $catc ){ $cate = $catc; $cate =~ s/\-$//; }
		    $idat .= "<td>$imgview</td>\n" if $imgv;
		    $idat .= '<td><b>' . (!$imgv && $imgview ? $imgview : $Idata->{'Item_Name'}) . "</b>" 
			  . ($cate ? "  y $CD->{$cate} z" : undef) . "<br>\n";
		    $idat .= $puname . "<br>\n" if $puname;
		    $idat .= "[ FILEF$fname CODEF$Idata->{'Item_Code'}  DATEF$Idata->{'Item_Date'} ] </td>\n"; } else
		  { my $size = -s $ifile; $size = 100 if $size && $size < 100; $size = $size / 1000 if $size; $size =~ s/([\d]+\.\d)([\d]+)?/$1/o; $size = ' ( ' . $size . 'K )';
		    my $whsize = undef;
		    if( $DIS == 2 && $CGI->{'categ'} =~ /^003_/ )
		    { $rdata =~ s/\_/\//g; 
		      $size .= '<br><font color=#FF0000>̃t@Cɑ΂Ă̏if[^悤łB</font>'
					 unless -f $SS->{'ITEM_DIR'} . $rdata; }
		    if( $IMache && $_ =~ /($Imagc)$/ )
		    { my ($width, $height) = &ImageMagick(1, $ifile, undef); $whsize = 'w' . $width . 'x h' .  $height; 
		      $img = '<img src="' . $SS->{'IMG_URL'} . 
			($$categ =~ /\_001$/ ? 'shop/' : $$categ =~ /\_002$/ ? 'memb/' : $$categ =~ /\_003$/ ? 'epsi/' : undef) . 
				$_ . '">' . "\n" if $$categ =~ /^002\_/ && $CGI->{'imp'};  $img =~ s/https\:\/\//http\:\/\// if $nossl; }
		    $filepri = !$img ? &PageJavaLink(\($link . "&disp=pv:" . $_), $fname, 'shopimg', '500', '400', 'yes') : $fname;
		    $idat .= "<td>$img<b>$filepri</b> $whsize $size</td>\n"; } }
		$idat .= "</tr>"; 
	      } $c++; }
	  } $idat .= '</table>';
	  my $ah = ${&ManageCommHidden($SS->{'MANAG_URL'}, 0)} . '&mode=' . $CGI->{'mode'} 
		   . '&categ=' . $CGI->{'categ'} . '&dpv=' . $CGI->{'dpv'}
		   . '&lv=' . $CGI->{'lv'} . '&imp=' . $CGI->{'imp'} . '&sort=' . $CGI->{'sort'};
	  $plink = ${&ManagePageLink(0, 0, 1, Sys::PageLink($ah, $P, $c - 1, $end, 0))};
	  $plink .= "<p align=right>" . ${&ListPage($ah, $c, $SForm->{'SYS_Fview'}, '', $P, 0, 0)} . "</p>\n";
	} my $delname = $Del == 1 ? 'ݔ' : $CGI->{'categ'} eq '006' ? 'G[O' : 'obNDir';
	$item .= '<b><font CLASS=font14>s ' . ($Del ? $delname : $page->[$Pv - 1]) . ' t</font></b>' . "\n";
	if( !$$categ && !$Sear)
	{ my ($fmsga, $fmsgb) = $DIS == 1 ? ($Pmsg . 'Xg', 'JeS[') : ('e' . $Pmsg . 'Xg̓Abvs', $Pmsg);
	  my $msg = " $fmsga͍Xgɂ$fmsgbIĉB\n";
	  $msg .= '<br> ړ̍ۂ͈ړif[^[\\AړJeS[Ƀ`FbNĉB' 
									if $DIS == 1 && $Pv != 1 && !$NoCate;
	  $item .= "<br>\n$msg\n"; } 
	else
	{ if( $Del && $c) 
	  { $item .= '@' . '<input type="submit" name="disp" value="B.' . $delname . 'ɂ">' . "\n"
		   . ($Del != 2 ? '<font CLASS=font7 size=1><br></font>' . "\n" : '@');  } 
	  elsif( $Pv != 2 && !$Del )
	  { my $nmsg = 'ĕ' if $New;
	    $item .= $DIS == 1 ? 
		'@' . '<input type="submit" name="vdis" value="N.VK' . $nmsg . 'o^">' . "\n" : 
		'<font CLASS=font7 size=1><br><br></font>' . "\n" . 
		'<input type="radio" name="itemfile" value=""' . 
			(!$$err ? $SForm->{'form_checked'} : undef) . 
		' onClick="FormCheck(1,7,\'\',0)">VKAbv ' . "\n" . 
		'<input type="file" size="20" name="fileup">' . "\n" . 
		'<input type="submit" name="disp" value="U.Abvs">' . "\n" if !$Sear; }
	  if( $c )
	  { if( $Pv != 2 && !$Del)
	    { if( $DIS == 2 )
	      { $item .= '<font CLASS=font7 size=1><br><br></font>' . "\n" 
		      . '@ ' . 't@C F <input type="text" size="20" name="filename" value="' 
		      .  ($$err ? $CGI->{'filename'} : undef) . '">' . "\n"
	      	      . ' <input type="submit" name="disp" value="M.ύX"' 
		      . ' onClick="return FormCheck(1,5,' . $SForm->{'SYS_Fview'} . ',0)">' . "\n";
		$item .=  '<font CLASS=font7 size=1><br><br></font>' . "\n"
		      . ' [ VbvCtH =&gt; info.datA V =&gt; whatsnew.datA<br>' 
		      . '@o[m点 =&gt; N--.datA eiX =&gt; ment.dat ]' if $$categ eq '005';
	   	$item .= '<font CLASS=font7 size=1><br><br></font>' . "\n"
		      . ' t@CύXyя㏑Abvꍇ͉LXg'
		      . 'st@CɃ`FbN' . 
			  ($$categ eq '005' ? 'Ls^CvI' : undef) . 'ĎsĉB'; } else
	      { $item .= ' <input type="submit" name="vdis" value="M.ύX">' . "\n" if !$New; } } 
	    elsif( $Pv == 1 && !$Del || $Pv == 2 )
	    { $item .= !$New ? '<br><input type="radio" name="movType" value="1"' 
		    .   $SForm->{'form_checked'} . '>ʈړ' . "\n"
	            .  '<input type="radio" name="movType" value="2">SĈړ' . "\n"
		    . ' <input type="submit" name="disp" value="G.ړ"' 
		    . ' onClick="return FormCheck(1,10,' . $SForm->{'SYS_Fview'} . ',' . $Mc . ')">' . "\n" : "<br>\n"
							 if $Del != 2 && ($DIS == 1 || $MoChec);
	      undef $onClick;
	      $onClick = ' onClick="return FormCheck(1,4,' . $SForm->{'SYS_Fview'} . ',0)"';
	      $item .= '@ [ ';
	      $item .= '<input type="radio" name="delType" value="1"' 
		    .   $SForm->{'form_checked'} . '>ʍ폜' . "\n"
	            .  '<input type="radio" name="delType" value="2">S폜' . "\n" if $New;
	      $item .= ' <input type="submit" name="disp" value="D.폜"' . $onClick . '> ]' . "\n"; 

	      if( $DIS == 1 || $MoChec )
	      { $item .= '<font CLASS=font7 size=1><br><br></font>';
	        $item .= $New ? ' 폜̂ݎ\\ƂȂ܂B( Fݔɂ͓܂B )' :
			  $Del == 2 ? 'ʍ폜́ALt@C`FbNɂ [ D.폜 ]  ɂĎsĉB' :
	       		' ړ̍ۂ͈ړif[^[Ƀ`FbNꍶ̃fBNg[Ƀ`FbNĉB<br>' 
		      .  ' (SĈړ̏ꍇ [ SĈړ ] ̂݃`FbNĎsĉB)'; } }
	    else
	    { $item .= '<font CLASS=font7 size=1><br></font>'
	 	    .  ' ʍ폜́A폜y[WɐؑւčsĉB'; }
	  }
	  $item .= "#Form_Errmsg#\n";
	  my $tmpcate = $New ? 'VKo^' : $Del == 1 ? '폜' . $Pmsg : 
				$Del == 2 ? ($CGI->{'categ'} eq '006' ? 'O' : 'obN') . $Pmsg : $Tmp ? 'ꎞۊ' : undef;
	  $item .= "<font CLASS=font7 size=1><br><br></font>" 
		. ($tmpcate ? $tmpcate : ${&ManageCategNameDisp($New, $categ, $CD)})
		.  " <b>[</b> " . ${&MembCountView($start, $end, $c)} . " <b>] </b><hr>\n";
	  $item .= ($c ? $idat : 't@C͂܂B') . "\n";
	  $item .= '</td></form></tr>';
	  $item .= '<tr><td><hr>' . "\n";
	  $item .= $plink . "\n";
	} $item .= '</td></tr></table>' . "\n"; \$item;
}

sub ManageFileSortDisp
{	my $files = shift;
	$CGI->{'sort'} = 1 if !$CGI->{'sort'};
	if( $CGI->{'sort'} >= 3 )
	{ foreach (@{$files})
	  { s/^[\w\/]+\/([A-Z0-9\.]+)$/$1/io if $Sear && $$categ;
	    $_ = (stat($itdir . $_))[9] . ':' .  $_; } 
	} 
	if( $CGI->{'sort'} % 2 )
	{ @{$files} = sort { $a cmp $b } @{$files}; } else
	{ @{$files} = sort { $b cmp $a } @{$files};  }$files;

}
sub ManageCategNameDisp
{	my ($c, $catecode, $catepri, $new, $categ, $CD) = (0, undef, undef, @_);
	if( !$New )
	{  return \$catepri if $NoCate;
	  $catepri .= '<b>';
	  foreach (split(/\_/, $$categ))
	  { if( $c ){ $catecode .= '_'; $catepri .= ' -&gt; '; } 
	    my $key = $catecode .= $_; $catepri .= $CD->{$key}; $c++; 
	  } $catepri =~ s/\-\&gt$//; 
	  $catepri .= '</b>' . ($DIS == 1 && $$categ ? '( ' . $$categ . ' )' : undef) . '<br>';
	  $catepri .= ' y ' . $CGI->{'searkey'} . ' z ' if $Sear; } else
	{ $catepri = '<b>VKo^</b>'; } \$catepri;
}

sub ManageCategoryFileDisp
{	my ($pri, $disp, $cdata, $chadir) = (undef, @_);

	foreach my $data (@{$cdata})
	{ if( ($Pv || $data !~ /^(picup|rank)/)
	  && ($data =~ /^($Lmatc)?([\w]+)($Lmatc)?\=($Lmatc)?($Dmatc)?($Lmatc)?/
		 || $disp && $data =~ /^\# JeS/ ) )
	  { if( !$disp || $disp eq 'picup')
	    { my $key = $2; my $val = $6 || $7 || $8; 
	      next if $NoCate && $key !~ /^[0]+$/ 
			|| !$NoCate && $key =~ /^[0]+$/; 
	      if( $Pv && $data =~ /^(picup|rank)/ ){ $PU->{$key} = $val; next; }
	      next if $disp eq 'picup';
	      $CD->{$key} = $val; my @check = split(/\_/, $key);
	      $catec = $#check if $catec < $#check; } else { $pri .= $data; } }
	} $pri = ${&ManageCategoryData($catec, 1, $chadir)} if !$disp; \$pri;
}

sub ManageCategoryData
{	my ($catec, $formc, $chadir) = @_;
	my ($catecode, $catepri, $trp) = (undef, undef, undef);
	my ($mcS, $mcN, $mcD, $cmI) = ('safe:tmp', 'item:tmp', 'item:del', 'shop:del');
	my $file = $SS->{'LOCK_DIR'} . 'categoOn';
	my $lline = '----------------';
	my $colsapn = $catec + 3;
	my $ah  = ${&ManageCommHidden($SS->{'MANAG_URL'}, 0, 0)} 
		. '&mode=' . $CGI->{'mode'} . '&dpv=' . $CGI->{'dpv'} . '&categ=';
	my $tr = '<tr><td>' . $SForm->{'mfline_IMG'} . '</td><td>' . '^' 
		. '</td><td nowrap colspan="' . ($colsapn - 1 ) . '">' . "\n";

	local($Vitem) = $CGI->{'mode'} =~ /^1\.3\:(1|2)/ ? 1 : 0;
	local($CCO, $line) = ($Vitem ? &FileOpen(\$file, 2, 1) : undef, $SForm->{'mfline_IMG'});
	local($Allcount) = 0;
	local($hier) = 0;
	local(@catec) = split(/\_/, $$categ) if $$categ;
	$catepri  = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" CLASS=font13>\n";
	if( $DMO == 3 )
	{ ($trp, $fol)= ($tr, &ManageDelFileCheck($chadir, $DIS == 1 ? 'itemdel' : 'shopdel') ? $SForm->{'mgomi_IMG1'} : $SForm->{'mgomi_IMG'});
	  $trp =~ s/\^/$fol/o; $catepri .= $trp;
	  $catepri .= $Del == 1 ? '<b>ݔ</b>' : $ah . ($DIS == 1 ? $mcD : $cmI) . '">ݔ</a>' . "</td></tr>\n";

	  if( $DIS == 1 )
	  { $catepri .= '<tr><td nowrap colspan="' . ($colsapn + 1)  . '">' . $lline . "</td></tr>\n";
	   ($trp, $fol)= ($tr, $New ? $SForm->{'mfolder_IMG2'} : $SForm->{'mfolder_IMG0'});
	    $trp =~ s/\^/$fol/o; $catepri .= $trp;
	    $catepri .= $New ? '<b>VKo^</b>' : $ah . $mcN . '">VKo^</a>' . "</td></tr>\n"; }
	  if( $DIS == 1 && !$NoCate && $CGI->{'dpv'} == 2 )
	  { ($trp, $fol) = ($tr, $$categ eq $mcS ? $SForm->{'mfolder_IMG2'} : $SForm->{'mfolder_IMG0'}); 
	    $trp =~ s/\^/$fol/o; $catepri .= $trp;
	    $catepri .= $$categ eq 'safe:tmp' ? '( <b>ꎞۊ</b> )' : 
		($New ? undef : '<input type="radio" name="movdir" value="' . $mcS . '">') 
				. '( ' . $ah . 'safe:tmp">ꎞۊ</a> )</td></tr>' . "\n"; }
	}
	if( $Vitem )
	{ $catepri .= '<tr><td nowrap colspan="' . ($colsapn + 1)  . '">' . 
	  ($DIS == 1 ? '[ ACe:' . $CCO->{'ALL_COUNT'} . ' ]' : $lline) . '</td></tr>' . "\n"; }
	foreach (sort { $a cmp $b } keys(%{$CD}))
	{ local(@subca) = split(/\_/, $_); local($hiec) = $#subca;
	  my $check = $Catche && $Catche eq $_ ? $SForm->{'form_checked'} : undef;
	  my $colc = $colsapn - ($hiec + 1);
	  my ($count, $linep, $l) = &ManageTiemCategCheck(\$_, $line, $categ);
	  my $idir = !$l ? 1 : 0;
	  my $radio =  $DIS == 2 && !$MoChec || $Del == 2 || $New || $NoCate || !$Pv || $Pv == 1 ? undef : 
		      $idir ? "<input type=\"radio\" name=\"movdir\" value=\"$_\"$check>" : '@';
	  my ($fp, $bo) = $Vitem ? ($l == 2 ? ($SForm->{'mfolder_IMG2'}, 1) : ($SForm->{'mfolder_IMG0'}, 0)) : 
	     $$categ && $$categ ne $_ ? ($SForm->{'mfolder_IMG1'}, 0) : ($SForm->{'mfolder_IMG2'}, 1);
	  my $cp = !$Vitem || !$idir && !$bo ? $CD->{$_} : $bo ? '<b>' . $CD->{$_} . '</b>' : 
							$ah . $_ . '">' . $CD->{$_} . '</a>';
	  $catepri .= "<tr>";
	  my $br = '<br>' if $DIS == 2 && $_ =~ /^(005|007)$/;
	  my ($align, $kae) = $DIS == 2 && $_ eq '007' ? ('center', ' @)') : ('right', undef);
	  $linep = '(  ' if $DIS == 2 && $_ eq '007';
	  for($i = 0; $i <= $hiec; $i++)
	  { $hiMark = ($hier <= $hiec || $hier > $hiec) && $i >= $hiec ? $linep : '@';
	    $catepri .= "<td width=\"26\" align=\"$align\">$br$hiMark</td>"; }
	  $Mc++ if $radio =~ /^</;
	  $catepri .= "<td width=\"26\">$br$fp</td><td colspan=\"$colc\" nowrap>$br$radio$cp$kae</td></tr>\n"; 
	  $hier = $hiec;
	} $catepri .= "</table>\n"; \$catepri;
}

sub ManageTiemCategCheck
{	my ($c, $count, $l, $k, $line, $categ) = (0, 0, 0, @_);
	if( $Vitem )
	{ while (my ($key, $val) = each %{$CD})
	  { if($key =~ /^$$k\_/){ $count += $CCO->{$key}; $c++; } }
	  $l = $c && $$categ =~ /^$$k/ ? 2 : $c ? 1 : 0;
	  $count = $CCO->{$$k} if !$c && $CCO->{$$k};  } else
	{ $l = 2; }
	$line=~ s/(<.*)(\.[a-z]+".*)/$1 . $l . $2/e if $l;
	$l = 2 if $$categ && $$categ =~ /^$$k/; $count, $line, $l;
}

sub ManageMewItemFileDisp
{	my ($iname, $pupc, $tfile, $fc) = (undef, undef, @_);
	$CGI->{'itemfile'} = $tfile ? $tfile : 
		$TIME[11] . sprintf("%06d", int(rand(100000))) . $SS->{'ITEM_FILEKAKU'};
	if( $fc )
	{ ($iname, $pupc) = ($1, $2)  if $CGI->{'itemfile'} =~ /^([^\.]+)(\.\d)?\.[A-Z]+$/i; }
	$iname, $pupc;
}

sub ManageDelFileCheck
{	my ($fc, $root, $dir) = (0, @_);
	my $deldir = $$root . $dir;
	$#{&FileListOpen(\$deldir)} > 1 ? 1 : 0;
}

sub ManagePicupCheckDisp
{	my ($pco, $npco) = (0, 0);
 	local($Pv) = 1;
	&ManageCategoryFileDisp("picup", 
			Sys::FileOpen(\($SS->{'CONF_DIR'} . 
					$SS->{'CATE_CONF'}), 0, 1) ); $Pv = 0;
	for(my $i = 1; $i < 10; $i++)
	{ if( $PU->{"picup" . $i} )
	  { my $pdir = $SS->{'PIUP_DIR'} . 'picup' . $i . '/';
	    if( -d $pdir )
	    { foreach (@{&FileListOpen(\$pdir)})
	      { next if /^\./;
		my $itemfile = $_; $itemfile =~ s/\_/\//g;
		if( !(-f $SS->{'ITEM_DIR'} . $itemfile) || $_ !~ /\.$i\.dat$/ )
		{ if( $CGI->{'vdis'} ){ unlink($pdir . $_); next; } else { $npco++; } }
		$pco++;	
	      }
	    }
	  }
	} $pco, $npco;
}

sub ManageSalesDirDisp
{	my ($error, $caldir, $dis) = (undef, @_);
	foreach my $file (sort { $b cmp $a } @{Sys::FileListOpen($caldir)})
	{ next if $file =~ /^[\.]+$/;
	  if( $dis == 9 ){ unlink($$caldir . '/' . $file); }
	} 
	if( $dis == 9 )
	{ rmdir($$caldir); 
	  -d $$caldir ? &ShopErrorPri(&ManageError(100 , 
		"can't del for sale dir"), 1 , 14) : \$error; }
}

;####################################################
;###################  KEY ֘A   ################
;#################################################### 

sub ManageKeyDataViwe
{	my $key = shift;
	my ($keyname, $keyput) = $key =~ /\=/ ? split(/=/, $key) : (undef, $key); 
	my $htmlpri .= "<b>$name </b><br><form>";
	if( $dis eq 'cD' )
	{ return ($Error = "Ɏs悤łB") if $keyname !~ /^[\w]+/;
	  $keyput =~ s/ \/ /\//o; 
	  $keyname =~ s/(\r)?\n/<br>/g;
	  $htmlpri .= '<b>OrderNo.</b> ' . $keyname . "<br>\n"; }
	elsif( $dis eq 'kD' && $Eco ) 
	{ $htmlpri .= ${&ManageKeyErrorPrint()}; }
	elsif( $dis eq 'S' ) 
	{ $htmlpri .= $keyname . "<br>\n"; }else
	{ $keyput =~ s/(\r)?\n$//; }
	$htmlpri .= "<textarea cols=\"76\" rows=\"5\">$keyput</textarea>\n" if !$ukey; 
	$htmlpri;
}

sub ManageKeyErrorPrint
{	my $msg = "S$Aco$Eco$disNameɎs" . 
		($dis eq 'kD' ? "܂" : "悤ł") . "B<br>\n";
	$msg .= "----------------- ERROR FILE -----------------<br>\n";
	foreach (@eFile)
	{ my $file = /(.*)(\/[\w\-]+\/[\w\-]+\/[\w\-]+\/\.[\w\-]+)$/ ? $2 : $_;
	  $msg .= $file . "<br>\n";
	} $msg .= "----------------------------------------------<br>\n"; \$msg;

}

sub ManageKeyDisp
{	local($Error, $dis, $name) = (undef, @_);
	local($keydata, $keyfc, $fidel) = ($CGI->{'keyDeEn'} || $CGI->{'idpass'}, $CGI->{'keyfc'}, $CGI->{'fidel'});
	local($DatDir, $orgDir, $scdDatDir, $newDatDir) = (undef, undef, undef, undef);
	local($KeyData, $KeyFile, $backpass) = (undef, undef, undef);
	local($keypass) = $dis eq 'L' ? $CGI->{'keyDeEn'} : 
				($dis eq 'cD' && !$CGI->{'passkey'} ||
					$dis =~ /^(kD|dD|KC)$/) && $SS->{'CRYPT_KEY'} ? 
							$SS->{'CRYPT_KEY'} : $CGI->{'passkey'};
	if( $dis =~ /^(kD|cD)$/ && $keyfc )
	{ $KeyFile = $CGI->{'Backkey'} if $keyfc == 2 && $CGI->{'Backkey'};
	  $KeyData = $CGI->{'Backkey'} if $keyfc == 1 && $CGI->{'Backkey'};
	  $backpass = $CGI->{'backpass'};
	}
	local($ukey, $disName) = (0, undef);
	if( $dis =~ /^(kD|dD|ND|DC|KC|CA|CL)$/ )
	{ $DatDir = $SS->{'MEMB_DIR'};
	  $orgDir    = $SS->{'TMP_DIR'} . 'users.org' if $dis =~ /^(ND|CA|CL)$/;
	  $scdDatDir = $SS->{'TMP_DIR'} . 'users.SCD';
	  $newDatDir = $SS->{'TMP_DIR'} . 'users.new'; 
	  $ukey = 1; $disName = $dis =~ /^(kD|DC)$/ ? '' : 'Í';
	}
	my $data = $dis =~ /^(S|L|K|k|c|n|cD|kD|dD)$/? &ManageCrypDipsCheck() : 
			$dis =~ /^(DC|KC)$/  ? &ManageDatasCheck() : 
				$dis =~ /^(CA|CL)$/ ? &ManageDataDirClean(0) : 
					$dis eq 'ND' ? &ManageDataChange() : undef; 
	$data = $Error = "Ώۏs̈׎so܂łB" if !$data;
	\$data, $ukey, $Error ? 1 : 0;
}

sub ManageCrypDipsCheck
{
	if( $KeyFile )
	{ $KeyFile =~ s/^(\x20|\x81\x40|(\r)?\n)+//;
	  $KeyFile =~ s/(\x20|\x81\x40|(\r)?\n)+$//; 
	  $Error = "L[t@C݂ĂȂ悤łB" unless -f $KeyFile; }
	elsif( $KeyData ){ $KeyData =~ s/ /\+/g; }

	if( $dis eq 'kD' && -d $scdDatDir )
	{ $Error = "łɕꂽfBNg[݂Ă܂B"; }
	elsif($dis eq 'dD' )
	{ $Error = -d $newDatDir ? "łɈÍꂽfBNg[݂Ă܂B" : 
		 !(-d $scdDatDir) ? "ꂽfBNg[݂܂B" : undef; }
	elsif( $dis eq 'c' && $keydata !~ /^[\w]+\:[\x21-\x7E]+$/ )
	{ $Error = "ANZXF؏͂ĉB(L => ID:pX[h)"; }
	elsif( $dis eq 'k' && $keydata !~ /^([\d]{8})\:[\x21-\x7E]+$/ 
					|| $dis eq 'K' && $keydata !~ /^([\d]{8})$/ )
	{ $Error = "GvVF؏͂ĉB(L => _ԍ(8)" . 
						($dis eq 'k' ? ": pX[h" : undef) . ")"; }
	return $Error if $Error;

	my ($data, $sw) = $dis eq 'S' ? ('', 'L -S') : ($keydata, $dis); 
	my ($key, $pa, $type) = (undef, $ukey  ? 1 : 0, 1);
	if( $dis =~ /^(cD|kD)$/ )
	{ $data =~ s/ /\+/g; $sw = $dis eq 'cD' ? 'k' : 'kw'; 
	  $pa = 1; $type = 2 if $dis eq 'kD'; }
	elsif( $dis =~ /^k$/i ){ $dis = 'k'; $sw = 'E'; }
	elsif( $dis eq 'dD' ){ $sw = 'dw'; $type = 3; }
	$key = &ManageKeyDeEnDisp($data, $sw, $pa, $type);
	return $Error || $key;
}

sub ManageDatasCheck
{	local($Dco, $Aco, $Eco, $Foc, @eFile) = (0, 0, 0, 0);

	if($dis eq 'DC' && !(-d $scdDatDir))
	{ $Error = "ꂽfBNg[݂܂B"; }
	elsif($dis eq 'KC' && !(-d $newDatDir))
	{ $Error = "ÍꂽfBNg[݂܂B"; }

	$dis eq 'DC' ? &ManageFileCheck($scdDatDir, 0) : 
					&ManageKeyDeEnDisp(undef, "k", 1, 2) if !$Error;
	return $Error if $Error;
	if( !$Aco )
	{ $Error = "`FbNꂽt@C悤łB"; } 
	elsif( !$Eco )
	{ $msg = "<b>S$Acot@C $disNameĂ悤łB</b><br>\n" .
		 "@( [U[$Uedc Ǘ$Medc )<br>\n"; } 
	else 
	{ if( $Aco == $Eco )
	  { $msg = "S$Acot@C St@C$disNameɎsĂ悤łB<br>\n"; } else 
	  { $msg = ${&ManageKeyErrorPrint()};
	    if( $fidel )
	    { $msg .= " st@C폜܂B<br>\n" if $Foc == $Eco;
	      $msg .= " st@C폜 $Eco"
		   . ($Eco - $Foc) . "s܂B<br>\n" if $Foc < $Eco; } }
	} return $Error || $msg;
}

sub ManageDataChange
{
	if( -d $orgDir )
	{ $Error = "f[^ւĂ悤łB"; } 
	elsif( -d $newDatDir && system("cp -R $DatDir $orgDir") )
	{ $Error = "f[^[̃obNAbvɎs܂B"; } else 
	{ &ManageFileCheck($newDatDir, 1); } $Error || "<b>f[^[֊</b><br>";
}

sub ManageDataDirClean
{	my ($msg, $dc, $delc) = (undef, 0, shift);

	if( !$delc )
	{ if( $dis eq 'CA' )
	  { return ($Error = "f[^ւsĂȂ悤łB") unless -d $orgDir; 
	    $msg = "f[^[փLZ";
	    foreach (@{Sys::FileListOpen(\$DatDir)})
	    { if( -d $DatDir . $_ && $_ =~ /^($SS->{'MEMB_HEDID'}|$MANAG_HEDID)$/ )
	      { $dc = 1; last; } 
	    } 
	    if( !$dc ){ $Error = "ݒfBNg[Ȃ悤łB"; } 
	    elsif( (system("rm -r $DatDir\*") || system("cp -R $orgDir/* $DatDir")) )
	    { $Error = "f[^փLZɎs܂B"; } } else
	  { $msg = "ƃt@CNA"; }
	  system("rm -r $orgDir") if -d $orgDir && $orgDir =~ /\.org$/;
	}
	system("rm -r $scdDatDir") if !$delc && $dis eq 'CL' && -d $scdDatDir && $scdDatDir =~ /\.SCD$/;
	system("rm -r $newDatDir") if (!$delc || $delc == 2) && -d $newDatDir && $newDatDir =~ /\.new$/;
	$delc ? 0 :  $Error || "<b>$msg</b><br>";
}

sub ManageDeEnDataChack
{	my ($user, $file, $data) = (undef, @_);
	return 1 if $file =~ /\_P/ && $data !~ /^PASS\:/i
			|| $file =~ /\_D/ && $data !~ /^[0-9]+\:[0-9A-Z\-\_]+\=/i;

	if( $file =~ /\/\.([\w\-]+)\_P/i )
	{ my $hed = $1; 
	  if( $user ne $hed )
	  { if( $hed =~ /^$SS->{'MEMB_HEDID'}/i ){ $Uedc++; }
	    elsif( $hed =~ /^$MANAG_HEDID/i ){ $Medc++; } $user = $hed;
	  }
	} return 0;
}

sub ManageKeyDeEnDisp
{	my ($data, $pdata, $swc, $pa, $type) = (undef, @_);
	my $command =  $dis =~ /^(S|L|k|c|n)$/ ? $SS->{'KEYENGINE'} : $SS->{'SYSENGINE'};
	$pdata = $SS->{'WS_KEY'} . ':' . $KeyData . ':' . $pdata if $pa;
	my ($key, $len) = (undef, length($pdata));
	my $sw  = "-" . $swc;
	if( $type >= 2 )
	{ $sw .= " -DSh " . ($dis eq 'dD' ? $scdDatDir : $dis eq 'KC' ? $newDatDir : $DatDir);
	  $sw .= " -O " . ($dis eq 'dD' ? $newDatDir : $scdDatDir) if $dis ne 'KC';
	} $sw .= " -B " . $KeyFile  if $KeyFile;
	  $sw .= " -p " . $backpass if $backpass;
	if( ($dis eq 'cD' && !$CGI->{'passkey'} || 
		$dis =~ /^(kD|dD|KC)$/) && $SS->{'CRYPT_KEY'} )
	{ if( $keypass ){ $swp = 'p' }
	  elsif($dis eq 'dD')
	  { $sw .= " -T " . ($CGI->{'level'} ? $CGI->{'level'} : $SS->{'CRYPT_TYPE'}); } }
	elsif( $dis =~ /^(k|c|n)$/ )
	{ $sw .= " " . $pdata; } else
	{ $sw .= " -s" if $dis eq 'S' && $SSL;
	} $sw .= " -P$swp " . $keypass if $keypass;
	  $sw .= " -l " . $len if $SS->{'OS_TYPE'};

	# $SIG{CHLD} = \&waitpid;
	my $normal_end = 0;
	if( !$SS->{'OS_TYPE'} && !(-x $command) || $SS->{'OS_TYPE'} && !(-f $command) )
	{ $Error = "VXeG[܂(chmod $command)"; return 0; }
	if( !open2(READ, WRITE, "$command $sw") )
	{ $Error = "VXeG[܂(Can't Open $command)"; return 0; } else 
	{ print WRITE $pdata if $pa;
	  close(WRITE);
	  while (<READ>)
	  { if( /^\_ENGIN_END\_/ ){ $normal_end = 1; last; }
	    if(/^(SYSTEM|WSE|WSD)_ERROR/)
	    { s/(\r)?\n$//; $Error = "VXeG[܂B";
	      if( /\_ERROR ([\d]+) \: (.*)/ )
	      { my $ecode = $1; $_ = $ecode . ' ' . $2; 
		$Error = "ÍL[̕Ɏs܂B" if $ecode == 14; }
	      $Error .= "($_)"; undef $key; next;
	    }
	    if( $Error ){ $Error .= '<br><br>@E STOP FILE F ' . $1 if /ERROR_FILE (.*)/; last; }
	    if($dis eq 'kD')
	    { if( /^Cant\_Decode\=(.*)/ ){ push(@eFile, $1); $Eco++; }
	      elsif( /^Decode\_Count\=([\d]+)/ ){ $Aco = $1; } }
	    elsif($dis eq 'KC')
	    { if(/^\# CHECK FILE : (.*)/)
	      { $file = $1; $Aco++; } 
	      elsif( $file && $_ && $_ !~ /^[\#\r\n]/ && &ManageDeEnDataChack($file, $_) )
	      { push(@eFile, $file);
		if( $fidel ){ unlink($file); $Foc++ unless -f $file; }
		$Eco++; undef $file;
	      } } else
	    { $c = 1 if /^KEY/;
	      $key .= $_ if $c || $type == 1; }
	  } close(READ);
	}
	if( $dis =~ /^(S|k|c|n)$/ )
	{ $key =~ s/(\r)?\n//g;
	  my ($kd, $len) = (undef, length($key));
	  for (my $i = 0; $i < $len; $i+=60)
	  { $kd .= substr($key, $i, $i + 60) . "\n"; }
	  if( $dis eq 'S' )
	  { if( $SSL ){ $kd = 'SERVER_SSL_KEY=' . $kd; } 
	    else{ $kd = 'SERVER_KEY=' . $kd; } 
	  } $key = $kd; } 
	elsif( $dis =~ /^(kD|dD)$/ && $Error )
	{ &ManageDataDirClean($dis eq 'kD' ? 1 : 2); } 
	$Error = "VXeG[܂(Engine2 Error that a cause is Unknown.)" if !$Error && !$normal_end;
	$key = &ManageKeyDataViwe($key) if !$Error; $key;
}

sub ManageFileCheck
{	my ($Dir, $disc) = @_;
	my $files = Sys::FileListOpen(\$Dir);

	$Dir =~ s/\/$//o;
	if( !$Dco && $#{$files} < 0 )
	{ if( $disc == 2 )
	  { $Error = "JeS[i[fBNg[悤łB"; } 
	  elsif( $disc == 1 )
	  { $Error = "f[^ւ̓LZÍi[fBNg[悤łB"; } 
	  else 
	  { $Error = "`FbNfBNg[悤łB"; } 
	  return 1;
	}
	foreach (@{$files})
	{ unless( /^[\.]+$/ )
	  { my $file = $Dir . "\/" . $_;
	    if(-d $file)
	    { $Dco++; 
	      if( $disc == 2 )
	      { $Itemdirc .= ($Itemdirc ? '_' : undef) . $_; 
		$IDil = !$CD->{$Itemdirc} ? 1 : 0;
	      } &ManageFileCheck($file, $disc); 
	      if( $disc == 2 )
	      { if( $Itemdirc =~ /\_/ ){ $Itemdirc =~ s/\_[A-Z0-9]+$//io; } 
		else{ undef $Itemdirc; } rmdir($file) if $IDil; 
	      } }
	    elsif( $disc == 2 )
	    { $IDil = 0; }
	    else
	    { unless( /^\.[\w]+/ ){ unlink($file); next; }
	      $Aco++;
	      my ($ec, $udata) = 0;
	      if( $disc )
	      { my $ud = $1 if $Dir =~ /^$newDatDir(.*)/;
		my $pfile = $DatDir . $ud;
	        if(system("cp $file $pfile"))
	        { $Error = "f[^[Rs[Ɏs܂B"; return 1; } } else 
	      { if(!open(FILE,"<$file"))
		{ push(@eFile,"$file"); $Eco++; } else 
		{ while (my $data = <FILE>)
		  { if( $data !~ /^(\r)?\n/ && &ManageDeEnDataChack($file, $data) )
		    { push(@eFile,"$file"); close(FILE); $Eco++; $ec = 1; last; }
		  } close(FILE);
		  if( $ec && $dis eq 'DC' && $fidel )
		  { unlink($file); $Foc++ unless -f $file; }
		  next if $ec;
	        }
	      }
	    }
	  }
	} return 0;
}

;####################################################
;################  y[W֘A   #################
;#################################################### 

sub ManageSysPageList
{	my ($vm, $vs) = @_;
	my $List =
	[ [ 'eݒConf', 'ev[g', 'SHOPy[W', '', 'Ǘy[W', '', 'L[' ],
	  [ 'VXe,system,SYS_CONF',    'JeS[,catego,CATE_CONF', 
	    'tH[,form,FORM_CONF', 'E萔,postage,POSTAGE_CONF', 
	    'HTML֘A,html,HTM_CONF', '摜EG,image,IMG_CONF', 
	    '---------------,', 'Epsilon,epsilon,EPSI_CONF' ],
	  [ 'y[W֘A', '[֘A', 'i֘A', 
	    '---------------,', 'Rrj' ],
	  [ 'if[^Ǘ,item', 'HTMLE摜 etc' ],
	  [ '' ], [ 'VXe,manage,.conf' ],
	  [ '' ], [ 'L[쐬,', 'J[h,', 'L[,' ]
	];
	$vm ? $List->[0]->[$vm-1] : $List->[0], $vs ? $List->[$vm]->[$vs-1] : $List->[$vm];
}

sub ManageKeyPageList
{	my ($vm, $vs) = @_;
	my $List =
	[ [  ],
	  [ 'S:[s] CZXL[sp' . ($SSL ? 'SSL_' : undef ). 'ServerL[쐬', 
	    'K:[s] EpsilonF؉L[spL[쐬 ', 
	    'k:[F] EpsilonpF؃L[쐬', 'c:[F] T[o[pF؃L[쐬', 'n:[ov] ʃL[쐬',
	    'L:yBACKUPzL[쐬 (ÍDATA̕L[)' ],
	  [ 'cD:J[hÍf[^̕' ],
	  [ 'kD:P. [U[f[^', 'DC: `FbN', 
	    'dD:Q. [U[f[^Í', 'KC: Í`FbN', 'ND:R. [U[f[^', 
	    ':--------------------',
	    'CA:f[^փLZ', 'CL:ƃt@CNA' ]
	];
	my $dname = undef;
	if( $CGI->{'disp'} )
	{ foreach (@{$List->[$vs]})
	  { if( $_ =~ /^$CGI->{'disp'}\:/ ){ $dname = (split(/\:/, $_))[1]; last; } }
	} $List->[$vs], $dname;
}

sub ManageSysHIPageList
{	my ($ltype, $categ) = @_;

	if( !$PU )
	{ local($Pv) = 1;
	  &ManageCategoryFileDisp("picup", 
		Sys::FileOpen(\($SS->{'CONF_DIR'} . $SS->{'CATE_CONF'}), 0, 1) ); $Pv = 0; }
	if( $ltype )
	{ my $phcate = 
	  { '001' => 'html', '001_000' => 'js-css', '001_001' => 'PC html', '001_002' => 'g dat',
	    '002' => '摜', '002_001' => 'Vbv', '002_002' => '֘A',
	    '002_003' => 'J[h֘A', '002_004' => 'ʁEǗ', '003' => 'PICUP', 
	    '005' => 'CtHEe', '006' => 'G[O', '007' => 'obNDir' 
	  };
	  for(my $i = 1; $i < 10; $i++)
	  { my $val = $PU->{"picup" . $i};
	    $phcate->{"003_" . sprintf("%03d", $i)} = $val if $val;
	  }
	  if( $ltype == 1 )
	  { my ($pacate, $c) = (undef, 0);
	    while (my ($key, $val) = each %{$phcate})
	    { $pacate->[$c] = $key . ' = ' . $val; $c++; }
	    $pacate; } else
	  { $phcate; } } else 
	{ my $pfroot = 
	  { '001_000' => $SS->{'PC_DIR'} . 'js-css/', '001_001' => $SS->{'PC_DIR'}, '001_002' => $SS->{'PTB_DIR'}, 
	    '002_001' => $SS->{'IMG_DIR'} . 'shop/', '002_002' => $SS->{'IMG_DIR'} . 'memb/',
	    '002_003' => $SS->{'IMG_DIR'} . 'epsi/',
	    '002_004' => $SS->{'IMG_DIR'}, 'shop:del' => $SS->{'CACHE_DIR'} . 'admin/shopdel/',
	    '005'     => $SS->{'INFO_DIR'}, '006'     => $SS->{'LOG_DIR'}, '007'     => $SS->{'TMP_DIR'} };
	  for(my $i = 1; $i < 10; $i++)
	  { my $val = $PU->{'picup' . $i};
	    $pfroot->{'003_' . sprintf("%03d", $i)} = $SS->{'PIUP_DIR'} . 'picup' . $i . '/' if $val;
	  } $pfroot->{$categ};
	}
}

sub ManageMembPageName
{	my ($Disp, $disName) = (0, undef);
	my $disp = $CGI->{'disp'};
	my $imgdel = 'imgdel' . $1 if $DMO =~ /^3\:/ && $CGI->{'disp'} =~ /^([\d]+)./;
	if( $CGI->{'vdis'} =~ /^N./ )
	{ $CGI->{'vdis'} = 'N'; $disp = 'N.';
	  if( $CGI->{'categ'} eq 'item:tmp' && 
		$CGI->{'itemfile'}=~ /^([^\-]+)\-([\w\.]+)$SS->{'ITEM_FILEKAKU'}\.tmp$/ )
	  { $CGI->{'categ'} = $1; $CGI->{'vdis'} = 'N'; $disp = $CGI->{'disp'} = 0; $CGI->{'itemfile'} = $2 . $SS->{'ITEM_FILEKAKU'}; } else
	  { &ManageMewItemFileDisp(undef, 0); }
	} $disp = $CGI->{$imgdel} ? 'D.' : $CGI->{'pdis'} == 2 && $disp ? '2.' : 
					   $CGI->{'pdis'} == 1 ? 'V.' : 
		  			   $disp eq 'N.' ? '1.N' : $disp; 
	if( $VMO == 1 )
	{ ($Disp, $disName) = 
	  $disp =~ /^1\./ ? (1, 'ݒύX') : $disp =~ /^2\./ ? (2, 'UPύX')  : 
	  $disp =~ /^R\./ ? (3, 'ݒXV') : $disp =~ /^G\./ ? (7, 'iړ') :
	  $disp =~ /^B\./ || $CGI->{'delType'} == 2 ? (10, 'Sč폜') : 
	  $disp =~ /^D\./ ? 
		($CGI->{'categ'} =~ /^((shop|item)\:del|item\:tmp|007)$/ ? (9, 'i폜') : 
		 $CGI->{'dpv'} == 2 ? (8, 'i폜') : (4, 'ݒ')) : 
	  $disp =~ /^V\./ && !$CGI->{'oform'}  ? (5, 'DATAmF') : 
	  $disp =~ /^(F|V)\./ ? (7, '\mF') : $disp =~ /^U\./ ? (11, 'Abv') :
	  $disp =~ /^M\./ && $DMO =~ /^3:2/ ? (12, 't@CύX') : (0, undef); 
	  $CGI->{'movdir'} = 'item:del' if $Disp == 8; }
	elsif( $VMO =~ /^(2|7)$/ )
	{ undef $disp if $disp =~ /^L/;
	  ($Disp, $disName) = 
	  $disp =~ /^(1\.|mfor_)/ ? (1, 'ύX')   :
	  $disp =~ /^(2\.|pfor_)/ ? (2, 'pX[hύX') :
	  $disp =~ /^3\./ 	  ? (3, 'OC')   : 
	  $disp =~ /^(4\.|ofor_)/ ? (4, 'I[_[')   : 
	  $disp =~ /^5\./ 	  ? (5, 'J[h') : 
	  $disp =~ /^(6|I)\./ 	  ? (6, '')   : 
	  $disp =~ /^(7|D)\./ 	  ? (7, '폜')   : 
	  $disp =~ /^(9\.|lfor_)/ || $CGI->{'mode'} =~ /^7/ ? (9, 'Login') : (0, undef); } 
	elsif( $VMO == 3 )
	{ ($Disp, $disName) = 
	  $disp =~ /^afor_5/      ? (E, 'VKo^I')   :
	  $disp =~ /^(0\.|afor_)/ ? (A, 'ǗVKo^')   :
	  $disp =~ /^(1\.|mfor_)/ ? (1, 'ǗύX')   :
	  $disp =~ /^(2\.|pfor_)/ ? (2, 'pX[hύX') :
	  $disp =~ /^3\./ 	  ? (3, 'OC')   : 
	  $disp == 9              ? (9, '폜I')   : (0, undef); }
	elsif( $VMO == 4 )
	{ ($Disp, $disName) = 
	  $DMO == 7 ?
	  ( $disp =~ /^1\./ ? (1, 'f[^\')  :
	    $disp =~ /^(2|S)\./ ? (2, 'ύX')     : 
	    $disp =~ /^9\./ ? (9, '폜')     : (0, undef) ) :
	  ( $disp =~ /^1\./ ? (1, 'f[^\\')  :
	    $disp =~ /^2\./ ? (2, 'jݒ芮') : (0, undef) ); } $Disp, $disName;
}

sub ManageCommHidden
{	my ($action, $mhc, $fnc, $targ) = @_;
	my $formname = ' NAME="Formkey"' if $fnc;
	my $target = ' target="' . $targ . '"' if $targ;
	my ($hid, $enctype) = (undef, undef);
	if( $mhc )
	{ if( $mhc == 2 )
	  { $enctype = ' ENCTYPE="multipart/form-data"'; }
	  $hid  = "<form method=\"POST\" action=\"$action\"$formname$target$enctype>\n";
	  if( $targ ne 'shoppage' )
	  { $hid .= "<input type=\"hidden\" name=\"mid\" value=\"$CGI->{'mid'}\">\n" if $mhc != 3;
	    $hid .= "<input type=\"hidden\" name=\"lcode\" value=\"$CGI->{'lcode'}\">\n" 
								if $CGI->{'lcode'}; } } else
	{ $hid  = "<a class=lm$target href=\"" if !$fnc;
	  $hid .= "$action?";
	  $hid .= "mid="   . $CGI->{'mid'}   . "&" if $CGI->{'mid'};
	  $hid .= "lcode=" . $CGI->{'lcode'} . "&" if $CGI->{'lcode'};
	  $hid =~ s/\&$//; } \$hid;
}

sub ManagePageCheck
{	my ($dmo, $lpri, $lv) = @_;
	$dmo = $1 if $dmo =~ /^\/([A-Z0-9\/]+)\/[\d]{3}\/$/i;
	my ($c, $start, $end, $lc) = (0, &PageViewCheck($Uview, $L));
	my $check_dir = $SS->{'MEMB_DIR'} . $dmo;
	my $ah = ${&ManageCommHidden($SS->{'MANAG_URL'}, 0)} . '&mode=';
	my $mo = $VMO . "." . $dmo;
	if( $VMO == 3 || $DMO eq $HeadID || $CGI->{'searkey'} || $CGI->{'uskey'} )
	{ $c = (&ManageUserCount())[0]; } else
	{ foreach (sort @{Sys::FileListOpen(\$check_dir)})
	  { $c++ if $_ =~ /^[\d]+$/; } }
	#$c = (&ManageUserCount())[0];
	if( $lpri )
	{ Sys::ListPage($ah . $mo, $c, $Uview, '', $L || 1, $P, $lv); } else
	{ $ah, $mo, $start, $end, $lc, $c; }
}

sub ManagePageDisp
{	my ($p, $l, $d) = @_; $page = $p . '.' . $l . '.' . $d; $page;
}

sub ManageDown
{	my $buf = shift;
	if( $DownCount )
	{ print $buf . "\n"; } else
	{ my $file = sprintf("%d%02d%02d", $TIME[5], $TIME[4], $TIME[3]) . '.csv';
	  print "Content-type: application/download\n";
	  print "Content-disposition: attachment; filename=\"$file\"\n\n";
	  print $buf . "\n";
	} $DownCount++;
}

;####################################################
;################  G[֘A   #################
;#################################################### 

sub ManageError
{	my ($eNo, $eMsg) = @_;
	my @error_msg = undef;
	$error_msg[0]  = "Ǘ[hw肪s̈׃y[WJ܂B";
	$error_msg[1]  = "s$eMsgւ̃`FbN܂B";
	$error_msg[2]  = "폜wt@C͖悤łB";
	$error_msg[3]  = $eMsg . "͏IĂ悤łB";
	$error_msg[4]  = $eMsg . "͏rłB<br>[ R.XV ] or [ U.ɖ߂ ]sĉB";
	$error_msg[5]  = "t@CɎs܂B<br>($eMsg)";
	$error_msg[6]  = "Abvꂽt@C͑ΏۂƂȂt@Cł͂Ȃ悤łB";
	$error_msg[7]  = "ݕύXrłB ݂̏ [ R.XV ] or [ D. ] ɂďIĉB";
	$error_msg[8]  = "$eMsgf[^[ɐݒ~X悤łB";
	$error_msg[9]  = "ύXIĂ悤łB";
	$error_msg[10]  = "L[w肵ĉB";
	$error_msg[11]  = "IDwɊԈႢ悤łB";
	$error_msg[12]  = "wID[U[͂Ȃ悤łB";
	$error_msg[13]  = "ID݂Ȃ悤łB";
	$error_msg[15]  = "ALLNAꍇ܂̂ł̃y[WړĉB";
	$error_msg[16]  = "$eMsgf[^(Œ̕K)̂悤łB";
	$error_msg[17]  = "Abvt@C̃t@C܂B";
	$error_msg[18]  = "Abvt@C̃t@CƓI[_[t@C܂B";
	my $mem = $CGI->{'odis'} =~ /^D\./ ? '' : 'L' if $eNo == 20;
	$error_msg[20]  = "ID:$eMsg G[...Ă邩$memł͂Ȃ悤łB";
	$error_msg[21]  = "ID:$eMsg G[...Ă邩IDȂ悤łB";
	$error_msg[22]  = "IDȂĂ悤łB";
	$error_msg[25]  = "S폜Ɏs܂B($eMsg)";
	$error_msg[30]  = "w肳ꂽ[ $UIDC ] ͂łɊǗo^Ă܂B";
	$error_msg[31]  = "$eMsg̎w肪ԈĂ悤łB";
	$error_msg[32]  = "[ݒ肷邩A[֘Aݒ𖳌ɂĉB";
	if( $eNo == 33 )
	{ my @u = split(/\,/, $eMsg);
	  my $mail = 'ǗID [ ' . $MANAG_HEDID . $u[1] . ' ]' . (!$u[0] ? 'Mp' : 'G[\');
	  $error_msg[33]  = "$mail[ݒ肪d܂B"; }
	$error_msg[35]  = "Ǘ$eMsgɎs܂B";
	$error_msg[39]  = "ǗID݂Ȃ悤łB 폜o܂łB";
	$error_msg[40]  = "ǗID͍폜o܂B";
	$error_msg[45]  = $eMsg . "Ƀ`FbN܂B";
	$error_msg[49]  = "Abvt@CTCYIIo[ɂăAbv𒆎~܂B";
	$error_msg[50]  = "t@CAbvɎs܂B AbvoLt@Cł͂Ȃ悤łB";
	$error_msg[51]  = "[ $eMsg ] fBNg[쐬ɎsĂ悤łB";
	$error_msg[52]  = "[ $eMsg ] i[fBNg[Ȃ悤łB";
	$error_msg[55]  = "ݓo^rłB ݂̏ [ R.XV ] or [ D. ] ɂďIĉB";
	$error_msg[56]  = "$eMsgo^Ă悤łB";
	$error_msg[57]  = "" . ($DIS == 1 ? 'if[^[' : undef) . "t@C݂Ă܂Bt@CύXĉB";
	$error_msg[58]  = "if[^[t@C͔pp20ȓłw艺B";
	$error_msg[59]  = ($DIS == 1 ? 'if[^[' : 't@C') . "$eMsgɎst@C܂B";
	$error_msg[60]  = "ړɓt@Cړ𒆎~܂B";
	$error_msg[61]  = ($eMsg eq 'New' ? 'o^' : 'ύX') . "鏤if[^[悤łB" . 
					($eMsg eq 'New' ? ' ɏif[^[o^ĉB' : undef);
	$error_msg[62]  = ($DIS == 1 ? 'i' : 't@C') . "ړɎs܂B";
	$error_msg[63]  = "ړɓt@Cړ𒆎~t@C܂B";
	$error_msg[64]  = "w肳ꂽ܂ރt@CɂĎsĉB";
	$error_msg[100]  = "VXeG[܂B($eMsg)"; \$error_msg[$eNo];
}

1;

